/*
 * CSE1_Oculus_gesture.c
 *
 * Code generation for model "CSE1_Oculus_gesture".
 *
 * Model version              : 1.30
 * Simulink Coder version : 8.6 (R2014a) 27-Dec-2013
 * C source code generated on : Thu Apr 23 10:29:55 2015
 *
 * Target selection: NIVeriStand_VxWorks.tlc
 * Note: GRT includes extra infrastructure and instrumentation for prototyping
 * Embedded hardware selection: 32-bit Generic
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */
#include "CSE1_Oculus_gesture.h"
#include "CSE1_Oculus_gesture_private.h"

/* Block signals (auto storage) */
B_CSE1_Oculus_gesture_T CSE1_Oculus_gesture_B;

/* Continuous states */
X_CSE1_Oculus_gesture_T CSE1_Oculus_gesture_X;

/* Block states (auto storage) */
DW_CSE1_Oculus_gesture_T CSE1_Oculus_gesture_DW;

/* Previous zero-crossings (trigger) states */
PrevZCX_CSE1_Oculus_gesture_T CSE1_Oculus_gesture_PrevZCX;

/* Real-time model */
RT_MODEL_CSE1_Oculus_gesture_T CSE1_Oculus_gesture_M_;
RT_MODEL_CSE1_Oculus_gesture_T *const CSE1_Oculus_gesture_M =
  &CSE1_Oculus_gesture_M_;

/* Forward declaration for local functions */
static void CSE1_Oculus_gesture_mldivide(const real_T A[9], const real_T B[3],
  real_T Y[3]);

/*
 * Writes out MAT-file header.  Returns success or failure.
 * Returns:
 *      0 - success
 *      1 - failure
 */
int_T rt_WriteMat4FileHeader(FILE *fp, int32_T m, int32_T n, const char *name)
{
  typedef enum { ELITTLE_ENDIAN, EBIG_ENDIAN } ByteOrder;

  int16_T one = 1;
  ByteOrder byteOrder = (*((int8_T *)&one)==1) ? ELITTLE_ENDIAN : EBIG_ENDIAN;
  int32_T type = (byteOrder == ELITTLE_ENDIAN) ? 0: 1000;
  int32_T imagf = 0;
  int32_T name_len = (int32_T)strlen(name) + 1;
  if ((fwrite(&type, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(&m, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(&n, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(&imagf, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(&name_len, sizeof(int32_T), 1, fp) == 0) ||
      (fwrite(name, sizeof(char), name_len, fp) == 0)) {
    return(1);
  } else {
    return(0);
  }
}                                      /* end rt_WriteMat4FileHeader */

/*
 * This function updates continuous states using the ODE4 fixed-step
 * solver algorithm
 */
static void rt_ertODEUpdateContinuousStates(RTWSolverInfo *si )
{
  time_T t = rtsiGetT(si);
  time_T tnew = rtsiGetSolverStopTime(si);
  time_T h = rtsiGetStepSize(si);
  real_T *x = rtsiGetContStates(si);
  ODE4_IntgData *id = (ODE4_IntgData *)rtsiGetSolverData(si);
  real_T *y = id->y;
  real_T *f0 = id->f[0];
  real_T *f1 = id->f[1];
  real_T *f2 = id->f[2];
  real_T *f3 = id->f[3];
  real_T temp;
  int_T i;
  int_T nXc = 24;
  rtsiSetSimTimeStep(si,MINOR_TIME_STEP);

  /* Save the state values at time t in y, we'll use x as ynew. */
  (void) memcpy(y, x,
                (uint_T)nXc*sizeof(real_T));

  /* Assumes that rtsiSetT and ModelOutputs are up-to-date */
  /* f0 = f(t,y) */
  rtsiSetdX(si, f0);
  CSE1_Oculus_gesture_derivatives();

  /* f1 = f(t + (h/2), y + (h/2)*f0) */
  temp = 0.5 * h;
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (temp*f0[i]);
  }

  rtsiSetT(si, t + temp);
  rtsiSetdX(si, f1);
  CSE1_Oculus_gesture_output();
  CSE1_Oculus_gesture_derivatives();

  /* f2 = f(t + (h/2), y + (h/2)*f1) */
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (temp*f1[i]);
  }

  rtsiSetdX(si, f2);
  CSE1_Oculus_gesture_output();
  CSE1_Oculus_gesture_derivatives();

  /* f3 = f(t + h, y + h*f2) */
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + (h*f2[i]);
  }

  rtsiSetT(si, tnew);
  rtsiSetdX(si, f3);
  CSE1_Oculus_gesture_output();
  CSE1_Oculus_gesture_derivatives();

  /* tnew = t + h
     ynew = y + (h/6)*(f0 + 2*f1 + 2*f2 + 2*f3) */
  temp = h / 6.0;
  for (i = 0; i < nXc; i++) {
    x[i] = y[i] + temp*(f0[i] + 2.0*f1[i] + 2.0*f2[i] + f3[i]);
  }

  rtsiSetSimTimeStep(si,MAJOR_TIME_STEP);
}

/*
 * Output and update for atomic system:
 *    '<S14>/w_d*w_d'
 *    '<S18>/w_d*w_d'
 */
void CSE1_Oculus_gesture_w_dw_d(const real_T rtu_w_d[9],
  B_w_dw_d_CSE1_Oculus_gesture_T *localB)
{
  int32_T i;
  int32_T i_0;

  /* MATLAB Function 'Guidance/Reference model/w_d*w_d': '<S21>:1' */
  /* '<S21>:1:4' */
  for (i = 0; i < 3; i++) {
    for (i_0 = 0; i_0 < 3; i_0++) {
      localB->y[i + 3 * i_0] = 0.0;
      localB->y[i + 3 * i_0] += rtu_w_d[3 * i_0] * rtu_w_d[i];
      localB->y[i + 3 * i_0] += rtu_w_d[3 * i_0 + 1] * rtu_w_d[i + 3];
      localB->y[i + 3 * i_0] += rtu_w_d[3 * i_0 + 2] * rtu_w_d[i + 6];
    }
  }
}

/*
 * Output and update for atomic system:
 *    '<S14>/w_d*w_d1'
 *    '<S18>/w_d*w_d1'
 */
void CSE1_Oculus_gesture_w_dw_d1(const real_T rtu_w_d[9], const real_T rtu_zeta
  [9], B_w_dw_d1_CSE1_Oculus_gesture_T *localB)
{
  int32_T i;
  int32_T i_0;

  /* MATLAB Function 'Guidance/Reference model/w_d*w_d1': '<S22>:1' */
  /* '<S22>:1:4' */
  for (i = 0; i < 3; i++) {
    for (i_0 = 0; i_0 < 3; i_0++) {
      localB->y[i + 3 * i_0] = 0.0;
      localB->y[i + 3 * i_0] += 2.0 * rtu_zeta[i] * rtu_w_d[3 * i_0];
      localB->y[i + 3 * i_0] += rtu_zeta[i + 3] * 2.0 * rtu_w_d[3 * i_0 + 1];
      localB->y[i + 3 * i_0] += rtu_zeta[i + 6] * 2.0 * rtu_w_d[3 * i_0 + 2];
    }
  }
}

/*
 * Output and update for atomic system:
 *    '<S14>/w_d^-2'
 *    '<S18>/w_d^-2'
 */
void CSE1_Oculus_gesture_w_d2(const real_T rtu_w_d[9],
  B_w_d2_CSE1_Oculus_gesture_T *localB)
{
  real_T y[9];
  real_T x[9];
  int32_T p1;
  int32_T p2;
  int32_T p3;
  real_T absx11;
  real_T absx21;
  real_T absx31;
  int32_T itmp;
  real_T b_y;

  /* MATLAB Function 'Guidance/Reference model/w_d^-2': '<S23>:1' */
  /* '<S23>:1:4' */
  for (p1 = 0; p1 < 3; p1++) {
    for (p2 = 0; p2 < 3; p2++) {
      y[p1 + 3 * p2] = 0.0;
      y[p1 + 3 * p2] += rtu_w_d[3 * p2] * rtu_w_d[p1];
      y[p1 + 3 * p2] += rtu_w_d[3 * p2 + 1] * rtu_w_d[p1 + 3];
      y[p1 + 3 * p2] += rtu_w_d[3 * p2 + 2] * rtu_w_d[p1 + 6];
    }
  }

  memcpy(&x[0], &y[0], 9U * sizeof(real_T));
  p1 = 0;
  p2 = 3;
  p3 = 6;
  absx11 = fabs(y[0]);
  absx21 = fabs(y[1]);
  absx31 = fabs(y[2]);
  if ((absx21 > absx11) && (absx21 > absx31)) {
    p1 = 3;
    p2 = 0;
    x[0] = y[1];
    x[1] = y[0];
    x[3] = y[4];
    x[4] = y[3];
    x[6] = y[7];
    x[7] = y[6];
  } else {
    if (absx31 > absx11) {
      p1 = 6;
      p3 = 0;
      x[0] = y[2];
      x[2] = y[0];
      x[3] = y[5];
      x[5] = y[3];
      x[6] = y[8];
      x[8] = y[6];
    }
  }

  absx11 = x[1] / x[0];
  x[1] /= x[0];
  absx21 = x[2] / x[0];
  x[2] /= x[0];
  x[4] -= absx11 * x[3];
  x[5] -= absx21 * x[3];
  x[7] -= absx11 * x[6];
  x[8] -= absx21 * x[6];
  if (fabs(x[5]) > fabs(x[4])) {
    itmp = p2;
    p2 = p3;
    p3 = itmp;
    x[1] = absx21;
    x[2] = absx11;
    absx11 = x[4];
    x[4] = x[5];
    x[5] = absx11;
    absx11 = x[7];
    x[7] = x[8];
    x[8] = absx11;
  }

  absx31 = x[5];
  b_y = x[4];
  absx11 = x[5] / x[4];
  x[8] -= absx11 * x[7];
  absx11 = (absx11 * x[1] - x[2]) / x[8];
  absx21 = -(x[7] * absx11 + x[1]) / x[4];
  localB->y[p1] = ((1.0 - x[3] * absx21) - x[6] * absx11) / x[0];
  localB->y[p1 + 1] = absx21;
  localB->y[p1 + 2] = absx11;
  absx11 = -(absx31 / b_y) / x[8];
  absx21 = (1.0 - x[7] * absx11) / x[4];
  localB->y[p2] = -(x[3] * absx21 + x[6] * absx11) / x[0];
  localB->y[p2 + 1] = absx21;
  localB->y[p2 + 2] = absx11;
  absx11 = 1.0 / x[8];
  absx21 = -x[7] * absx11 / x[4];
  localB->y[p3] = -(x[3] * absx21 + x[6] * absx11) / x[0];
  localB->y[p3 + 1] = absx21;
  localB->y[p3 + 2] = absx11;
}

/*
 * Output and update for atomic system:
 *    '<S14>/w_d^3'
 *    '<S18>/w_d^3'
 */
void CSE1_Oculus_gesture_w_d3(const real_T rtu_w_d[9],
  B_w_d3_CSE1_Oculus_gesture_T *localB)
{
  real_T a[9];
  real_T e;
  boolean_T firstmult;
  real_T ed2;
  int32_T exitg1;
  int32_T i;
  int32_T i_0;
  real_T a_0[9];

  /* MATLAB Function 'Guidance/Reference model/w_d^3': '<S24>:1' */
  /* '<S24>:1:4' */
  memcpy(&a[0], &rtu_w_d[0], 9U * sizeof(real_T));
  e = 3.0;
  firstmult = true;
  do {
    exitg1 = 0;
    ed2 = floor(e / 2.0);
    if (2.0 * ed2 != e) {
      if (firstmult) {
        memcpy(&localB->y[0], &a[0], 9U * sizeof(real_T));
        firstmult = false;
      } else {
        for (i = 0; i < 3; i++) {
          for (i_0 = 0; i_0 < 3; i_0++) {
            a_0[i + 3 * i_0] = 0.0;
            a_0[i + 3 * i_0] += a[3 * i_0] * localB->y[i];
            a_0[i + 3 * i_0] += a[3 * i_0 + 1] * localB->y[i + 3];
            a_0[i + 3 * i_0] += a[3 * i_0 + 2] * localB->y[i + 6];
          }
        }

        for (i = 0; i < 3; i++) {
          localB->y[3 * i] = a_0[3 * i];
          localB->y[1 + 3 * i] = a_0[3 * i + 1];
          localB->y[2 + 3 * i] = a_0[3 * i + 2];
        }
      }
    }

    if (ed2 == 0.0) {
      exitg1 = 1;
    } else {
      e = ed2;
      for (i = 0; i < 3; i++) {
        for (i_0 = 0; i_0 < 3; i_0++) {
          a_0[i + 3 * i_0] = 0.0;
          a_0[i + 3 * i_0] += a[3 * i_0] * a[i];
          a_0[i + 3 * i_0] += a[3 * i_0 + 1] * a[i + 3];
          a_0[i + 3 * i_0] += a[3 * i_0 + 2] * a[i + 6];
        }
      }

      for (i = 0; i < 3; i++) {
        a[3 * i] = a_0[3 * i];
        a[1 + 3 * i] = a_0[3 * i + 1];
        a[2 + 3 * i] = a_0[3 * i + 2];
      }
    }
  } while (exitg1 == 0);
}

/*
 * Output and update for atomic system:
 *    '<S29>/MATLAB Function'
 *    '<S30>/MATLAB Function4'
 */
void CSE1_Oculus_gest_MATLABFunction(real_T rtu_K_p1, real_T rtu_K_p1_f, real_T
  rtu_K_p1_m, B_MATLABFunction_CSE1_Oculus__T *localB)
{
  /* MATLAB Function 'Input/Control Gains/MATLAB Function': '<S35>:1' */
  /* '<S35>:1:4' */
  memset(&localB->K_p[0], 0, 9U * sizeof(real_T));

  /* SignalConversion: '<S35>/TmpSignal ConversionAt SFunction Inport1' */
  localB->K_p[0] = rtu_K_p1;
  localB->K_p[4] = rtu_K_p1_f;
  localB->K_p[8] = rtu_K_p1_m;
}

/*
 * Output and update for atomic system:
 *    '<S40>/diag'
 *    '<S41>/diag'
 */
void CSE1_Oculus_gesture_diag(real_T rtu_w_d_vector, real_T rtu_w_d_vector_l,
  real_T rtu_w_d_vector_e, B_diag_CSE1_Oculus_gesture_T *localB)
{
  /* MATLAB Function 'Input/Guidance gains/DP guidance/diag': '<S42>:1' */
  /* '<S42>:1:4' */
  memset(&localB->w_d[0], 0, 9U * sizeof(real_T));

  /* SignalConversion: '<S42>/TmpSignal ConversionAt SFunction Inport1' */
  localB->w_d[0] = rtu_w_d_vector;
  localB->w_d[4] = rtu_w_d_vector_l;
  localB->w_d[8] = rtu_w_d_vector_e;
}

/*
 * Output and update for atomic system:
 *    '<S40>/diag1'
 *    '<S41>/diag1'
 */
void CSE1_Oculus_gesture_diag1(real_T rtu_zeta_vector, real_T rtu_zeta_vector_p,
  real_T rtu_zeta_vector_pm, B_diag1_CSE1_Oculus_gesture_T *localB)
{
  /* MATLAB Function 'Input/Guidance gains/DP guidance/diag1': '<S43>:1' */
  /* '<S43>:1:4' */
  memset(&localB->Zeta[0], 0, 9U * sizeof(real_T));

  /* SignalConversion: '<S43>/TmpSignal ConversionAt SFunction Inport1' */
  localB->Zeta[0] = rtu_zeta_vector;
  localB->Zeta[4] = rtu_zeta_vector_p;
  localB->Zeta[8] = rtu_zeta_vector_pm;
}

/*
 * Output and update for atomic system:
 *    '<S5>/diag2vector'
 *    '<S5>/diag2vector1'
 *    '<S5>/diag2vector2'
 *    '<S5>/diag2vector3'
 *    '<S5>/diag2vector4'
 */
void CSE1_Oculus_gesture_diag2vector(const real_T rtu_u[9],
  B_diag2vector_CSE1_Oculus_ges_T *localB)
{
  /* MATLAB Function 'Output/diag2vector': '<S55>:1' */
  /* '<S55>:1:4' */
  localB->y[0] = rtu_u[0];
  localB->y[1] = rtu_u[4];
  localB->y[2] = rtu_u[8];
}

real_T rt_roundd_snf(real_T u)
{
  real_T y;
  if (fabs(u) < 4.503599627370496E+15) {
    if (u >= 0.5) {
      y = floor(u + 0.5);
    } else if (u > -0.5) {
      y = u * 0.0;
    } else {
      y = ceil(u - 0.5);
    }
  } else {
    y = u;
  }

  return y;
}

real_T rt_remd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T u1_0;
  if (!((!rtIsNaN(u0)) && (!rtIsInf(u0)) && ((!rtIsNaN(u1)) && (!rtIsInf(u1)))))
  {
    y = (rtNaN);
  } else {
    if (u1 < 0.0) {
      u1_0 = ceil(u1);
    } else {
      u1_0 = floor(u1);
    }

    if ((u1 != 0.0) && (u1 != u1_0)) {
      u1_0 = u0 / u1;
      if (fabs(u1_0 - rt_roundd_snf(u1_0)) <= DBL_EPSILON * fabs(u1_0)) {
        y = 0.0;
      } else {
        y = fmod(u0, u1);
      }
    } else {
      y = fmod(u0, u1);
    }
  }

  return y;
}

/* Function for MATLAB Function: '<S6>/Thrust allocation' */
static void CSE1_Oculus_gesture_mldivide(const real_T A[9], const real_T B[3],
  real_T Y[3])
{
  real_T b_A[9];
  int32_T r1;
  int32_T r2;
  int32_T r3;
  real_T maxval;
  real_T a21;
  int32_T rtemp;
  memcpy(&b_A[0], &A[0], 9U * sizeof(real_T));
  r1 = 0;
  r2 = 1;
  r3 = 2;
  maxval = fabs(A[0]);
  a21 = fabs(A[1]);
  if (a21 > maxval) {
    maxval = a21;
    r1 = 1;
    r2 = 0;
  }

  if (fabs(A[2]) > maxval) {
    r1 = 2;
    r2 = 1;
    r3 = 0;
  }

  b_A[r2] = A[r2] / A[r1];
  b_A[r3] /= b_A[r1];
  b_A[3 + r2] -= b_A[3 + r1] * b_A[r2];
  b_A[3 + r3] -= b_A[3 + r1] * b_A[r3];
  b_A[6 + r2] -= b_A[6 + r1] * b_A[r2];
  b_A[6 + r3] -= b_A[6 + r1] * b_A[r3];
  if (fabs(b_A[3 + r3]) > fabs(b_A[3 + r2])) {
    rtemp = r2;
    r2 = r3;
    r3 = rtemp;
  }

  b_A[3 + r3] /= b_A[3 + r2];
  b_A[6 + r3] -= b_A[3 + r3] * b_A[6 + r2];
  Y[1] = B[r2] - B[r1] * b_A[r2];
  Y[2] = (B[r3] - B[r1] * b_A[r3]) - b_A[3 + r3] * Y[1];
  Y[2] /= b_A[6 + r3];
  Y[0] = B[r1] - b_A[6 + r1] * Y[2];
  Y[1] -= b_A[6 + r2] * Y[2];
  Y[1] /= b_A[3 + r2];
  Y[0] -= b_A[3 + r1] * Y[1];
  Y[0] /= b_A[r1];
}

real_T rt_atan2d_snf(real_T u0, real_T u1)
{
  real_T y;
  int32_T u0_0;
  int32_T u1_0;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = (rtNaN);
  } else if (rtIsInf(u0) && rtIsInf(u1)) {
    if (u0 > 0.0) {
      u0_0 = 1;
    } else {
      u0_0 = -1;
    }

    if (u1 > 0.0) {
      u1_0 = 1;
    } else {
      u1_0 = -1;
    }

    y = atan2(u0_0, u1_0);
  } else if (u1 == 0.0) {
    if (u0 > 0.0) {
      y = RT_PI / 2.0;
    } else if (u0 < 0.0) {
      y = -(RT_PI / 2.0);
    } else {
      y = 0.0;
    }
  } else {
    y = atan2(u0, u1);
  }

  return y;
}

/* Model output function */
void CSE1_Oculus_gesture_output(void)
{
  /* local block i/o variables */
  real_T rtb_Integrator[3];
  real_T rtb_Integrator1[3];
  real_T rtb_K_d[9];
  real_T rtb_K_i[9];
  real_T rtb_Integrator2[3];
  real_T rtb_MatrixMultiply2[3];
  real_T rtb_TmpSignalConversionAtToFile[15];
  real_T rtb_TmpSignalConversionAtetaInp[3];
  real_T signal;
  static const real_T b[9] = { 1.165, 0.0, 0.0, 0.0, 1.165, 0.0, 0.0, 0.0, 2.629
  };

  static const real_T c[9] = { 1.0, 0.0, 0.0, 0.0, 1.0, -0.4575, 0.0, 1.0,
    0.3875 };

  real_T rtb_Row2;
  real_T rtb_Gain_c;
  real_T rtb_TmpSignalConversionAtSFun_i[3];
  int32_T i;
  real_T tmp[3];
  real_T tmp_0[3];
  real_T tmp_1[9];
  real_T rtb_MultiportSwitch_idx_0;
  real_T rtb_MultiportSwitch_idx_3;
  real_T rtb_MultiportSwitch_idx_4;
  real_T rtb_MultiportSwitch_idx_6;
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* set solver stop time */
    if (!(CSE1_Oculus_gesture_M->Timing.clockTick0+1)) {
      rtsiSetSolverStopTime(&CSE1_Oculus_gesture_M->solverInfo,
                            ((CSE1_Oculus_gesture_M->Timing.clockTickH0 + 1) *
        CSE1_Oculus_gesture_M->Timing.stepSize0 * 4294967296.0));
    } else {
      rtsiSetSolverStopTime(&CSE1_Oculus_gesture_M->solverInfo,
                            ((CSE1_Oculus_gesture_M->Timing.clockTick0 + 1) *
        CSE1_Oculus_gesture_M->Timing.stepSize0 +
        CSE1_Oculus_gesture_M->Timing.clockTickH0 *
        CSE1_Oculus_gesture_M->Timing.stepSize0 * 4294967296.0));
    }
  }                                    /* end MajorTimeStep */

  /* Update absolute time of base rate at minor time step */
  if (rtmIsMinorTimeStep(CSE1_Oculus_gesture_M)) {
    CSE1_Oculus_gesture_M->Timing.t[0] = rtsiGetT
      (&CSE1_Oculus_gesture_M->solverInfo);
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* Memory: '<S62>/Memory' */
    CSE1_Oculus_gesture_B.Memory = CSE1_Oculus_gesture_DW.Memory_PreviousInput;
  }

  /* MATLAB Function: '<S62>/Switch_function' */
  /* MATLAB Function 'ctrl_out/Switch_subsystem/Switch_function': '<S69>:1' */
  /* % Function that takes in impulse button sigals [0,1] and sends out a  */
  /*  different signal depentent pn which button has been pressed */
  /* '<S69>:1:8' */
  signal = CSE1_Oculus_gesture_B.Memory;
  if (CSE1_Oculus_gesture_B.Cross != 0.0) {
    /* '<S69>:1:10' */
    /* '<S69>:1:11' */
    signal = 1.0;
  }

  if (CSE1_Oculus_gesture_B.Square != 0.0) {
    /* '<S69>:1:14' */
    /* '<S69>:1:15' */
    signal = 2.0;
  }

  if (CSE1_Oculus_gesture_B.Circle != 0.0) {
    /* '<S69>:1:18' */
    /* '<S69>:1:19' */
    signal = 3.0;
  }

  if (CSE1_Oculus_gesture_B.Triangle != 0.0) {
    /* '<S69>:1:22' */
    /* '<S69>:1:23' */
    signal = 4.0;
  }

  /* '<S69>:1:26' */
  CSE1_Oculus_gesture_B.switch_signal = signal;

  /* End of MATLAB Function: '<S62>/Switch_function' */

  /* MATLAB Function: '<S29>/MATLAB Function' */
  CSE1_Oculus_gest_MATLABFunction(CSE1_Oculus_gesture_B.K_p_x,
    CSE1_Oculus_gesture_B.K_p_y, CSE1_Oculus_gesture_B.K_p_psi,
    &CSE1_Oculus_gesture_B.sf_MATLABFunction);

  /* Saturate: '<S34>/Saturation' */
  if (CSE1_Oculus_gesture_B.psi > CSE1_Oculus_gesture_P.Saturation_UpperSat) {
    signal = CSE1_Oculus_gesture_P.Saturation_UpperSat;
  } else if (CSE1_Oculus_gesture_B.psi <
             CSE1_Oculus_gesture_P.Saturation_LowerSat) {
    signal = CSE1_Oculus_gesture_P.Saturation_LowerSat;
  } else {
    signal = CSE1_Oculus_gesture_B.psi;
  }

  /* End of Saturate: '<S34>/Saturation' */

  /* Signum: '<S34>/Sign' */
  if (signal < 0.0) {
    rtb_MultiportSwitch_idx_0 = -1.0;
  } else if (signal > 0.0) {
    rtb_MultiportSwitch_idx_0 = 1.0;
  } else if (signal == 0.0) {
    rtb_MultiportSwitch_idx_0 = 0.0;
  } else {
    rtb_MultiportSwitch_idx_0 = signal;
  }

  /* Gain: '<S34>/Gain' incorporates:
   *  Signum: '<S34>/Sign'
   */
  rtb_Row2 = CSE1_Oculus_gesture_P.Gain_Gain * rtb_MultiportSwitch_idx_0;

  /* Sum: '<S34>/Sum1' */
  signal += rtb_Row2;

  /* Math: '<S34>/Math Function' incorporates:
   *  Constant: '<S34>/Constant'
   */
  signal = rt_remd_snf(signal, CSE1_Oculus_gesture_P.Constant_Value);

  /* Sum: '<S34>/Sum' */
  CSE1_Oculus_gesture_B.Sum = signal - rtb_Row2;

  /* MATLAB Function 'Input/Control Gains/MATLAB Function1': '<S36>:1' */
  /* '<S36>:1:4' */
  for (i = 0; i < 9; i++) {
    /* MATLAB Function: '<S29>/MATLAB Function1' */
    rtb_K_i[i] = 0.0;

    /* MATLAB Function: '<S29>/MATLAB Function2' */
    rtb_K_d[i] = 0.0;
  }

  /* MATLAB Function: '<S29>/MATLAB Function1' incorporates:
   *  SignalConversion: '<S36>/TmpSignal ConversionAt SFunction Inport1'
   */
  rtb_K_i[0] = CSE1_Oculus_gesture_B.K_i_x;
  rtb_K_i[4] = CSE1_Oculus_gesture_B.K_i_y;
  rtb_K_i[8] = CSE1_Oculus_gesture_B.K_i_psi;

  /* MATLAB Function: '<S29>/MATLAB Function2' incorporates:
   *  SignalConversion: '<S37>/TmpSignal ConversionAt SFunction Inport1'
   */
  /* MATLAB Function 'Input/Control Gains/MATLAB Function2': '<S37>:1' */
  /* '<S37>:1:4' */
  rtb_K_d[0] = CSE1_Oculus_gesture_B.K_d_x;
  rtb_K_d[4] = CSE1_Oculus_gesture_B.K_d_y;
  rtb_K_d[8] = CSE1_Oculus_gesture_B.K_d_psi;
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
  }

  /* MATLAB Function: '<S40>/diag' */
  CSE1_Oculus_gesture_diag(CSE1_Oculus_gesture_B.w_d_x,
    CSE1_Oculus_gesture_B.w_d_y, CSE1_Oculus_gesture_B.w_d_psi,
    &CSE1_Oculus_gesture_B.sf_diag);

  /* Gain: '<S33>/Gain3' */
  CSE1_Oculus_gesture_B.Gain3 = CSE1_Oculus_gesture_P.Gain3_Gain *
    CSE1_Oculus_gesture_B.Oculus_yaw;

  /* MATLAB Function: '<S40>/diag1' */
  CSE1_Oculus_gesture_diag1(CSE1_Oculus_gesture_B.zeta_x,
    CSE1_Oculus_gesture_B.zeta_y, CSE1_Oculus_gesture_B.zeta_psi,
    &CSE1_Oculus_gesture_B.sf_diag1);

  /* MATLAB Function: '<S41>/diag' */
  CSE1_Oculus_gesture_diag(CSE1_Oculus_gesture_B.w_d_x_l,
    CSE1_Oculus_gesture_B.w_d_y_c, CSE1_Oculus_gesture_B.w_d_psi_d,
    &CSE1_Oculus_gesture_B.sf_diag_j);

  /* MATLAB Function: '<S30>/MATLAB Function4' */
  CSE1_Oculus_gest_MATLABFunction(CSE1_Oculus_gesture_B.K_u,
    CSE1_Oculus_gesture_B.K_v, CSE1_Oculus_gesture_B.K_r,
    &CSE1_Oculus_gesture_B.sf_MATLABFunction4);

  /* Gain: '<S33>/Gain1' */
  CSE1_Oculus_gesture_B.Gain1 = CSE1_Oculus_gesture_P.Gain1_Gain *
    CSE1_Oculus_gesture_B.Oculus_roll;

  /* Saturate: '<S12>/Saturation' incorporates:
   *  Fcn: '<S8>/yaw angle'
   */
  if (CSE1_Oculus_gesture_B.Sum > CSE1_Oculus_gesture_P.Saturation_UpperSat_d) {
    rtb_Row2 = CSE1_Oculus_gesture_P.Saturation_UpperSat_d;
  } else if (CSE1_Oculus_gesture_B.Sum <
             CSE1_Oculus_gesture_P.Saturation_LowerSat_l) {
    rtb_Row2 = CSE1_Oculus_gesture_P.Saturation_LowerSat_l;
  } else {
    rtb_Row2 = CSE1_Oculus_gesture_B.Sum;
  }

  /* End of Saturate: '<S12>/Saturation' */

  /* Signum: '<S12>/Sign' */
  if (rtb_Row2 < 0.0) {
    rtb_MultiportSwitch_idx_0 = -1.0;
  } else if (rtb_Row2 > 0.0) {
    rtb_MultiportSwitch_idx_0 = 1.0;
  } else if (rtb_Row2 == 0.0) {
    rtb_MultiportSwitch_idx_0 = 0.0;
  } else {
    rtb_MultiportSwitch_idx_0 = rtb_Row2;
  }

  /* Gain: '<S12>/Gain' incorporates:
   *  Signum: '<S12>/Sign'
   */
  signal = CSE1_Oculus_gesture_P.Gain_Gain_n * rtb_MultiportSwitch_idx_0;

  /* Sum: '<S12>/Sum1' */
  rtb_Row2 += signal;

  /* Math: '<S12>/Math Function' incorporates:
   *  Constant: '<S12>/Constant'
   */
  rtb_Row2 = rt_remd_snf(rtb_Row2, CSE1_Oculus_gesture_P.Constant_Value_d);

  /* Sum: '<S12>/Sum' */
  rtb_Row2 -= signal;

  /* Saturate: '<S19>/Saturation' incorporates:
   *  Fcn: '<S2>/yaw angle'
   */
  if (CSE1_Oculus_gesture_B.Sum > CSE1_Oculus_gesture_P.Saturation_UpperSat_dc)
  {
    signal = CSE1_Oculus_gesture_P.Saturation_UpperSat_dc;
  } else if (CSE1_Oculus_gesture_B.Sum <
             CSE1_Oculus_gesture_P.Saturation_LowerSat_e) {
    signal = CSE1_Oculus_gesture_P.Saturation_LowerSat_e;
  } else {
    signal = CSE1_Oculus_gesture_B.Sum;
  }

  /* End of Saturate: '<S19>/Saturation' */

  /* Signum: '<S19>/Sign' */
  if (signal < 0.0) {
    rtb_MultiportSwitch_idx_0 = -1.0;
  } else if (signal > 0.0) {
    rtb_MultiportSwitch_idx_0 = 1.0;
  } else if (signal == 0.0) {
    rtb_MultiportSwitch_idx_0 = 0.0;
  } else {
    rtb_MultiportSwitch_idx_0 = signal;
  }

  /* Gain: '<S19>/Gain' incorporates:
   *  Signum: '<S19>/Sign'
   */
  rtb_Gain_c = CSE1_Oculus_gesture_P.Gain_Gain_e * rtb_MultiportSwitch_idx_0;

  /* Sum: '<S19>/Sum1' */
  signal += rtb_Gain_c;

  /* Math: '<S19>/Math Function' incorporates:
   *  Constant: '<S19>/Constant'
   */
  signal = rt_remd_snf(signal, CSE1_Oculus_gesture_P.Constant_Value_j);

  /* Sum: '<S19>/Sum' */
  signal -= rtb_Gain_c;

  /* Fcn: '<S17>/Row1' */
  CSE1_Oculus_gesture_B.Row1 = cos(signal) * CSE1_Oculus_gesture_B.x + sin
    (signal) * CSE1_Oculus_gesture_B.y;

  /* Fcn: '<S17>/Row2' */
  CSE1_Oculus_gesture_B.Row2 = -sin(signal) * CSE1_Oculus_gesture_B.x + cos
    (signal) * CSE1_Oculus_gesture_B.y;

  /* Fcn: '<S17>/Row3' */
  CSE1_Oculus_gesture_B.Row3 = CSE1_Oculus_gesture_B.Sum;

  /* Integrator: '<S2>/Integrator' */
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                       &CSE1_Oculus_gesture_PrevZCX.Integrator_Reset_ZCE,
                       CSE1_Oculus_gesture_B.reset);

    /* evaluate zero-crossings */
    if (zcEvent || CSE1_Oculus_gesture_DW.Integrator_IWORK.IcNeedsLoading) {
      CSE1_Oculus_gesture_X.Integrator_CSTATE[0] = CSE1_Oculus_gesture_B.Row1;
      CSE1_Oculus_gesture_X.Integrator_CSTATE[1] = CSE1_Oculus_gesture_B.Row2;
      CSE1_Oculus_gesture_X.Integrator_CSTATE[2] = CSE1_Oculus_gesture_B.Row3;
    }
  }

  rtb_Integrator[0] = CSE1_Oculus_gesture_X.Integrator_CSTATE[0];
  rtb_Integrator[1] = CSE1_Oculus_gesture_X.Integrator_CSTATE[1];
  rtb_Integrator[2] = CSE1_Oculus_gesture_X.Integrator_CSTATE[2];

  /* Integrator: '<S18>/Integrator1' */
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                       &CSE1_Oculus_gesture_PrevZCX.Integrator1_Reset_ZCE,
                       CSE1_Oculus_gesture_B.reset);

    /* evaluate zero-crossings */
    if (zcEvent) {
      CSE1_Oculus_gesture_X.Integrator1_CSTATE[0] =
        CSE1_Oculus_gesture_P.Integrator1_IC;
      CSE1_Oculus_gesture_X.Integrator1_CSTATE[1] =
        CSE1_Oculus_gesture_P.Integrator1_IC;
      CSE1_Oculus_gesture_X.Integrator1_CSTATE[2] =
        CSE1_Oculus_gesture_P.Integrator1_IC;
    }
  }

  CSE1_Oculus_gesture_B.Integrator1[0] =
    CSE1_Oculus_gesture_X.Integrator1_CSTATE[0];
  CSE1_Oculus_gesture_B.Integrator1[1] =
    CSE1_Oculus_gesture_X.Integrator1_CSTATE[1];
  CSE1_Oculus_gesture_B.Integrator1[2] =
    CSE1_Oculus_gesture_X.Integrator1_CSTATE[2];

  /* Integrator: '<S14>/Integrator1' */
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                       &CSE1_Oculus_gesture_PrevZCX.Integrator1_Reset_ZCE_g,
                       CSE1_Oculus_gesture_B.reset);

    /* evaluate zero-crossings */
    if (zcEvent || CSE1_Oculus_gesture_DW.Integrator1_IWORK.IcNeedsLoading) {
      CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[0] = CSE1_Oculus_gesture_B.x;
      CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[1] = CSE1_Oculus_gesture_B.y;
      CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[2] = CSE1_Oculus_gesture_B.Sum;
    }
  }

  rtb_Integrator1[0] = CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[0];
  rtb_Integrator1[1] = CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[1];
  rtb_Integrator1[2] = CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[2];

  /* Integrator: '<S14>/Integrator3' */
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                       &CSE1_Oculus_gesture_PrevZCX.Integrator3_Reset_ZCE,
                       CSE1_Oculus_gesture_B.reset);

    /* evaluate zero-crossings */
    if (zcEvent) {
      CSE1_Oculus_gesture_X.Integrator3_CSTATE[0] =
        CSE1_Oculus_gesture_P.Integrator3_IC;
      CSE1_Oculus_gesture_X.Integrator3_CSTATE[1] =
        CSE1_Oculus_gesture_P.Integrator3_IC;
      CSE1_Oculus_gesture_X.Integrator3_CSTATE[2] =
        CSE1_Oculus_gesture_P.Integrator3_IC;
    }
  }

  CSE1_Oculus_gesture_B.Integrator3[0] =
    CSE1_Oculus_gesture_X.Integrator3_CSTATE[0];
  CSE1_Oculus_gesture_B.Integrator3[1] =
    CSE1_Oculus_gesture_X.Integrator3_CSTATE[1];
  CSE1_Oculus_gesture_B.Integrator3[2] =
    CSE1_Oculus_gesture_X.Integrator3_CSTATE[2];

  /* MultiPortSwitch: '<S2>/Multiport Switch' incorporates:
   *  Fcn: '<S15>/Fcn'
   *  Fcn: '<S15>/Fcn1'
   *  Fcn: '<S15>/Fcn2'
   *  Fcn: '<S16>/Fcn'
   *  Fcn: '<S16>/Fcn1'
   *  Fcn: '<S16>/Fcn2'
   *  Fcn: '<S2>/Fcn'
   */
  if ((int32_T)CSE1_Oculus_gesture_B.Gesture_off == 0) {
    CSE1_Oculus_gesture_B.MultiportSwitch[0] = cos(rtb_Integrator[2]) *
      rtb_Integrator[0] - sin(rtb_Integrator[2]) * rtb_Integrator[1];
    CSE1_Oculus_gesture_B.MultiportSwitch[1] = sin(rtb_Integrator[2]) *
      rtb_Integrator[0] + cos(rtb_Integrator[2]) * rtb_Integrator[1];
    CSE1_Oculus_gesture_B.MultiportSwitch[2] = rtb_Integrator[2];
    CSE1_Oculus_gesture_B.MultiportSwitch[3] = cos(rtb_Integrator[2]) *
      CSE1_Oculus_gesture_B.Integrator1[0] - sin(rtb_Integrator[2]) *
      CSE1_Oculus_gesture_B.Integrator1[1];
    CSE1_Oculus_gesture_B.MultiportSwitch[4] = sin(rtb_Integrator[2]) *
      CSE1_Oculus_gesture_B.Integrator1[0] + cos(rtb_Integrator[2]) *
      CSE1_Oculus_gesture_B.Integrator1[1];
    CSE1_Oculus_gesture_B.MultiportSwitch[5] =
      CSE1_Oculus_gesture_B.Integrator1[2];
  } else {
    CSE1_Oculus_gesture_B.MultiportSwitch[0] = rtb_Integrator1[0];
    CSE1_Oculus_gesture_B.MultiportSwitch[1] = rtb_Integrator1[1];
    CSE1_Oculus_gesture_B.MultiportSwitch[2] = rtb_Integrator1[2];
    CSE1_Oculus_gesture_B.MultiportSwitch[3] =
      CSE1_Oculus_gesture_B.Integrator3[0];
    CSE1_Oculus_gesture_B.MultiportSwitch[4] =
      CSE1_Oculus_gesture_B.Integrator3[1];
    CSE1_Oculus_gesture_B.MultiportSwitch[5] =
      CSE1_Oculus_gesture_B.Integrator3[2];
  }

  /* End of MultiPortSwitch: '<S2>/Multiport Switch' */

  /* Saturate: '<S20>/Saturation' */
  if (CSE1_Oculus_gesture_B.MultiportSwitch[2] >
      CSE1_Oculus_gesture_P.Saturation_UpperSat_c) {
    rtb_Gain_c = CSE1_Oculus_gesture_P.Saturation_UpperSat_c;
  } else if (CSE1_Oculus_gesture_B.MultiportSwitch[2] <
             CSE1_Oculus_gesture_P.Saturation_LowerSat_n) {
    rtb_Gain_c = CSE1_Oculus_gesture_P.Saturation_LowerSat_n;
  } else {
    rtb_Gain_c = CSE1_Oculus_gesture_B.MultiportSwitch[2];
  }

  /* End of Saturate: '<S20>/Saturation' */

  /* Signum: '<S20>/Sign' */
  if (rtb_Gain_c < 0.0) {
    rtb_MultiportSwitch_idx_0 = -1.0;
  } else if (rtb_Gain_c > 0.0) {
    rtb_MultiportSwitch_idx_0 = 1.0;
  } else if (rtb_Gain_c == 0.0) {
    rtb_MultiportSwitch_idx_0 = 0.0;
  } else {
    rtb_MultiportSwitch_idx_0 = rtb_Gain_c;
  }

  /* Gain: '<S20>/Gain' incorporates:
   *  Signum: '<S20>/Sign'
   */
  signal = CSE1_Oculus_gesture_P.Gain_Gain_l * rtb_MultiportSwitch_idx_0;

  /* Sum: '<S20>/Sum1' */
  rtb_Gain_c += signal;

  /* Math: '<S20>/Math Function' incorporates:
   *  Constant: '<S20>/Constant'
   */
  rtb_Gain_c = rt_remd_snf(rtb_Gain_c, CSE1_Oculus_gesture_P.Constant_Value_e);

  /* Sum: '<S20>/Sum' */
  CSE1_Oculus_gesture_B.Sum_p = rtb_Gain_c - signal;

  /* Sum: '<S8>/Sum2' */
  rtb_TmpSignalConversionAtSFun_i[0] = CSE1_Oculus_gesture_B.MultiportSwitch[0]
    - CSE1_Oculus_gesture_B.x;
  rtb_TmpSignalConversionAtSFun_i[1] = CSE1_Oculus_gesture_B.MultiportSwitch[1]
    - CSE1_Oculus_gesture_B.y;
  rtb_TmpSignalConversionAtSFun_i[2] = CSE1_Oculus_gesture_B.Sum_p -
    CSE1_Oculus_gesture_B.Sum;

  /* Saturate: '<S11>/Saturation' */
  if (rtb_TmpSignalConversionAtSFun_i[2] >
      CSE1_Oculus_gesture_P.Saturation_UpperSat_g) {
    rtb_Gain_c = CSE1_Oculus_gesture_P.Saturation_UpperSat_g;
  } else if (rtb_TmpSignalConversionAtSFun_i[2] <
             CSE1_Oculus_gesture_P.Saturation_LowerSat_et) {
    rtb_Gain_c = CSE1_Oculus_gesture_P.Saturation_LowerSat_et;
  } else {
    rtb_Gain_c = rtb_TmpSignalConversionAtSFun_i[2];
  }

  /* End of Saturate: '<S11>/Saturation' */

  /* Signum: '<S11>/Sign' */
  if (rtb_Gain_c < 0.0) {
    rtb_MultiportSwitch_idx_0 = -1.0;
  } else if (rtb_Gain_c > 0.0) {
    rtb_MultiportSwitch_idx_0 = 1.0;
  } else if (rtb_Gain_c == 0.0) {
    rtb_MultiportSwitch_idx_0 = 0.0;
  } else {
    rtb_MultiportSwitch_idx_0 = rtb_Gain_c;
  }

  /* Gain: '<S11>/Gain' incorporates:
   *  Signum: '<S11>/Sign'
   */
  signal = CSE1_Oculus_gesture_P.Gain_Gain_p * rtb_MultiportSwitch_idx_0;

  /* Sum: '<S11>/Sum1' */
  rtb_Gain_c += signal;

  /* Math: '<S11>/Math Function' incorporates:
   *  Constant: '<S11>/Constant'
   */
  rtb_Gain_c = rt_remd_snf(rtb_Gain_c, CSE1_Oculus_gesture_P.Constant_Value_c);

  /* Sum: '<S11>/Sum' */
  rtb_Gain_c -= signal;

  /* SignalConversion: '<S8>/TmpSignal ConversionAtMatrix MultiplyInport2' incorporates:
   *  Fcn: '<S9>/Row1'
   *  Fcn: '<S9>/Row2'
   *  Fcn: '<S9>/Row3'
   */
  CSE1_Oculus_gesture_B.TmpSignalConversionAtMatrixMult[0] = cos(rtb_Row2) *
    rtb_TmpSignalConversionAtSFun_i[0] + sin(rtb_Row2) *
    rtb_TmpSignalConversionAtSFun_i[1];
  CSE1_Oculus_gesture_B.TmpSignalConversionAtMatrixMult[1] = -sin(rtb_Row2) *
    rtb_TmpSignalConversionAtSFun_i[0] + cos(rtb_Row2) *
    rtb_TmpSignalConversionAtSFun_i[1];
  CSE1_Oculus_gesture_B.TmpSignalConversionAtMatrixMult[2] = rtb_Gain_c;

  /* Product: '<S8>/Matrix Multiply' */
  for (i = 0; i < 3; i++) {
    rtb_TmpSignalConversionAtSFun_i[i] =
      CSE1_Oculus_gesture_B.sf_MATLABFunction.K_p[i + 6] *
      CSE1_Oculus_gesture_B.TmpSignalConversionAtMatrixMult[2] +
      (CSE1_Oculus_gesture_B.sf_MATLABFunction.K_p[i + 3] *
       CSE1_Oculus_gesture_B.TmpSignalConversionAtMatrixMult[1] +
       CSE1_Oculus_gesture_B.sf_MATLABFunction.K_p[i] *
       CSE1_Oculus_gesture_B.TmpSignalConversionAtMatrixMult[0]);
  }

  /* End of Product: '<S8>/Matrix Multiply' */

  /* Integrator: '<S8>/Integrator' */
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                       &CSE1_Oculus_gesture_PrevZCX.Integrator_Reset_ZCE_h,
                       CSE1_Oculus_gesture_B.reset);

    /* evaluate zero-crossings */
    if (zcEvent) {
      CSE1_Oculus_gesture_X.Integrator_CSTATE_i[0] =
        CSE1_Oculus_gesture_P.Integrator_IC;
      CSE1_Oculus_gesture_X.Integrator_CSTATE_i[1] =
        CSE1_Oculus_gesture_P.Integrator_IC;
      CSE1_Oculus_gesture_X.Integrator_CSTATE_i[2] =
        CSE1_Oculus_gesture_P.Integrator_IC;
    }
  }

  rtb_MatrixMultiply2[0] = CSE1_Oculus_gesture_X.Integrator_CSTATE_i[0];
  rtb_MatrixMultiply2[1] = CSE1_Oculus_gesture_X.Integrator_CSTATE_i[1];
  rtb_MatrixMultiply2[2] = CSE1_Oculus_gesture_X.Integrator_CSTATE_i[2];

  /* Product: '<S8>/Matrix Multiply1' */
  for (i = 0; i < 3; i++) {
    rtb_Integrator2[i] = 0.0;
    rtb_Integrator2[i] += rtb_K_i[i] * rtb_MatrixMultiply2[0];
    rtb_Integrator2[i] += rtb_K_i[i + 3] * rtb_MatrixMultiply2[1];
    rtb_Integrator2[i] += rtb_K_i[i + 6] * rtb_MatrixMultiply2[2];
  }

  /* End of Product: '<S8>/Matrix Multiply1' */

  /* Sum: '<S8>/Sum3' */
  rtb_TmpSignalConversionAtSFun_i[0] += rtb_Integrator2[0];
  rtb_TmpSignalConversionAtSFun_i[1] += rtb_Integrator2[1];
  rtb_MultiportSwitch_idx_0 = rtb_TmpSignalConversionAtSFun_i[2] +
    rtb_Integrator2[2];
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* Delay: '<S46>/Delay' incorporates:
     *  SignalConversion: '<S46>/TmpSignal ConversionAtDelayInport2'
     */
    if (CSE1_Oculus_gesture_DW.icLoad != 0) {
      CSE1_Oculus_gesture_DW.Delay_DSTATE[0] = CSE1_Oculus_gesture_B.x;
      CSE1_Oculus_gesture_DW.Delay_DSTATE[1] = CSE1_Oculus_gesture_B.y;
      CSE1_Oculus_gesture_DW.Delay_DSTATE[2] = CSE1_Oculus_gesture_B.Sum;
    }

    CSE1_Oculus_gesture_B.Delay[0] = CSE1_Oculus_gesture_DW.Delay_DSTATE[0];
    CSE1_Oculus_gesture_B.Delay[1] = CSE1_Oculus_gesture_DW.Delay_DSTATE[1];
    CSE1_Oculus_gesture_B.Delay[2] = CSE1_Oculus_gesture_DW.Delay_DSTATE[2];

    /* End of Delay: '<S46>/Delay' */
  }

  /* MATLAB Function: '<S46>/MATLAB Function' incorporates:
   *  SignalConversion: '<S47>/TmpSignal ConversionAt SFunction Inport2'
   */
  /* MATLAB Function 'Navigation /Derivative filter/MATLAB Function': '<S47>:1' */
  /* '<S47>:1:3' */
  CSE1_Oculus_gesture_B.eta_filtered[0] = (1.0 - CSE1_Oculus_gesture_B.Filter1) *
    CSE1_Oculus_gesture_B.Delay[0] + CSE1_Oculus_gesture_B.Filter1 *
    CSE1_Oculus_gesture_B.x;
  CSE1_Oculus_gesture_B.eta_filtered[1] = (1.0 - CSE1_Oculus_gesture_B.Filter1) *
    CSE1_Oculus_gesture_B.Delay[1] + CSE1_Oculus_gesture_B.Filter1 *
    CSE1_Oculus_gesture_B.y;
  CSE1_Oculus_gesture_B.eta_filtered[2] = (1.0 - CSE1_Oculus_gesture_B.Filter1) *
    CSE1_Oculus_gesture_B.Delay[2] + CSE1_Oculus_gesture_B.Filter1 *
    CSE1_Oculus_gesture_B.Sum;

  /* MATLAB Function 'Navigation /Derivative filter/MATLAB Function1': '<S48>:1' */
  /* '<S48>:1:3' */
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* Memory: '<S46>/Memory3' */
    CSE1_Oculus_gesture_B.Memory3[0] =
      CSE1_Oculus_gesture_DW.Memory3_PreviousInput[0];
    CSE1_Oculus_gesture_B.Memory3[1] =
      CSE1_Oculus_gesture_DW.Memory3_PreviousInput[1];
    CSE1_Oculus_gesture_B.Memory3[2] =
      CSE1_Oculus_gesture_DW.Memory3_PreviousInput[2];
  }

  /* MATLAB Function: '<S46>/MATLAB Function2' incorporates:
   *  Constant: '<S46>/Constant1'
   *  MATLAB Function: '<S46>/MATLAB Function1'
   */
  /* MATLAB Function 'Navigation /Derivative filter/MATLAB Function2': '<S49>:1' */
  /* '<S49>:1:3' */
  CSE1_Oculus_gesture_B.eta_dot_filtered[0] =
    (CSE1_Oculus_gesture_B.eta_filtered[0] - CSE1_Oculus_gesture_B.Delay[0]) /
    CSE1_Oculus_gesture_P.Constant1_Value * CSE1_Oculus_gesture_B.Filter3 + (1.0
    - CSE1_Oculus_gesture_B.Filter3) * CSE1_Oculus_gesture_B.Memory3[0];
  CSE1_Oculus_gesture_B.eta_dot_filtered[1] =
    (CSE1_Oculus_gesture_B.eta_filtered[1] - CSE1_Oculus_gesture_B.Delay[1]) /
    CSE1_Oculus_gesture_P.Constant1_Value * CSE1_Oculus_gesture_B.Filter3 + (1.0
    - CSE1_Oculus_gesture_B.Filter3) * CSE1_Oculus_gesture_B.Memory3[1];
  CSE1_Oculus_gesture_B.eta_dot_filtered[2] =
    (CSE1_Oculus_gesture_B.eta_filtered[2] - CSE1_Oculus_gesture_B.Delay[2]) /
    CSE1_Oculus_gesture_P.Constant1_Value * CSE1_Oculus_gesture_B.Filter3 + (1.0
    - CSE1_Oculus_gesture_B.Filter3) * CSE1_Oculus_gesture_B.Memory3[2];

  /* MATLAB Function: '<S46>/MATLAB Function3' incorporates:
   *  Fcn: '<S46>/Fcn'
   */
  /* MATLAB Function 'Navigation /Derivative filter/MATLAB Function3': '<S50>:1' */
  /* '<S50>:1:3' */
  /* '<S50>:1:6' */
  tmp_1[0] = cos(CSE1_Oculus_gesture_B.Sum);
  tmp_1[3] = sin(CSE1_Oculus_gesture_B.Sum);
  tmp_1[6] = 0.0;
  tmp_1[1] = -sin(CSE1_Oculus_gesture_B.Sum);
  tmp_1[4] = cos(CSE1_Oculus_gesture_B.Sum);
  tmp_1[7] = 0.0;
  tmp_1[2] = 0.0;
  tmp_1[5] = 0.0;
  tmp_1[8] = 1.0;
  for (i = 0; i < 3; i++) {
    CSE1_Oculus_gesture_B.nu[i] = 0.0;
    CSE1_Oculus_gesture_B.nu[i] += tmp_1[i] *
      CSE1_Oculus_gesture_B.eta_dot_filtered[0];
    CSE1_Oculus_gesture_B.nu[i] += tmp_1[i + 3] *
      CSE1_Oculus_gesture_B.eta_dot_filtered[1];
    CSE1_Oculus_gesture_B.nu[i] += tmp_1[i + 6] *
      CSE1_Oculus_gesture_B.eta_dot_filtered[2];
  }

  /* End of MATLAB Function: '<S46>/MATLAB Function3' */

  /* Sum: '<S8>/Sum4' incorporates:
   *  Fcn: '<S10>/Row1'
   *  Fcn: '<S10>/Row2'
   *  Fcn: '<S10>/Row3'
   *  Fcn: '<S8>/yaw angle1'
   */
  rtb_Integrator2[0] = (cos(CSE1_Oculus_gesture_B.Sum_p) *
                        CSE1_Oculus_gesture_B.MultiportSwitch[3] + sin
                        (CSE1_Oculus_gesture_B.Sum_p) *
                        CSE1_Oculus_gesture_B.MultiportSwitch[4]) -
    CSE1_Oculus_gesture_B.nu[0];
  rtb_Integrator2[1] = (-sin(CSE1_Oculus_gesture_B.Sum_p) *
                        CSE1_Oculus_gesture_B.MultiportSwitch[3] + cos
                        (CSE1_Oculus_gesture_B.Sum_p) *
                        CSE1_Oculus_gesture_B.MultiportSwitch[4]) -
    CSE1_Oculus_gesture_B.nu[1];
  rtb_Integrator2[2] = CSE1_Oculus_gesture_B.MultiportSwitch[5] -
    CSE1_Oculus_gesture_B.nu[2];

  /* Product: '<S8>/Matrix Multiply2' */
  for (i = 0; i < 3; i++) {
    rtb_MatrixMultiply2[i] = 0.0;
    rtb_MatrixMultiply2[i] += rtb_K_d[i] * rtb_Integrator2[0];
    rtb_MatrixMultiply2[i] += rtb_K_d[i + 3] * rtb_Integrator2[1];
    rtb_MatrixMultiply2[i] += rtb_K_d[i + 6] * rtb_Integrator2[2];
  }

  /* End of Product: '<S8>/Matrix Multiply2' */

  /* Sum: '<S8>/Sum1' */
  CSE1_Oculus_gesture_B.Sum1[0] = rtb_TmpSignalConversionAtSFun_i[0] +
    rtb_MatrixMultiply2[0];
  CSE1_Oculus_gesture_B.Sum1[1] = rtb_TmpSignalConversionAtSFun_i[1] +
    rtb_MatrixMultiply2[1];
  CSE1_Oculus_gesture_B.Sum1[2] = rtb_MultiportSwitch_idx_0 +
    rtb_MatrixMultiply2[2];

  /* MATLAB Function: '<S6>/Thrust allocation' */
  /* MATLAB Function 'Thrust allocation/Thrust allocation': '<S61>:1' */
  /*  Forces and moments vector */
  /* '<S61>:1:4' */
  /*  Extended thrust configuration matrix */
  /*  Extended thrust coefficient matrix */
  /*  tau = T*K*u inverse */
  /* '<S61>:1:23' */
  tmp[0] = CSE1_Oculus_gesture_B.Sum1[0];
  tmp[1] = CSE1_Oculus_gesture_B.Sum1[1];
  tmp[2] = CSE1_Oculus_gesture_B.Sum1[2];
  CSE1_Oculus_gesture_mldivide(c, tmp, tmp_0);
  CSE1_Oculus_gesture_mldivide(b, tmp_0, rtb_TmpSignalConversionAtSFun_i);

  /* '<S61>:1:25' */
  /* '<S61>:1:27' */
  /* '<S61>:1:28' */
  /* '<S61>:1:29' */
  /* '<S61>:1:30' */
  if (CSE1_Oculus_gesture_B.VSP_on != 0.0) {
    /* '<S61>:1:33' */
    signal = 0.3;
  } else {
    /* '<S61>:1:35' */
    signal = 0.0;
  }

  CSE1_Oculus_gesture_B.u_BT_j = rtb_TmpSignalConversionAtSFun_i[2];
  CSE1_Oculus_gesture_B.u_VSP = sqrt(rtb_TmpSignalConversionAtSFun_i[0] *
    rtb_TmpSignalConversionAtSFun_i[0] + rtb_TmpSignalConversionAtSFun_i[1] *
    rtb_TmpSignalConversionAtSFun_i[1]);
  CSE1_Oculus_gesture_B.alpha_VSP = rt_atan2d_snf
    (rtb_TmpSignalConversionAtSFun_i[1], rtb_TmpSignalConversionAtSFun_i[0]);

  /* MultiPortSwitch: '<S7>/Multiport Switch' incorporates:
   *  MATLAB Function: '<S6>/Thrust allocation'
   */
  switch ((int32_T)CSE1_Oculus_gesture_B.switch_signal) {
   case 1:
    rtb_MultiportSwitch_idx_0 = CSE1_Oculus_gesture_B.u_BT_j;
    rtb_Gain_c = CSE1_Oculus_gesture_B.u_VSP;
    rtb_Row2 = CSE1_Oculus_gesture_B.u_VSP;
    rtb_MultiportSwitch_idx_3 = CSE1_Oculus_gesture_B.alpha_VSP;
    rtb_MultiportSwitch_idx_4 = CSE1_Oculus_gesture_B.alpha_VSP;
    rtb_MultiportSwitch_idx_6 = signal;
    break;

   case 2:
    rtb_MultiportSwitch_idx_0 = CSE1_Oculus_gesture_B.u_BT;
    rtb_Gain_c = CSE1_Oculus_gesture_B.u_VSP1;
    rtb_Row2 = CSE1_Oculus_gesture_B.u_VSP2;
    rtb_MultiportSwitch_idx_3 = CSE1_Oculus_gesture_B.alpha_VSP1;
    rtb_MultiportSwitch_idx_4 = CSE1_Oculus_gesture_B.alpha_VSP2;
    signal = CSE1_Oculus_gesture_B.omega_VSP1;
    rtb_MultiportSwitch_idx_6 = CSE1_Oculus_gesture_B.omega_VSP2;
    break;

   case 3:
    rtb_MultiportSwitch_idx_0 = CSE1_Oculus_gesture_B.u_BT_c;
    rtb_Gain_c = CSE1_Oculus_gesture_B.u_VSP1_d;
    rtb_Row2 = CSE1_Oculus_gesture_B.u_VSP2_c;
    rtb_MultiportSwitch_idx_3 = CSE1_Oculus_gesture_B.alpha_VSP1_i;
    rtb_MultiportSwitch_idx_4 = CSE1_Oculus_gesture_B.alpha_VSP2_f;
    signal = CSE1_Oculus_gesture_B.omega_VSP1_a;
    rtb_MultiportSwitch_idx_6 = CSE1_Oculus_gesture_B.omega_VSP2_f;
    break;

   default:
    rtb_MultiportSwitch_idx_0 = CSE1_Oculus_gesture_B.u_BT_f;
    rtb_Gain_c = CSE1_Oculus_gesture_B.u_VSP1_g;
    rtb_Row2 = CSE1_Oculus_gesture_B.u_VSP2_o;
    rtb_MultiportSwitch_idx_3 = CSE1_Oculus_gesture_B.alpha_VSP1_o;
    rtb_MultiportSwitch_idx_4 = CSE1_Oculus_gesture_B.alpha_VSP2_f2;
    signal = CSE1_Oculus_gesture_B.omega_VSP1_k;
    rtb_MultiportSwitch_idx_6 = CSE1_Oculus_gesture_B.omega_VSP2_b;
    break;
  }

  /* End of MultiPortSwitch: '<S7>/Multiport Switch' */

  /* Saturate: '<S7>/Saturation4' */
  if (rtb_MultiportSwitch_idx_4 > CSE1_Oculus_gesture_P.Saturation4_UpperSat) {
    CSE1_Oculus_gesture_B.Saturation4 =
      CSE1_Oculus_gesture_P.Saturation4_UpperSat;
  } else if (rtb_MultiportSwitch_idx_4 <
             CSE1_Oculus_gesture_P.Saturation4_LowerSat) {
    CSE1_Oculus_gesture_B.Saturation4 =
      CSE1_Oculus_gesture_P.Saturation4_LowerSat;
  } else {
    CSE1_Oculus_gesture_B.Saturation4 = rtb_MultiportSwitch_idx_4;
  }

  /* End of Saturate: '<S7>/Saturation4' */

  /* Saturate: '<S7>/Saturation' */
  if (rtb_MultiportSwitch_idx_0 > CSE1_Oculus_gesture_P.Saturation_UpperSat_b) {
    CSE1_Oculus_gesture_B.Saturation =
      CSE1_Oculus_gesture_P.Saturation_UpperSat_b;
  } else if (rtb_MultiportSwitch_idx_0 <
             CSE1_Oculus_gesture_P.Saturation_LowerSat_nv) {
    CSE1_Oculus_gesture_B.Saturation =
      CSE1_Oculus_gesture_P.Saturation_LowerSat_nv;
  } else {
    CSE1_Oculus_gesture_B.Saturation = rtb_MultiportSwitch_idx_0;
  }

  /* End of Saturate: '<S7>/Saturation' */

  /* Saturate: '<S7>/Saturation1' */
  if (rtb_Gain_c > CSE1_Oculus_gesture_P.Saturation1_UpperSat) {
    CSE1_Oculus_gesture_B.Saturation1 =
      CSE1_Oculus_gesture_P.Saturation1_UpperSat;
  } else if (rtb_Gain_c < CSE1_Oculus_gesture_P.Saturation1_LowerSat) {
    CSE1_Oculus_gesture_B.Saturation1 =
      CSE1_Oculus_gesture_P.Saturation1_LowerSat;
  } else {
    CSE1_Oculus_gesture_B.Saturation1 = rtb_Gain_c;
  }

  /* End of Saturate: '<S7>/Saturation1' */

  /* Saturate: '<S7>/Saturation2' */
  if (rtb_Row2 > CSE1_Oculus_gesture_P.Saturation2_UpperSat) {
    CSE1_Oculus_gesture_B.Saturation2 =
      CSE1_Oculus_gesture_P.Saturation2_UpperSat;
  } else if (rtb_Row2 < CSE1_Oculus_gesture_P.Saturation2_LowerSat) {
    CSE1_Oculus_gesture_B.Saturation2 =
      CSE1_Oculus_gesture_P.Saturation2_LowerSat;
  } else {
    CSE1_Oculus_gesture_B.Saturation2 = rtb_Row2;
  }

  /* End of Saturate: '<S7>/Saturation2' */

  /* Saturate: '<S7>/Saturation3' */
  if (rtb_MultiportSwitch_idx_3 > CSE1_Oculus_gesture_P.Saturation3_UpperSat) {
    CSE1_Oculus_gesture_B.Saturation3 =
      CSE1_Oculus_gesture_P.Saturation3_UpperSat;
  } else if (rtb_MultiportSwitch_idx_3 <
             CSE1_Oculus_gesture_P.Saturation3_LowerSat) {
    CSE1_Oculus_gesture_B.Saturation3 =
      CSE1_Oculus_gesture_P.Saturation3_LowerSat;
  } else {
    CSE1_Oculus_gesture_B.Saturation3 = rtb_MultiportSwitch_idx_3;
  }

  /* End of Saturate: '<S7>/Saturation3' */

  /* Saturate: '<S7>/Saturation5' */
  if (signal > CSE1_Oculus_gesture_P.Saturation5_UpperSat) {
    CSE1_Oculus_gesture_B.Saturation5 =
      CSE1_Oculus_gesture_P.Saturation5_UpperSat;
  } else if (signal < CSE1_Oculus_gesture_P.Saturation5_LowerSat) {
    CSE1_Oculus_gesture_B.Saturation5 =
      CSE1_Oculus_gesture_P.Saturation5_LowerSat;
  } else {
    CSE1_Oculus_gesture_B.Saturation5 = signal;
  }

  /* End of Saturate: '<S7>/Saturation5' */

  /* Saturate: '<S7>/Saturation6' */
  if (rtb_MultiportSwitch_idx_6 > CSE1_Oculus_gesture_P.Saturation6_UpperSat) {
    CSE1_Oculus_gesture_B.Saturation6 =
      CSE1_Oculus_gesture_P.Saturation6_UpperSat;
  } else if (rtb_MultiportSwitch_idx_6 <
             CSE1_Oculus_gesture_P.Saturation6_LowerSat) {
    CSE1_Oculus_gesture_B.Saturation6 =
      CSE1_Oculus_gesture_P.Saturation6_LowerSat;
  } else {
    CSE1_Oculus_gesture_B.Saturation6 = rtb_MultiportSwitch_idx_6;
  }

  /* End of Saturate: '<S7>/Saturation6' */

  /* MATLAB Function: '<S7>/control limit checking' */
  /* MATLAB Function 'ctrl_out/control limit checking': '<S63>:1' */
  /* '<S63>:1:2' */
  /* '<S63>:1:3' */
  /* '<S63>:1:5' */
  /* '<S63>:1:6' */
  /* '<S63>:1:7' */
  /* '<S63>:1:8' */
  /* '<S63>:1:10' */
  /* '<S63>:1:18' */
  CSE1_Oculus_gesture_B.fault = !((-1.0 <= rtb_MultiportSwitch_idx_0) &&
    (rtb_MultiportSwitch_idx_0 <= 1.0) && (0.0 <= rtb_Gain_c) && (rtb_Gain_c <=
    1.0) && (0.0 <= rtb_Gain_c) && (rtb_Gain_c <= 2.0) && (-3.1415926535897931 <=
    rtb_MultiportSwitch_idx_3) && (rtb_MultiportSwitch_idx_3 <=
    3.1415926535897931) && (-3.1415926535897931 <= rtb_MultiportSwitch_idx_4) &&
                                  (rtb_MultiportSwitch_idx_4 <=
    3.1415926535897931) && (-1.0 <= signal) && (signal <= 1.0) && (-1.0 <=
    rtb_MultiportSwitch_idx_6) && (rtb_MultiportSwitch_idx_6 <= 1.0));

  /* MATLAB Function: '<S67>/C' */
  /* MATLAB Function 'ctrl_out/indicator/C': '<S70>:1' */
  /* '<S70>:1:3' */
  CSE1_Oculus_gesture_B.ctrl_sixaxis2thruster = false;

  /* '<S70>:1:4' */
  CSE1_Oculus_gesture_B.ctrl_sixaxis2force = false;

  /* '<S70>:1:5' */
  CSE1_Oculus_gesture_B.ctrl_DP_basic = false;

  /* '<S70>:1:6' */
  CSE1_Oculus_gesture_B.ctrl_student = false;
  if (CSE1_Oculus_gesture_B.switch_signal == 1.0) {
    /* '<S70>:1:8' */
    /* '<S70>:1:9' */
    CSE1_Oculus_gesture_B.ctrl_student = true;
  } else if (CSE1_Oculus_gesture_B.switch_signal == 2.0) {
    /* '<S70>:1:10' */
    /* '<S70>:1:11' */
    CSE1_Oculus_gesture_B.ctrl_sixaxis2force = true;
  } else if (CSE1_Oculus_gesture_B.switch_signal == 3.0) {
    /* '<S70>:1:12' */
    /* '<S70>:1:13' */
    CSE1_Oculus_gesture_B.ctrl_DP_basic = true;
  } else {
    if (CSE1_Oculus_gesture_B.switch_signal == 4.0) {
      /* '<S70>:1:14' */
      /* '<S70>:1:15' */
      CSE1_Oculus_gesture_B.ctrl_sixaxis2thruster = true;
    }
  }

  /* End of MATLAB Function: '<S67>/C' */

  /* Integrator: '<S14>/Integrator2' */
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                       &CSE1_Oculus_gesture_PrevZCX.Integrator2_Reset_ZCE,
                       CSE1_Oculus_gesture_B.reset);

    /* evaluate zero-crossings */
    if (zcEvent) {
      CSE1_Oculus_gesture_X.Integrator2_CSTATE[0] =
        CSE1_Oculus_gesture_P.Integrator2_IC;
      CSE1_Oculus_gesture_X.Integrator2_CSTATE[1] =
        CSE1_Oculus_gesture_P.Integrator2_IC;
      CSE1_Oculus_gesture_X.Integrator2_CSTATE[2] =
        CSE1_Oculus_gesture_P.Integrator2_IC;
    }
  }

  rtb_Integrator2[0] = CSE1_Oculus_gesture_X.Integrator2_CSTATE[0];
  rtb_Integrator2[1] = CSE1_Oculus_gesture_X.Integrator2_CSTATE[1];
  rtb_Integrator2[2] = CSE1_Oculus_gesture_X.Integrator2_CSTATE[2];

  /* MATLAB Function: '<S14>/w_d^3' */
  CSE1_Oculus_gesture_w_d3(CSE1_Oculus_gesture_B.sf_diag.w_d,
    &CSE1_Oculus_gesture_B.sf_w_d3);

  /* MultiPortSwitch: '<S3>/Multiport Switch' */
  if ((int32_T)CSE1_Oculus_gesture_B.Oculus_ref_on_off == 0) {
    CSE1_Oculus_gesture_B.MultiportSwitch_o = CSE1_Oculus_gesture_B.psi_ref;
  } else {
    CSE1_Oculus_gesture_B.MultiportSwitch_o = CSE1_Oculus_gesture_B.Gain3;
  }

  /* End of MultiPortSwitch: '<S3>/Multiport Switch' */

  /* MATLAB Function: '<S14>/w_d^-2' */
  CSE1_Oculus_gesture_w_d2(CSE1_Oculus_gesture_B.sf_diag.w_d,
    &CSE1_Oculus_gesture_B.sf_w_d2);

  /* Product: '<S14>/Matrix Multiply1' */
  for (i = 0; i < 3; i++) {
    rtb_MatrixMultiply2[i] = 0.0;
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_d2.y[i] *
      rtb_Integrator2[0];
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_d2.y[i + 3] *
      rtb_Integrator2[1];
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_d2.y[i + 6] *
      rtb_Integrator2[2];
  }

  /* End of Product: '<S14>/Matrix Multiply1' */

  /* Sum: '<S14>/Sum' */
  rtb_MatrixMultiply2[0] = CSE1_Oculus_gesture_B.x_ref - rtb_MatrixMultiply2[0];
  rtb_MatrixMultiply2[1] = CSE1_Oculus_gesture_B.y_ref - rtb_MatrixMultiply2[1];
  rtb_MatrixMultiply2[2] = CSE1_Oculus_gesture_B.MultiportSwitch_o -
    rtb_MatrixMultiply2[2];

  /* Product: '<S14>/Matrix Multiply' */
  for (i = 0; i < 3; i++) {
    CSE1_Oculus_gesture_B.MatrixMultiply[i] = 0.0;
    CSE1_Oculus_gesture_B.MatrixMultiply[i] += CSE1_Oculus_gesture_B.sf_w_d3.y[i]
      * rtb_MatrixMultiply2[0];
    CSE1_Oculus_gesture_B.MatrixMultiply[i] += CSE1_Oculus_gesture_B.sf_w_d3.y[i
      + 3] * rtb_MatrixMultiply2[1];
    CSE1_Oculus_gesture_B.MatrixMultiply[i] += CSE1_Oculus_gesture_B.sf_w_d3.y[i
      + 6] * rtb_MatrixMultiply2[2];
  }

  /* End of Product: '<S14>/Matrix Multiply' */

  /* MATLAB Function: '<S14>/w_d*w_d' */
  CSE1_Oculus_gesture_w_dw_d(CSE1_Oculus_gesture_B.sf_diag.w_d,
    &CSE1_Oculus_gesture_B.sf_w_dw_d);

  /* Product: '<S14>/Matrix Multiply2' */
  for (i = 0; i < 3; i++) {
    rtb_MatrixMultiply2[i] = 0.0;
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_dw_d.y[i] *
      rtb_Integrator1[0];
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_dw_d.y[i + 3] *
      rtb_Integrator1[1];
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_dw_d.y[i + 6] *
      rtb_Integrator1[2];
  }

  /* End of Product: '<S14>/Matrix Multiply2' */

  /* MATLAB Function: '<S14>/w_d*w_d1' */
  CSE1_Oculus_gesture_w_dw_d1(CSE1_Oculus_gesture_B.sf_diag.w_d,
    CSE1_Oculus_gesture_B.sf_diag1.Zeta, &CSE1_Oculus_gesture_B.sf_w_dw_d1);

  /* Sum: '<S14>/Sum5' incorporates:
   *  Product: '<S14>/Matrix Multiply5'
   *  Sum: '<S14>/Sum2'
   */
  for (i = 0; i < 3; i++) {
    CSE1_Oculus_gesture_B.Sum5[i] = (rtb_Integrator2[i] - rtb_MatrixMultiply2[i])
      - ((CSE1_Oculus_gesture_B.sf_w_dw_d1.y[i + 3] *
          CSE1_Oculus_gesture_B.Integrator3[1] +
          CSE1_Oculus_gesture_B.sf_w_dw_d1.y[i] *
          CSE1_Oculus_gesture_B.Integrator3[0]) +
         CSE1_Oculus_gesture_B.sf_w_dw_d1.y[i + 6] *
         CSE1_Oculus_gesture_B.Integrator3[2]);
  }

  /* End of Sum: '<S14>/Sum5' */

  /* Integrator: '<S18>/Integrator2' */
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                       &CSE1_Oculus_gesture_PrevZCX.Integrator2_Reset_ZCE_p,
                       CSE1_Oculus_gesture_B.reset);

    /* evaluate zero-crossings */
    if (zcEvent) {
      CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[0] =
        CSE1_Oculus_gesture_P.Integrator2_IC_n;
      CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[1] =
        CSE1_Oculus_gesture_P.Integrator2_IC_n;
      CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[2] =
        CSE1_Oculus_gesture_P.Integrator2_IC_n;
    }
  }

  rtb_Integrator2[0] = CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[0];
  rtb_Integrator2[1] = CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[1];
  rtb_Integrator2[2] = CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[2];

  /* Integrator: '<S18>/Integrator3' */
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    ZCEventType zcEvent;
    zcEvent = rt_ZCFcn(ANY_ZERO_CROSSING,
                       &CSE1_Oculus_gesture_PrevZCX.Integrator3_Reset_ZCE_h,
                       CSE1_Oculus_gesture_B.reset);

    /* evaluate zero-crossings */
    if (zcEvent) {
      CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[0] =
        CSE1_Oculus_gesture_P.Integrator3_IC_i;
      CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[1] =
        CSE1_Oculus_gesture_P.Integrator3_IC_i;
      CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[2] =
        CSE1_Oculus_gesture_P.Integrator3_IC_i;
    }
  }

  CSE1_Oculus_gesture_B.Integrator3_o[0] =
    CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[0];
  CSE1_Oculus_gesture_B.Integrator3_o[1] =
    CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[1];
  CSE1_Oculus_gesture_B.Integrator3_o[2] =
    CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[2];

  /* MATLAB Function: '<S18>/w_d^3' */
  CSE1_Oculus_gesture_w_d3(CSE1_Oculus_gesture_B.sf_diag_j.w_d,
    &CSE1_Oculus_gesture_B.sf_w_d3_f);

  /* Gain: '<S33>/Gain2' */
  CSE1_Oculus_gesture_B.Gain2 = CSE1_Oculus_gesture_P.Gain2_Gain *
    CSE1_Oculus_gesture_B.Oculus_pitch;

  /* Gain: '<S30>/Gain' */
  rtb_TmpSignalConversionAtSFun_i[0] = CSE1_Oculus_gesture_P.Gain_Gain_f *
    CSE1_Oculus_gesture_B.Gain1;
  rtb_TmpSignalConversionAtSFun_i[1] = CSE1_Oculus_gesture_P.Gain_Gain_f *
    CSE1_Oculus_gesture_B.Gain2;
  rtb_TmpSignalConversionAtSFun_i[2] = CSE1_Oculus_gesture_P.Gain_Gain_f *
    CSE1_Oculus_gesture_B.Gain3;

  /* MATLAB Function: '<S30>/MATLAB Function' */
  /* MATLAB Function 'Input/Gesture based ctrl/MATLAB Function': '<S38>:1' */
  if (fabs(rtb_TmpSignalConversionAtSFun_i[0]) < 0.055555555555555552) {
    /* '<S38>:1:3' */
    /* '<S38>:1:4' */
    signal = 0.0;
  } else {
    /* '<S38>:1:6' */
    signal = rtb_TmpSignalConversionAtSFun_i[0];
  }

  if (fabs(rtb_TmpSignalConversionAtSFun_i[1]) < 0.055555555555555552) {
    /* '<S38>:1:9' */
    /* '<S38>:1:10' */
    rtb_Row2 = 0.0;
  } else {
    /* '<S38>:1:12' */
    rtb_Row2 = rtb_TmpSignalConversionAtSFun_i[1];
  }

  if (fabs(rtb_TmpSignalConversionAtSFun_i[2]) < 0.055555555555555552) {
    /* '<S38>:1:15' */
    /* '<S38>:1:16' */
    rtb_Gain_c = 0.0;
  } else {
    /* '<S38>:1:18' */
    rtb_Gain_c = rtb_TmpSignalConversionAtSFun_i[2];
  }

  /* End of MATLAB Function: '<S30>/MATLAB Function' */

  /* SignalConversion: '<S30>/TmpSignal ConversionAtT_bInport1' */
  rtb_MatrixMultiply2[0] = signal;
  rtb_MatrixMultiply2[1] = rtb_Row2;
  rtb_MatrixMultiply2[2] = rtb_Gain_c;

  /* Gain: '<S30>/T_b' incorporates:
   *  Product: '<S30>/Matrix Multiply'
   */
  for (i = 0; i < 3; i++) {
    tmp[i] = CSE1_Oculus_gesture_P.T_b_Gain[i + 6] * rtb_MatrixMultiply2[2] +
      (CSE1_Oculus_gesture_P.T_b_Gain[i + 3] * rtb_MatrixMultiply2[1] +
       CSE1_Oculus_gesture_P.T_b_Gain[i] * rtb_MatrixMultiply2[0]);
  }

  /* End of Gain: '<S30>/T_b' */

  /* Product: '<S30>/Matrix Multiply' */
  for (i = 0; i < 3; i++) {
    CSE1_Oculus_gesture_B.MatrixMultiply_k[i] = 0.0;
    CSE1_Oculus_gesture_B.MatrixMultiply_k[i] +=
      CSE1_Oculus_gesture_B.sf_MATLABFunction4.K_p[i] * tmp[0];
    CSE1_Oculus_gesture_B.MatrixMultiply_k[i] +=
      CSE1_Oculus_gesture_B.sf_MATLABFunction4.K_p[i + 3] * tmp[1];
    CSE1_Oculus_gesture_B.MatrixMultiply_k[i] +=
      CSE1_Oculus_gesture_B.sf_MATLABFunction4.K_p[i + 6] * tmp[2];
  }

  /* MATLAB Function: '<S18>/w_d^-2' */
  CSE1_Oculus_gesture_w_d2(CSE1_Oculus_gesture_B.sf_diag_j.w_d,
    &CSE1_Oculus_gesture_B.sf_w_d2_d);

  /* Product: '<S18>/Matrix Multiply1' */
  for (i = 0; i < 3; i++) {
    rtb_MatrixMultiply2[i] = 0.0;
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_d2_d.y[i] *
      rtb_Integrator2[0];
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_d2_d.y[i + 3] *
      rtb_Integrator2[1];
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_d2_d.y[i + 6] *
      rtb_Integrator2[2];
  }

  /* End of Product: '<S18>/Matrix Multiply1' */

  /* Sum: '<S18>/Sum' */
  rtb_MatrixMultiply2[0] = CSE1_Oculus_gesture_B.MatrixMultiply_k[0] -
    rtb_MatrixMultiply2[0];
  rtb_MatrixMultiply2[1] = CSE1_Oculus_gesture_B.MatrixMultiply_k[1] -
    rtb_MatrixMultiply2[1];
  rtb_MatrixMultiply2[2] = CSE1_Oculus_gesture_B.MatrixMultiply_k[2] -
    rtb_MatrixMultiply2[2];

  /* Product: '<S18>/Matrix Multiply' */
  for (i = 0; i < 3; i++) {
    CSE1_Oculus_gesture_B.MatrixMultiply_n[i] = 0.0;
    CSE1_Oculus_gesture_B.MatrixMultiply_n[i] +=
      CSE1_Oculus_gesture_B.sf_w_d3_f.y[i] * rtb_MatrixMultiply2[0];
    CSE1_Oculus_gesture_B.MatrixMultiply_n[i] +=
      CSE1_Oculus_gesture_B.sf_w_d3_f.y[i + 3] * rtb_MatrixMultiply2[1];
    CSE1_Oculus_gesture_B.MatrixMultiply_n[i] +=
      CSE1_Oculus_gesture_B.sf_w_d3_f.y[i + 6] * rtb_MatrixMultiply2[2];
  }

  /* End of Product: '<S18>/Matrix Multiply' */

  /* MATLAB Function: '<S18>/w_d*w_d' */
  CSE1_Oculus_gesture_w_dw_d(CSE1_Oculus_gesture_B.sf_diag_j.w_d,
    &CSE1_Oculus_gesture_B.sf_w_dw_d_f);

  /* Product: '<S18>/Matrix Multiply2' */
  for (i = 0; i < 3; i++) {
    rtb_MatrixMultiply2[i] = 0.0;
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_dw_d_f.y[i] *
      CSE1_Oculus_gesture_B.Integrator1[0];
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_dw_d_f.y[i + 3] *
      CSE1_Oculus_gesture_B.Integrator1[1];
    rtb_MatrixMultiply2[i] += CSE1_Oculus_gesture_B.sf_w_dw_d_f.y[i + 6] *
      CSE1_Oculus_gesture_B.Integrator1[2];
  }

  /* End of Product: '<S18>/Matrix Multiply2' */

  /* MATLAB Function: '<S41>/diag1' */
  CSE1_Oculus_gesture_diag1(CSE1_Oculus_gesture_B.zeta_x_m,
    CSE1_Oculus_gesture_B.zeta_y_k, CSE1_Oculus_gesture_B.zeta_psi_i,
    &CSE1_Oculus_gesture_B.sf_diag1_j);

  /* MATLAB Function: '<S18>/w_d*w_d1' */
  CSE1_Oculus_gesture_w_dw_d1(CSE1_Oculus_gesture_B.sf_diag_j.w_d,
    CSE1_Oculus_gesture_B.sf_diag1_j.Zeta, &CSE1_Oculus_gesture_B.sf_w_dw_d1_f);

  /* Sum: '<S18>/Sum5' incorporates:
   *  Product: '<S18>/Matrix Multiply5'
   *  Sum: '<S18>/Sum2'
   */
  for (i = 0; i < 3; i++) {
    CSE1_Oculus_gesture_B.Sum5_o[i] = (rtb_Integrator2[i] -
      rtb_MatrixMultiply2[i]) - ((CSE1_Oculus_gesture_B.sf_w_dw_d1_f.y[i + 3] *
      CSE1_Oculus_gesture_B.Integrator3_o[1] +
      CSE1_Oculus_gesture_B.sf_w_dw_d1_f.y[i] *
      CSE1_Oculus_gesture_B.Integrator3_o[0]) +
      CSE1_Oculus_gesture_B.sf_w_dw_d1_f.y[i + 6] *
      CSE1_Oculus_gesture_B.Integrator3_o[2]);
  }

  /* End of Sum: '<S18>/Sum5' */

  /* MATLAB Function: '<S5>/diag2vector' */
  CSE1_Oculus_gesture_diag2vector(CSE1_Oculus_gesture_B.sf_MATLABFunction.K_p,
    &CSE1_Oculus_gesture_B.sf_diag2vector);

  /* MATLAB Function: '<S5>/diag2vector1' */
  CSE1_Oculus_gesture_diag2vector(rtb_K_i,
    &CSE1_Oculus_gesture_B.sf_diag2vector1);

  /* MATLAB Function: '<S5>/diag2vector2' */
  CSE1_Oculus_gesture_diag2vector(rtb_K_d,
    &CSE1_Oculus_gesture_B.sf_diag2vector2);

  /* MATLAB Function: '<S5>/diag2vector3' */
  CSE1_Oculus_gesture_diag2vector(CSE1_Oculus_gesture_B.sf_diag.w_d,
    &CSE1_Oculus_gesture_B.sf_diag2vector3);

  /* MATLAB Function: '<S5>/diag2vector4' */
  CSE1_Oculus_gesture_diag2vector(CSE1_Oculus_gesture_B.sf_diag1.Zeta,
    &CSE1_Oculus_gesture_B.sf_diag2vector4);
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* SignalConversion: '<S5>/TmpSignal ConversionAtTo FileInport1' */
    rtb_TmpSignalConversionAtToFile[0] = CSE1_Oculus_gesture_B.sf_diag2vector.y
      [0];
    rtb_TmpSignalConversionAtToFile[1] = CSE1_Oculus_gesture_B.sf_diag2vector.y
      [1];
    rtb_TmpSignalConversionAtToFile[2] = CSE1_Oculus_gesture_B.sf_diag2vector.y
      [2];
    rtb_TmpSignalConversionAtToFile[3] =
      CSE1_Oculus_gesture_B.sf_diag2vector1.y[0];
    rtb_TmpSignalConversionAtToFile[4] =
      CSE1_Oculus_gesture_B.sf_diag2vector1.y[1];
    rtb_TmpSignalConversionAtToFile[5] =
      CSE1_Oculus_gesture_B.sf_diag2vector1.y[2];
    rtb_TmpSignalConversionAtToFile[6] =
      CSE1_Oculus_gesture_B.sf_diag2vector2.y[0];
    rtb_TmpSignalConversionAtToFile[7] =
      CSE1_Oculus_gesture_B.sf_diag2vector2.y[1];
    rtb_TmpSignalConversionAtToFile[8] =
      CSE1_Oculus_gesture_B.sf_diag2vector2.y[2];
    rtb_TmpSignalConversionAtToFile[9] =
      CSE1_Oculus_gesture_B.sf_diag2vector3.y[0];
    rtb_TmpSignalConversionAtToFile[10] =
      CSE1_Oculus_gesture_B.sf_diag2vector3.y[1];
    rtb_TmpSignalConversionAtToFile[11] =
      CSE1_Oculus_gesture_B.sf_diag2vector3.y[2];
    rtb_TmpSignalConversionAtToFile[12] =
      CSE1_Oculus_gesture_B.sf_diag2vector4.y[0];
    rtb_TmpSignalConversionAtToFile[13] =
      CSE1_Oculus_gesture_B.sf_diag2vector4.y[1];
    rtb_TmpSignalConversionAtToFile[14] =
      CSE1_Oculus_gesture_B.sf_diag2vector4.y[2];

    /* ToFile: '<S5>/To File' */
    {
      if (!(++CSE1_Oculus_gesture_DW.ToFile_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.ToFile_IWORK.Count*16)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.ToFile_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[16];
          CSE1_Oculus_gesture_DW.ToFile_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = rtb_TmpSignalConversionAtToFile[0];
          u[2] = rtb_TmpSignalConversionAtToFile[1];
          u[3] = rtb_TmpSignalConversionAtToFile[2];
          u[4] = rtb_TmpSignalConversionAtToFile[3];
          u[5] = rtb_TmpSignalConversionAtToFile[4];
          u[6] = rtb_TmpSignalConversionAtToFile[5];
          u[7] = rtb_TmpSignalConversionAtToFile[6];
          u[8] = rtb_TmpSignalConversionAtToFile[7];
          u[9] = rtb_TmpSignalConversionAtToFile[8];
          u[10] = rtb_TmpSignalConversionAtToFile[9];
          u[11] = rtb_TmpSignalConversionAtToFile[10];
          u[12] = rtb_TmpSignalConversionAtToFile[11];
          u[13] = rtb_TmpSignalConversionAtToFile[12];
          u[14] = rtb_TmpSignalConversionAtToFile[13];
          u[15] = rtb_TmpSignalConversionAtToFile[14];
          if (fwrite(u, sizeof(real_T), 16, fp) != 16) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file gains.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.ToFile_IWORK.Count)*16)+1 >= 100000000)
          {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file gains.mat.\n");
          }
        }
      }
    }
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* ToFile: '<S51>/tau' */
    {
      if (!(++CSE1_Oculus_gesture_DW.tau_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.tau_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.tau_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.tau_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = CSE1_Oculus_gesture_B.Sum1[0];
          u[2] = CSE1_Oculus_gesture_B.Sum1[1];
          u[3] = CSE1_Oculus_gesture_B.Sum1[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file tau.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.tau_IWORK.Count)*4)+1 >= 100000000) {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file tau.mat.\n");
          }
        }
      }
    }
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* SignalConversion: '<S51>/TmpSignal ConversionAteta3Inport1' */
    rtb_TmpSignalConversionAtetaInp[0] = CSE1_Oculus_gesture_B.u_BT_j;
    rtb_TmpSignalConversionAtetaInp[1] = CSE1_Oculus_gesture_B.u_VSP;
    rtb_TmpSignalConversionAtetaInp[2] = CSE1_Oculus_gesture_B.alpha_VSP;

    /* ToFile: '<S51>/eta3' */
    {
      if (!(++CSE1_Oculus_gesture_DW.eta3_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.eta3_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta3_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.eta3_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = rtb_TmpSignalConversionAtetaInp[0];
          u[2] = rtb_TmpSignalConversionAtetaInp[1];
          u[3] = rtb_TmpSignalConversionAtetaInp[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file thrust.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.eta3_IWORK.Count)*4)+1 >= 100000000) {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file thrust.mat.\n");
          }
        }
      }
    }
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* SignalConversion: '<S52>/TmpSignal ConversionAteta1Inport1' */
    rtb_TmpSignalConversionAtetaInp[0] = CSE1_Oculus_gesture_B.MultiportSwitch[0];
    rtb_TmpSignalConversionAtetaInp[1] = CSE1_Oculus_gesture_B.MultiportSwitch[1];
    rtb_TmpSignalConversionAtetaInp[2] = CSE1_Oculus_gesture_B.Sum_p;

    /* ToFile: '<S52>/eta1' */
    {
      if (!(++CSE1_Oculus_gesture_DW.eta1_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.eta1_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta1_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.eta1_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = rtb_TmpSignalConversionAtetaInp[0];
          u[2] = rtb_TmpSignalConversionAtetaInp[1];
          u[3] = rtb_TmpSignalConversionAtetaInp[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file eta_d.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.eta1_IWORK.Count)*4)+1 >= 100000000) {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file eta_d.mat.\n");
          }
        }
      }
    }
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* ToFile: '<S52>/eta3' */
    {
      if (!(++CSE1_Oculus_gesture_DW.eta3_IWORK_a.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.eta3_IWORK_a.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta3_PWORK_p.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.eta3_IWORK_a.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = CSE1_Oculus_gesture_B.Integrator1[0];
          u[2] = CSE1_Oculus_gesture_B.Integrator1[1];
          u[3] = CSE1_Oculus_gesture_B.Integrator1[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file nu_d.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.eta3_IWORK_a.Count)*4)+1 >= 100000000)
          {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file nu_d.mat.\n");
          }
        }
      }
    }
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* ToFile: '<S52>/eta5' */
    {
      if (!(++CSE1_Oculus_gesture_DW.eta5_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.eta5_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta5_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.eta5_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = CSE1_Oculus_gesture_B.MatrixMultiply_k[0];
          u[2] = CSE1_Oculus_gesture_B.MatrixMultiply_k[1];
          u[3] = CSE1_Oculus_gesture_B.MatrixMultiply_k[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file nu_oculus.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.eta5_IWORK.Count)*4)+1 >= 100000000) {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file nu_oculus.mat.\n");
          }
        }
      }
    }
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* SignalConversion: '<S52>/TmpSignal ConversionAteta4Inport1' */
    rtb_TmpSignalConversionAtetaInp[0] = CSE1_Oculus_gesture_B.Gain1;
    rtb_TmpSignalConversionAtetaInp[1] = CSE1_Oculus_gesture_B.Gain2;
    rtb_TmpSignalConversionAtetaInp[2] = CSE1_Oculus_gesture_B.Gain3;

    /* ToFile: '<S52>/eta4' */
    {
      if (!(++CSE1_Oculus_gesture_DW.eta4_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.eta4_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta4_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.eta4_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = rtb_TmpSignalConversionAtetaInp[0];
          u[2] = rtb_TmpSignalConversionAtetaInp[1];
          u[3] = rtb_TmpSignalConversionAtetaInp[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file oculus.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.eta4_IWORK.Count)*4)+1 >= 100000000) {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file oculus.mat.\n");
          }
        }
      }
    }

    /* SignalConversion: '<S52>/TmpSignal ConversionAteta2Inport1' */
    rtb_TmpSignalConversionAtetaInp[0] = CSE1_Oculus_gesture_B.x_ref;
    rtb_TmpSignalConversionAtetaInp[1] = CSE1_Oculus_gesture_B.y_ref;
    rtb_TmpSignalConversionAtetaInp[2] = CSE1_Oculus_gesture_B.MultiportSwitch_o;

    /* ToFile: '<S52>/eta2' */
    {
      if (!(++CSE1_Oculus_gesture_DW.eta2_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.eta2_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta2_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.eta2_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = rtb_TmpSignalConversionAtetaInp[0];
          u[2] = rtb_TmpSignalConversionAtetaInp[1];
          u[3] = rtb_TmpSignalConversionAtetaInp[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file ref.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.eta2_IWORK.Count)*4)+1 >= 100000000) {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file ref.mat.\n");
          }
        }
      }
    }

    /* ToFile: '<S52>/nu 1' */
    {
      if (!(++CSE1_Oculus_gesture_DW.nu1_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.nu1_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.nu1_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.nu1_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = CSE1_Oculus_gesture_B.MultiportSwitch[3];
          u[2] = CSE1_Oculus_gesture_B.MultiportSwitch[4];
          u[3] = CSE1_Oculus_gesture_B.MultiportSwitch[5];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file eta_dot_d.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.nu1_IWORK.Count)*4)+1 >= 100000000) {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file eta_dot_d.mat.\n");
          }
        }
      }
    }

    /* ToFile: '<S52>/nu_dot1' */
    {
      if (!(++CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.nu_dot1_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = CSE1_Oculus_gesture_B.Sum5[0];
          u[2] = CSE1_Oculus_gesture_B.Sum5[1];
          u[3] = CSE1_Oculus_gesture_B.Sum5[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file eta_ddot_d.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Count)*4)+1 >= 100000000)
          {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file eta_ddot_d.mat.\n");
          }
        }
      }
    }
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* ToFile: '<S53>/nu_hat ' */
    {
      if (!(++CSE1_Oculus_gesture_DW.nu_hat_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.nu_hat_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.nu_hat_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.nu_hat_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = CSE1_Oculus_gesture_B.nu[0];
          u[2] = CSE1_Oculus_gesture_B.nu[1];
          u[3] = CSE1_Oculus_gesture_B.nu[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file nu_hat.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.nu_hat_IWORK.Count)*4)+1 >= 100000000)
          {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file nu_hat.mat.\n");
          }
        }
      }
    }
  }

  /* Saturate: '<S60>/Saturation' */
  if (CSE1_Oculus_gesture_B.Sum > CSE1_Oculus_gesture_P.Saturation_UpperSat_o) {
    rtb_Row2 = CSE1_Oculus_gesture_P.Saturation_UpperSat_o;
  } else if (CSE1_Oculus_gesture_B.Sum <
             CSE1_Oculus_gesture_P.Saturation_LowerSat_l5) {
    rtb_Row2 = CSE1_Oculus_gesture_P.Saturation_LowerSat_l5;
  } else {
    rtb_Row2 = CSE1_Oculus_gesture_B.Sum;
  }

  /* End of Saturate: '<S60>/Saturation' */

  /* Signum: '<S60>/Sign' */
  if (rtb_Row2 < 0.0) {
    rtb_MultiportSwitch_idx_0 = -1.0;
  } else if (rtb_Row2 > 0.0) {
    rtb_MultiportSwitch_idx_0 = 1.0;
  } else if (rtb_Row2 == 0.0) {
    rtb_MultiportSwitch_idx_0 = 0.0;
  } else {
    rtb_MultiportSwitch_idx_0 = rtb_Row2;
  }

  /* Gain: '<S60>/Gain' incorporates:
   *  Signum: '<S60>/Sign'
   */
  rtb_Gain_c = CSE1_Oculus_gesture_P.Gain_Gain_pb * rtb_MultiportSwitch_idx_0;

  /* Sum: '<S60>/Sum1' */
  rtb_Row2 += rtb_Gain_c;

  /* Math: '<S60>/Math Function' incorporates:
   *  Constant: '<S60>/Constant'
   */
  rtb_Row2 = rt_remd_snf(rtb_Row2, CSE1_Oculus_gesture_P.Constant_Value_f);

  /* Sum: '<S60>/Sum' */
  CSE1_Oculus_gesture_B.Sum_a = rtb_Row2 - rtb_Gain_c;
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* SignalConversion: '<S54>/TmpSignal ConversionAtetaInport1' */
    rtb_TmpSignalConversionAtetaInp[0] = CSE1_Oculus_gesture_B.x;
    rtb_TmpSignalConversionAtetaInp[1] = CSE1_Oculus_gesture_B.y;
    rtb_TmpSignalConversionAtetaInp[2] = CSE1_Oculus_gesture_B.Sum_a;

    /* ToFile: '<S54>/eta' */
    {
      if (!(++CSE1_Oculus_gesture_DW.eta_IWORK.Decimation % 1) &&
          (CSE1_Oculus_gesture_DW.eta_IWORK.Count*4)+1 < 100000000 ) {
        FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta_PWORK.FilePtr;
        if (fp != (NULL)) {
          real_T u[4];
          CSE1_Oculus_gesture_DW.eta_IWORK.Decimation = 0;
          u[0] = CSE1_Oculus_gesture_M->Timing.t[1];
          u[1] = rtb_TmpSignalConversionAtetaInp[0];
          u[2] = rtb_TmpSignalConversionAtetaInp[1];
          u[3] = rtb_TmpSignalConversionAtetaInp[2];
          if (fwrite(u, sizeof(real_T), 4, fp) != 4) {
            rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                              "Error writing to MAT-file eta.mat");
            return;
          }

          if (((++CSE1_Oculus_gesture_DW.eta_IWORK.Count)*4)+1 >= 100000000) {
            (void)fprintf(stdout,
                          "*** The ToFile block will stop logging data before\n"
                          "    the simulation has ended, because it has reached\n"
                          "    the maximum number of elements (100000000)\n"
                          "    allowed in MAT-file eta.mat.\n");
          }
        }
      }
    }
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
  }
}

/* Model update function */
void CSE1_Oculus_gesture_update(void)
{
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* Update for Memory: '<S62>/Memory' */
    CSE1_Oculus_gesture_DW.Memory_PreviousInput =
      CSE1_Oculus_gesture_B.switch_signal;
  }

  /* Update for Integrator: '<S2>/Integrator' */
  CSE1_Oculus_gesture_DW.Integrator_IWORK.IcNeedsLoading = 0;

  /* Update for Integrator: '<S14>/Integrator1' */
  CSE1_Oculus_gesture_DW.Integrator1_IWORK.IcNeedsLoading = 0;
  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    /* Update for Delay: '<S46>/Delay' */
    CSE1_Oculus_gesture_DW.icLoad = 0U;
    CSE1_Oculus_gesture_DW.Delay_DSTATE[0] = CSE1_Oculus_gesture_B.eta_filtered
      [0];
    CSE1_Oculus_gesture_DW.Delay_DSTATE[1] = CSE1_Oculus_gesture_B.eta_filtered
      [1];
    CSE1_Oculus_gesture_DW.Delay_DSTATE[2] = CSE1_Oculus_gesture_B.eta_filtered
      [2];

    /* Update for Memory: '<S46>/Memory3' */
    CSE1_Oculus_gesture_DW.Memory3_PreviousInput[0] =
      CSE1_Oculus_gesture_B.eta_dot_filtered[0];
    CSE1_Oculus_gesture_DW.Memory3_PreviousInput[1] =
      CSE1_Oculus_gesture_B.eta_dot_filtered[1];
    CSE1_Oculus_gesture_DW.Memory3_PreviousInput[2] =
      CSE1_Oculus_gesture_B.eta_dot_filtered[2];
  }

  if (rtmIsMajorTimeStep(CSE1_Oculus_gesture_M)) {
    rt_ertODEUpdateContinuousStates(&CSE1_Oculus_gesture_M->solverInfo);
  }

  /* Update absolute time for base rate */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   * Timer of this task consists of two 32 bit unsigned integers.
   * The two integers represent the low bits Timing.clockTick0 and the high bits
   * Timing.clockTickH0. When the low bit overflows to 0, the high bits increment.
   */
  if (!(++CSE1_Oculus_gesture_M->Timing.clockTick0)) {
    ++CSE1_Oculus_gesture_M->Timing.clockTickH0;
  }

  CSE1_Oculus_gesture_M->Timing.t[0] = rtsiGetSolverStopTime
    (&CSE1_Oculus_gesture_M->solverInfo);

  {
    /* Update absolute timer for sample time: [0.01s, 0.0s] */
    /* The "clockTick1" counts the number of times the code of this task has
     * been executed. The absolute time is the multiplication of "clockTick1"
     * and "Timing.stepSize1". Size of "clockTick1" ensures timer will not
     * overflow during the application lifespan selected.
     * Timer of this task consists of two 32 bit unsigned integers.
     * The two integers represent the low bits Timing.clockTick1 and the high bits
     * Timing.clockTickH1. When the low bit overflows to 0, the high bits increment.
     */
    if (!(++CSE1_Oculus_gesture_M->Timing.clockTick1)) {
      ++CSE1_Oculus_gesture_M->Timing.clockTickH1;
    }

    CSE1_Oculus_gesture_M->Timing.t[1] =
      CSE1_Oculus_gesture_M->Timing.clockTick1 *
      CSE1_Oculus_gesture_M->Timing.stepSize1 +
      CSE1_Oculus_gesture_M->Timing.clockTickH1 *
      CSE1_Oculus_gesture_M->Timing.stepSize1 * 4294967296.0;
  }
}

/* Derivatives for root system: '<Root>' */
void CSE1_Oculus_gesture_derivatives(void)
{
  /* Derivatives for Integrator: '<S2>/Integrator' */
  {
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator_CSTATE[0] = CSE1_Oculus_gesture_B.Integrator1[0];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator_CSTATE[1] = CSE1_Oculus_gesture_B.Integrator1[1];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator_CSTATE[2] = CSE1_Oculus_gesture_B.Integrator1[2];
  }

  /* Derivatives for Integrator: '<S18>/Integrator1' */
  {
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator1_CSTATE[0] = CSE1_Oculus_gesture_B.Integrator3_o[0];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator1_CSTATE[1] = CSE1_Oculus_gesture_B.Integrator3_o[1];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator1_CSTATE[2] = CSE1_Oculus_gesture_B.Integrator3_o[2];
  }

  /* Derivatives for Integrator: '<S14>/Integrator1' */
  {
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator1_CSTATE_j[0] = CSE1_Oculus_gesture_B.Integrator3[0];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator1_CSTATE_j[1] = CSE1_Oculus_gesture_B.Integrator3[1];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator1_CSTATE_j[2] = CSE1_Oculus_gesture_B.Integrator3[2];
  }

  /* Derivatives for Integrator: '<S14>/Integrator3' */
  {
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator3_CSTATE[0] = CSE1_Oculus_gesture_B.Sum5[0];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator3_CSTATE[1] = CSE1_Oculus_gesture_B.Sum5[1];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator3_CSTATE[2] = CSE1_Oculus_gesture_B.Sum5[2];
  }

  /* Derivatives for Integrator: '<S8>/Integrator' */
  {
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator_CSTATE_i[0] =
      CSE1_Oculus_gesture_B.TmpSignalConversionAtMatrixMult[0];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator_CSTATE_i[1] =
      CSE1_Oculus_gesture_B.TmpSignalConversionAtMatrixMult[1];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator_CSTATE_i[2] =
      CSE1_Oculus_gesture_B.TmpSignalConversionAtMatrixMult[2];
  }

  /* Derivatives for Integrator: '<S14>/Integrator2' */
  {
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator2_CSTATE[0] = CSE1_Oculus_gesture_B.MatrixMultiply[0];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator2_CSTATE[1] = CSE1_Oculus_gesture_B.MatrixMultiply[1];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator2_CSTATE[2] = CSE1_Oculus_gesture_B.MatrixMultiply[2];
  }

  /* Derivatives for Integrator: '<S18>/Integrator2' */
  {
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator2_CSTATE_b[0] = CSE1_Oculus_gesture_B.MatrixMultiply_n[0];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator2_CSTATE_b[1] = CSE1_Oculus_gesture_B.MatrixMultiply_n[1];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator2_CSTATE_b[2] = CSE1_Oculus_gesture_B.MatrixMultiply_n[2];
  }

  /* Derivatives for Integrator: '<S18>/Integrator3' */
  {
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator3_CSTATE_f[0] = CSE1_Oculus_gesture_B.Sum5_o[0];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator3_CSTATE_f[1] = CSE1_Oculus_gesture_B.Sum5_o[1];
    ((XDot_CSE1_Oculus_gesture_T *) CSE1_Oculus_gesture_M->ModelData.derivs)
      ->Integrator3_CSTATE_f[2] = CSE1_Oculus_gesture_B.Sum5_o[2];
  }
}

/* Model initialize function */
void CSE1_Oculus_gesture_initialize(void)
{
  /* Start for ToFile: '<S5>/To File' */
  {
    char fileName[509] = "gains.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file gains.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,16,0,"ans")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file gains.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.ToFile_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.ToFile_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.ToFile_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S51>/tau' */
  {
    char fileName[509] = "tau.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file tau.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"tau")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file tau.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.tau_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.tau_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.tau_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S51>/eta3' */
  {
    char fileName[509] = "thrust.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file thrust.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"thrust")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file thrust.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.eta3_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.eta3_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.eta3_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S52>/eta1' */
  {
    char fileName[509] = "eta_d.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file eta_d.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"eta_d")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file eta_d.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.eta1_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.eta1_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.eta1_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S52>/eta3' */
  {
    char fileName[509] = "nu_d.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file nu_d.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"nu_d")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file nu_d.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.eta3_IWORK_a.Count = 0;
    CSE1_Oculus_gesture_DW.eta3_IWORK_a.Decimation = -1;
    CSE1_Oculus_gesture_DW.eta3_PWORK_p.FilePtr = fp;
  }

  /* Start for ToFile: '<S52>/eta5' */
  {
    char fileName[509] = "nu_oculus.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file nu_oculus.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"nu_oculus")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file nu_oculus.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.eta5_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.eta5_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.eta5_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S52>/eta4' */
  {
    char fileName[509] = "oculus.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file oculus.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"oculus")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file oculus.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.eta4_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.eta4_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.eta4_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S52>/eta2' */
  {
    char fileName[509] = "ref.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file ref.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"ref")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file ref.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.eta2_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.eta2_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.eta2_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S52>/nu 1' */
  {
    char fileName[509] = "eta_dot_d.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file eta_dot_d.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"eta_dot_d")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file eta_dot_d.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.nu1_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.nu1_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.nu1_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S52>/nu_dot1' */
  {
    char fileName[509] = "eta_ddot_d.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file eta_ddot_d.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"eta_ddot_d")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file eta_ddot_d.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.nu_dot1_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S53>/nu_hat ' */
  {
    char fileName[509] = "nu_hat.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file nu_hat.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"nu_hat")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file nu_hat.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.nu_hat_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.nu_hat_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.nu_hat_PWORK.FilePtr = fp;
  }

  /* Start for ToFile: '<S54>/eta' */
  {
    char fileName[509] = "eta.mat";
    FILE *fp = (NULL);
    if ((fp = fopen(fileName, "wb")) == (NULL)) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error creating .mat file eta.mat");
      return;
    }

    if (rt_WriteMat4FileHeader(fp,4,0,"eta")) {
      rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                        "Error writing mat file header to file eta.mat");
      return;
    }

    CSE1_Oculus_gesture_DW.eta_IWORK.Count = 0;
    CSE1_Oculus_gesture_DW.eta_IWORK.Decimation = -1;
    CSE1_Oculus_gesture_DW.eta_PWORK.FilePtr = fp;
  }

  CSE1_Oculus_gesture_PrevZCX.Integrator_Reset_ZCE = UNINITIALIZED_ZCSIG;
  CSE1_Oculus_gesture_PrevZCX.Integrator1_Reset_ZCE = UNINITIALIZED_ZCSIG;
  CSE1_Oculus_gesture_PrevZCX.Integrator1_Reset_ZCE_g = UNINITIALIZED_ZCSIG;
  CSE1_Oculus_gesture_PrevZCX.Integrator3_Reset_ZCE = UNINITIALIZED_ZCSIG;
  CSE1_Oculus_gesture_PrevZCX.Integrator_Reset_ZCE_h = UNINITIALIZED_ZCSIG;
  CSE1_Oculus_gesture_PrevZCX.Integrator2_Reset_ZCE = UNINITIALIZED_ZCSIG;
  CSE1_Oculus_gesture_PrevZCX.Integrator2_Reset_ZCE_p = UNINITIALIZED_ZCSIG;
  CSE1_Oculus_gesture_PrevZCX.Integrator3_Reset_ZCE_h = UNINITIALIZED_ZCSIG;

  /* InitializeConditions for Memory: '<S62>/Memory' */
  CSE1_Oculus_gesture_DW.Memory_PreviousInput = CSE1_Oculus_gesture_P.Memory_X0;

  /* InitializeConditions for Integrator: '<S2>/Integrator' */
  if (rtmIsFirstInitCond(CSE1_Oculus_gesture_M)) {
    CSE1_Oculus_gesture_X.Integrator_CSTATE[0] = 0.0;
    CSE1_Oculus_gesture_X.Integrator_CSTATE[1] = 0.0;
    CSE1_Oculus_gesture_X.Integrator_CSTATE[2] = 0.0;
  }

  CSE1_Oculus_gesture_DW.Integrator_IWORK.IcNeedsLoading = 1;

  /* InitializeConditions for Integrator: '<S18>/Integrator1' */
  CSE1_Oculus_gesture_X.Integrator1_CSTATE[0] =
    CSE1_Oculus_gesture_P.Integrator1_IC;
  CSE1_Oculus_gesture_X.Integrator1_CSTATE[1] =
    CSE1_Oculus_gesture_P.Integrator1_IC;
  CSE1_Oculus_gesture_X.Integrator1_CSTATE[2] =
    CSE1_Oculus_gesture_P.Integrator1_IC;

  /* InitializeConditions for Integrator: '<S14>/Integrator1' */
  if (rtmIsFirstInitCond(CSE1_Oculus_gesture_M)) {
    CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[0] = 0.0;
    CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[1] = 0.0;
    CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[2] = 0.0;
  }

  CSE1_Oculus_gesture_DW.Integrator1_IWORK.IcNeedsLoading = 1;

  /* InitializeConditions for Integrator: '<S14>/Integrator3' */
  CSE1_Oculus_gesture_X.Integrator3_CSTATE[0] =
    CSE1_Oculus_gesture_P.Integrator3_IC;
  CSE1_Oculus_gesture_X.Integrator3_CSTATE[1] =
    CSE1_Oculus_gesture_P.Integrator3_IC;
  CSE1_Oculus_gesture_X.Integrator3_CSTATE[2] =
    CSE1_Oculus_gesture_P.Integrator3_IC;

  /* InitializeConditions for Integrator: '<S8>/Integrator' */
  CSE1_Oculus_gesture_X.Integrator_CSTATE_i[0] =
    CSE1_Oculus_gesture_P.Integrator_IC;
  CSE1_Oculus_gesture_X.Integrator_CSTATE_i[1] =
    CSE1_Oculus_gesture_P.Integrator_IC;
  CSE1_Oculus_gesture_X.Integrator_CSTATE_i[2] =
    CSE1_Oculus_gesture_P.Integrator_IC;

  /* InitializeConditions for Delay: '<S46>/Delay' */
  CSE1_Oculus_gesture_DW.icLoad = 1U;

  /* InitializeConditions for Memory: '<S46>/Memory3' */
  CSE1_Oculus_gesture_DW.Memory3_PreviousInput[0] =
    CSE1_Oculus_gesture_P.Memory3_X0[0];
  CSE1_Oculus_gesture_DW.Memory3_PreviousInput[1] =
    CSE1_Oculus_gesture_P.Memory3_X0[1];
  CSE1_Oculus_gesture_DW.Memory3_PreviousInput[2] =
    CSE1_Oculus_gesture_P.Memory3_X0[2];

  /* InitializeConditions for Integrator: '<S14>/Integrator2' */
  CSE1_Oculus_gesture_X.Integrator2_CSTATE[0] =
    CSE1_Oculus_gesture_P.Integrator2_IC;
  CSE1_Oculus_gesture_X.Integrator2_CSTATE[1] =
    CSE1_Oculus_gesture_P.Integrator2_IC;
  CSE1_Oculus_gesture_X.Integrator2_CSTATE[2] =
    CSE1_Oculus_gesture_P.Integrator2_IC;

  /* InitializeConditions for Integrator: '<S18>/Integrator2' */
  CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[0] =
    CSE1_Oculus_gesture_P.Integrator2_IC_n;
  CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[1] =
    CSE1_Oculus_gesture_P.Integrator2_IC_n;
  CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[2] =
    CSE1_Oculus_gesture_P.Integrator2_IC_n;

  /* InitializeConditions for Integrator: '<S18>/Integrator3' */
  CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[0] =
    CSE1_Oculus_gesture_P.Integrator3_IC_i;
  CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[1] =
    CSE1_Oculus_gesture_P.Integrator3_IC_i;
  CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[2] =
    CSE1_Oculus_gesture_P.Integrator3_IC_i;

  /* set "at time zero" to false */
  if (rtmIsFirstInitCond(CSE1_Oculus_gesture_M)) {
    rtmSetFirstInitCond(CSE1_Oculus_gesture_M, 0);
  }
}

/* Model terminate function */
void CSE1_Oculus_gesture_terminate(void)
{
  /* Terminate for ToFile: '<S5>/To File' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.ToFile_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "gains.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file gains.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file gains.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 16,
           CSE1_Oculus_gesture_DW.ToFile_IWORK.Count, "ans")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for ans to MAT-file gains.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file gains.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.ToFile_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S51>/tau' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.tau_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "tau.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file tau.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file tau.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4, CSE1_Oculus_gesture_DW.tau_IWORK.Count,
           "tau")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for tau to MAT-file tau.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file tau.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.tau_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S51>/eta3' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta3_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "thrust.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file thrust.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file thrust.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4, CSE1_Oculus_gesture_DW.eta3_IWORK.Count,
           "thrust")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for thrust to MAT-file thrust.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file thrust.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.eta3_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S52>/eta1' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta1_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "eta_d.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file eta_d.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file eta_d.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4, CSE1_Oculus_gesture_DW.eta1_IWORK.Count,
           "eta_d")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for eta_d to MAT-file eta_d.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file eta_d.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.eta1_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S52>/eta3' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta3_PWORK_p.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "nu_d.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file nu_d.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file nu_d.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4,
           CSE1_Oculus_gesture_DW.eta3_IWORK_a.Count, "nu_d")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for nu_d to MAT-file nu_d.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file nu_d.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.eta3_PWORK_p.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S52>/eta5' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta5_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "nu_oculus.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file nu_oculus.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file nu_oculus.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4, CSE1_Oculus_gesture_DW.eta5_IWORK.Count,
           "nu_oculus")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for nu_oculus to MAT-file nu_oculus.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file nu_oculus.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.eta5_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S52>/eta4' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta4_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "oculus.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file oculus.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file oculus.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4, CSE1_Oculus_gesture_DW.eta4_IWORK.Count,
           "oculus")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for oculus to MAT-file oculus.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file oculus.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.eta4_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S52>/eta2' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta2_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "ref.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file ref.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file ref.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4, CSE1_Oculus_gesture_DW.eta2_IWORK.Count,
           "ref")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for ref to MAT-file ref.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file ref.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.eta2_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S52>/nu 1' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.nu1_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "eta_dot_d.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file eta_dot_d.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file eta_dot_d.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4, CSE1_Oculus_gesture_DW.nu1_IWORK.Count,
           "eta_dot_d")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for eta_dot_d to MAT-file eta_dot_d.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file eta_dot_d.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.nu1_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S52>/nu_dot1' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.nu_dot1_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "eta_ddot_d.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file eta_ddot_d.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file eta_ddot_d.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4,
           CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Count, "eta_ddot_d")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for eta_ddot_d to MAT-file eta_ddot_d.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file eta_ddot_d.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.nu_dot1_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S53>/nu_hat ' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.nu_hat_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "nu_hat.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file nu_hat.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file nu_hat.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4,
           CSE1_Oculus_gesture_DW.nu_hat_IWORK.Count, "nu_hat")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for nu_hat to MAT-file nu_hat.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file nu_hat.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.nu_hat_PWORK.FilePtr = (NULL);
    }
  }

  /* Terminate for ToFile: '<S54>/eta' */
  {
    FILE *fp = (FILE *) CSE1_Oculus_gesture_DW.eta_PWORK.FilePtr;
    if (fp != (NULL)) {
      char fileName[509] = "eta.mat";
      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file eta.mat");
        return;
      }

      if ((fp = fopen(fileName, "r+b")) == (NULL)) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error reopening MAT-file eta.mat");
        return;
      }

      if (rt_WriteMat4FileHeader(fp, 4, CSE1_Oculus_gesture_DW.eta_IWORK.Count,
           "eta")) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error writing header for eta to MAT-file eta.mat");
      }

      if (fclose(fp) == EOF) {
        rtmSetErrorStatus(CSE1_Oculus_gesture_M,
                          "Error closing MAT-file eta.mat");
        return;
      }

      CSE1_Oculus_gesture_DW.eta_PWORK.FilePtr = (NULL);
    }
  }
}

/*========================================================================*
 * Start of Classic call interface                                        *
 *========================================================================*/

/* Solver interface called by GRT_Main */
#ifndef USE_GENERATED_SOLVER

void rt_ODECreateIntegrationData(RTWSolverInfo *si)
{
  UNUSED_PARAMETER(si);
  return;
}                                      /* do nothing */

void rt_ODEDestroyIntegrationData(RTWSolverInfo *si)
{
  UNUSED_PARAMETER(si);
  return;
}                                      /* do nothing */

void rt_ODEUpdateContinuousStates(RTWSolverInfo *si)
{
  UNUSED_PARAMETER(si);
  return;
}                                      /* do nothing */

#endif

void MdlOutputs(int_T tid)
{
  CSE1_Oculus_gesture_output();
  UNUSED_PARAMETER(tid);
}

void MdlUpdate(int_T tid)
{
  CSE1_Oculus_gesture_update();
  UNUSED_PARAMETER(tid);
}

void MdlInitializeSizes(void)
{
}

void MdlInitializeSampleTimes(void)
{
}

void MdlInitialize(void)
{
}

void MdlStart(void)
{
  CSE1_Oculus_gesture_initialize();
}

void MdlTerminate(void)
{
  CSE1_Oculus_gesture_terminate();
}

/* Registration function */
RT_MODEL_CSE1_Oculus_gesture_T *CSE1_Oculus_gesture(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)CSE1_Oculus_gesture_M, 0,
                sizeof(RT_MODEL_CSE1_Oculus_gesture_T));

  {
    /* Setup solver object */
    rtsiSetSimTimeStepPtr(&CSE1_Oculus_gesture_M->solverInfo,
                          &CSE1_Oculus_gesture_M->Timing.simTimeStep);
    rtsiSetTPtr(&CSE1_Oculus_gesture_M->solverInfo, &rtmGetTPtr
                (CSE1_Oculus_gesture_M));
    rtsiSetStepSizePtr(&CSE1_Oculus_gesture_M->solverInfo,
                       &CSE1_Oculus_gesture_M->Timing.stepSize0);
    rtsiSetdXPtr(&CSE1_Oculus_gesture_M->solverInfo,
                 &CSE1_Oculus_gesture_M->ModelData.derivs);
    rtsiSetContStatesPtr(&CSE1_Oculus_gesture_M->solverInfo, (real_T **)
                         &CSE1_Oculus_gesture_M->ModelData.contStates);
    rtsiSetNumContStatesPtr(&CSE1_Oculus_gesture_M->solverInfo,
      &CSE1_Oculus_gesture_M->Sizes.numContStates);
    rtsiSetErrorStatusPtr(&CSE1_Oculus_gesture_M->solverInfo,
                          (&rtmGetErrorStatus(CSE1_Oculus_gesture_M)));
    rtsiSetRTModelPtr(&CSE1_Oculus_gesture_M->solverInfo, CSE1_Oculus_gesture_M);
  }

  rtsiSetSimTimeStep(&CSE1_Oculus_gesture_M->solverInfo, MAJOR_TIME_STEP);
  CSE1_Oculus_gesture_M->ModelData.intgData.y =
    CSE1_Oculus_gesture_M->ModelData.odeY;
  CSE1_Oculus_gesture_M->ModelData.intgData.f[0] =
    CSE1_Oculus_gesture_M->ModelData.odeF[0];
  CSE1_Oculus_gesture_M->ModelData.intgData.f[1] =
    CSE1_Oculus_gesture_M->ModelData.odeF[1];
  CSE1_Oculus_gesture_M->ModelData.intgData.f[2] =
    CSE1_Oculus_gesture_M->ModelData.odeF[2];
  CSE1_Oculus_gesture_M->ModelData.intgData.f[3] =
    CSE1_Oculus_gesture_M->ModelData.odeF[3];
  CSE1_Oculus_gesture_M->ModelData.contStates = ((real_T *)
    &CSE1_Oculus_gesture_X);
  rtsiSetSolverData(&CSE1_Oculus_gesture_M->solverInfo, (void *)
                    &CSE1_Oculus_gesture_M->ModelData.intgData);
  rtsiSetSolverName(&CSE1_Oculus_gesture_M->solverInfo,"ode4");

  /* Initialize timing info */
  {
    int_T *mdlTsMap = CSE1_Oculus_gesture_M->Timing.sampleTimeTaskIDArray;
    mdlTsMap[0] = 0;
    mdlTsMap[1] = 1;
    CSE1_Oculus_gesture_M->Timing.sampleTimeTaskIDPtr = (&mdlTsMap[0]);
    CSE1_Oculus_gesture_M->Timing.sampleTimes =
      (&CSE1_Oculus_gesture_M->Timing.sampleTimesArray[0]);
    CSE1_Oculus_gesture_M->Timing.offsetTimes =
      (&CSE1_Oculus_gesture_M->Timing.offsetTimesArray[0]);

    /* task periods */
    CSE1_Oculus_gesture_M->Timing.sampleTimes[0] = (0.0);
    CSE1_Oculus_gesture_M->Timing.sampleTimes[1] = (0.01);

    /* task offsets */
    CSE1_Oculus_gesture_M->Timing.offsetTimes[0] = (0.0);
    CSE1_Oculus_gesture_M->Timing.offsetTimes[1] = (0.0);
  }

  rtmSetTPtr(CSE1_Oculus_gesture_M, &CSE1_Oculus_gesture_M->Timing.tArray[0]);

  {
    int_T *mdlSampleHits = CSE1_Oculus_gesture_M->Timing.sampleHitArray;
    mdlSampleHits[0] = 1;
    mdlSampleHits[1] = 1;
    CSE1_Oculus_gesture_M->Timing.sampleHits = (&mdlSampleHits[0]);
  }

  rtmSetTFinal(CSE1_Oculus_gesture_M, -1);
  CSE1_Oculus_gesture_M->Timing.stepSize0 = 0.01;
  CSE1_Oculus_gesture_M->Timing.stepSize1 = 0.01;
  rtmSetFirstInitCond(CSE1_Oculus_gesture_M, 1);

  /* Setup for data logging */
  {
    static RTWLogInfo rt_DataLoggingInfo;
    CSE1_Oculus_gesture_M->rtwLogInfo = &rt_DataLoggingInfo;
  }

  /* Setup for data logging */
  {
    rtliSetLogXSignalInfo(CSE1_Oculus_gesture_M->rtwLogInfo, (NULL));
    rtliSetLogXSignalPtrs(CSE1_Oculus_gesture_M->rtwLogInfo, (NULL));
    rtliSetLogT(CSE1_Oculus_gesture_M->rtwLogInfo, "tout");
    rtliSetLogX(CSE1_Oculus_gesture_M->rtwLogInfo, "");
    rtliSetLogXFinal(CSE1_Oculus_gesture_M->rtwLogInfo, "");
    rtliSetLogVarNameModifier(CSE1_Oculus_gesture_M->rtwLogInfo, "rt_");
    rtliSetLogFormat(CSE1_Oculus_gesture_M->rtwLogInfo, 0);
    rtliSetLogMaxRows(CSE1_Oculus_gesture_M->rtwLogInfo, 1000);
    rtliSetLogDecimation(CSE1_Oculus_gesture_M->rtwLogInfo, 1);
    rtliSetLogY(CSE1_Oculus_gesture_M->rtwLogInfo, "");
    rtliSetLogYSignalInfo(CSE1_Oculus_gesture_M->rtwLogInfo, (NULL));
    rtliSetLogYSignalPtrs(CSE1_Oculus_gesture_M->rtwLogInfo, (NULL));
  }

  CSE1_Oculus_gesture_M->solverInfoPtr = (&CSE1_Oculus_gesture_M->solverInfo);
  CSE1_Oculus_gesture_M->Timing.stepSize = (0.01);
  rtsiSetFixedStepSize(&CSE1_Oculus_gesture_M->solverInfo, 0.01);
  rtsiSetSolverMode(&CSE1_Oculus_gesture_M->solverInfo,
                    SOLVER_MODE_SINGLETASKING);

  /* block I/O */
  CSE1_Oculus_gesture_M->ModelData.blockIO = ((void *) &CSE1_Oculus_gesture_B);
  (void) memset(((void *) &CSE1_Oculus_gesture_B), 0,
                sizeof(B_CSE1_Oculus_gesture_T));

  /* parameters */
  CSE1_Oculus_gesture_M->ModelData.defaultParam = ((real_T *)
    &CSE1_Oculus_gesture_P);

  /* states (continuous) */
  {
    real_T *x = (real_T *) &CSE1_Oculus_gesture_X;
    CSE1_Oculus_gesture_M->ModelData.contStates = (x);
    (void) memset((void *)&CSE1_Oculus_gesture_X, 0,
                  sizeof(X_CSE1_Oculus_gesture_T));
  }

  /* states (dwork) */
  CSE1_Oculus_gesture_M->ModelData.dwork = ((void *) &CSE1_Oculus_gesture_DW);
  (void) memset((void *)&CSE1_Oculus_gesture_DW, 0,
                sizeof(DW_CSE1_Oculus_gesture_T));

  /* Initialize Sizes */
  CSE1_Oculus_gesture_M->Sizes.numContStates = (24);/* Number of continuous states */
  CSE1_Oculus_gesture_M->Sizes.numY = (0);/* Number of model outputs */
  CSE1_Oculus_gesture_M->Sizes.numU = (0);/* Number of model inputs */
  CSE1_Oculus_gesture_M->Sizes.sysDirFeedThru = (0);/* The model is not direct feedthrough */
  CSE1_Oculus_gesture_M->Sizes.numSampTimes = (2);/* Number of sample times */
  CSE1_Oculus_gesture_M->Sizes.numBlocks = (284);/* Number of blocks */
  CSE1_Oculus_gesture_M->Sizes.numBlockIO = (128);/* Number of block outputs */
  CSE1_Oculus_gesture_M->Sizes.numBlockPrms = (634);/* Sum of parameter "widths" */
  return CSE1_Oculus_gesture_M;
}

/*========================================================================*
 * End of Classic call interface                                          *
 *========================================================================*/

/*========================================================================*
 * NI VeriStand Generated Code                                            *
 *========================================================================*
 * This file contains automatically generated code for functions
 * to update the inports and outports of a Simulink/Realtime Workshop
 * model. Calls to these functions should be made before each step is taken
 * (inports, call SetExternalInputs) and after each step is taken
 * (outports, call SetExternalOutputs.)
 */
#ifdef NI_ROOTMODEL_CSE1_Oculus_gesture
#include "model_info.h"
#include <stddef.h>
#include <stdlib.h>
#include <float.h>

unsigned char ReadSideDirtyFlag = 0, WriteSideDirtyFlag = 0;
double NIRT_GetValueByDataType(void* ptr,int subindex, int type, int Complex)
{
  switch (type)
  {
   case 0:
    return (double)(((real_T*)ptr)[subindex]);

   case 1:
    return (double)(((real32_T*)ptr)[subindex]);

   case 2:
    return (double)(((int8_T*)ptr)[subindex]);

   case 3:
    return (double)(((uint8_T*)ptr)[subindex]);

   case 4:
    return (double)(((int16_T*)ptr)[subindex]);

   case 5:
    return (double)(((uint16_T*)ptr)[subindex]);

   case 6:
    return (double)(((int32_T*)ptr)[subindex]);

   case 7:
    return (double)(((uint32_T*)ptr)[subindex]);

   case 8:
    return (double)(((boolean_T*)ptr)[subindex]);

   case 10:
    return NIRT_GetValueByDataType(ptr,subindex,6,Complex);

   case 13:
    return NIRT_GetValueByDataType(ptr,subindex,7,Complex);

   case 15:
    return NIRT_GetValueByDataType(ptr,subindex,6,Complex);

   case 16:
    return NIRT_GetValueByDataType(ptr,subindex,6,Complex);

   case 17:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 18:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 19:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 20:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 21:
    return NIRT_GetValueByDataType(ptr,subindex,3,Complex);

   case 22:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 23:
    return NIRT_GetValueByDataType(ptr,subindex,3,Complex);

   case 24:
    return NIRT_GetValueByDataType(ptr,subindex,10,Complex);

   case 25:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 28:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 29:
    return NIRT_GetValueByDataType(ptr,subindex,8,Complex);

   case 45:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 46:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 47:
    return NIRT_GetValueByDataType(ptr,subindex,7,Complex);

   case 48:
    return NIRT_GetValueByDataType(ptr,subindex,0,Complex);

   case 49:
    return NIRT_GetValueByDataType(ptr,subindex,7,Complex);
  }

  // return ((double *)ptr)[subindex];
  return rtNaN;
}

long NIRT_SetValueByDataType(void* ptr,int subindex, double value, int type, int
  Complex)
{
  //Complex is only used for R14.3 and down
  switch (type)
  {
   case 0:
    ((real_T *)ptr)[subindex] = (real_T)value;
    return NI_OK;

   case 1:
    ((real32_T *)ptr)[subindex] = (real32_T)value;
    return NI_OK;

   case 2:
    ((int8_T *)ptr)[subindex] = (int8_T)value;
    return NI_OK;

   case 3:
    ((uint8_T *)ptr)[subindex] = (uint8_T)value;
    return NI_OK;

   case 4:
    ((int16_T *)ptr)[subindex] = (int16_T)value;
    return NI_OK;

   case 5:
    ((uint16_T *)ptr)[subindex] = (uint16_T)value;
    return NI_OK;

   case 6:
    ((int32_T *)ptr)[subindex] = (int32_T)value;
    return NI_OK;

   case 7:
    ((uint32_T *)ptr)[subindex] = (uint32_T)value;
    return NI_OK;

   case 8:
    ((boolean_T *)ptr)[subindex] = (boolean_T)value;
    return NI_OK;

   case 10:
    //Type is renamed. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,6,Complex);

   case 13:
    //Type is array. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,7,Complex);

   case 15:
    //Type is enum. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,6,Complex);

   case 16:
    //Type is enum. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,6,Complex);

   case 17:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 18:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 19:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 20:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 21:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,3,Complex);

   case 22:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 23:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,3,Complex);

   case 24:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,10,Complex);

   case 25:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 28:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 29:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,8,Complex);

   case 45:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 46:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 47:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,7,Complex);

   case 48:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,0,Complex);

   case 49:
    //Type is matrix. Call SetValueByDataType on its contained type
    return NIRT_SetValueByDataType(ptr,subindex,value,7,Complex);
  }

  //No matching datatype conversion
  return NI_ERROR;
}

extern CSE1_Oculus_gesture_rtModel *S;
extern _SITexportglobals SITexportglobals;
void SetExternalInputs(double* data, int* TaskSampleHit)
{
  int index = 0, count = 0;

  // ctrl_out/sixaxis/Triangle
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Triangle, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/sixaxis/Circle
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Circle, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/sixaxis/Cross
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Cross, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/sixaxis/Square
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Square, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Control Gains/K_p_x
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_p_x, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Control Gains/K_p_y
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_p_y, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Control Gains/K_p_psi
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_p_psi, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Control Gains/K_i_psi
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_i_psi, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Control Gains/K_i_x
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_i_x, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Control Gains/K_i_y
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_i_y, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Control Gains/K_d_psi
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_d_psi, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Control Gains/K_d_x
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_d_x, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Control Gains/K_d_y
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_d_y, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/psi
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.psi, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/reset
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.reset, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Observer Gains/Filter 1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Filter1, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Observer Gains/Filter 2
  if (TaskSampleHit[1]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Filter2, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Observer Gains/Filter 3
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Filter3, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/VSP_on
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.VSP_on, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/DP guidance/zeta_y
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.zeta_y, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/DP guidance/w_d_psi
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.w_d_psi, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/DP guidance/w_d_x
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.w_d_x, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/DP guidance/w_d_y
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.w_d_y, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/DP guidance/zeta_psi
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.zeta_psi, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/DP guidance/zeta_x
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.zeta_x, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Oculus_ref_on_off
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Oculus_ref_on_off, 0,
      data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/psi_ref
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.psi_ref, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Oculus_yaw
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Oculus_yaw, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // Input/x_ref
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.x_ref, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/y_ref
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.y_ref, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/x
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.x, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/y
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.y, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Gesture_off
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Gesture_off, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/Gesture guidance/zeta_y
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.zeta_y_k, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/Gesture guidance/w_d_psi
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.w_d_psi_d, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/Gesture guidance/w_d_x
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.w_d_x_l, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/Gesture guidance/w_d_y
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.w_d_y_c, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/Gesture guidance/zeta_psi
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.zeta_psi_i, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // Input/Guidance gains/Gesture guidance/zeta_x
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.zeta_x_m, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // Input/Gesture based ctrl/K_u
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_u, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Gesture based ctrl/K_v
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_v, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Gesture based ctrl/K_r
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.K_r, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // Input/Oculus_roll
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Oculus_roll, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // Input/Oculus_pitch
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.Oculus_pitch, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2force/u_BT
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.u_BT, 0, data[index++], 0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2force/u_VSP2
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.u_VSP2, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2force/omega_VSP1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.omega_VSP1, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2force/omega_VSP2
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.omega_VSP2, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2force/u_VSP1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.u_VSP1, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2force/alpha_VSP1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.alpha_VSP1, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2force/alpha_VSP2
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.alpha_VSP2, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_DP_basic/u_BT
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.u_BT_c, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_DP_basic/u_VSP2
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.u_VSP2_c, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_DP_basic/omega_VSP1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.omega_VSP1_a, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_DP_basic/omega_VSP2
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.omega_VSP2_f, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_DP_basic/u_VSP1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.u_VSP1_d, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_DP_basic/alpha_VSP1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.alpha_VSP1_i, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_DP_basic/alpha_VSP2
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.alpha_VSP2_f, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2thruster/u_BT
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.u_BT_f, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2thruster/u_VSP2
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.u_VSP2_o, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2thruster/omega_VSP1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.omega_VSP1_k, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2thruster/omega_VSP2
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.omega_VSP2_b, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2thruster/u_VSP1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.u_VSP1_g, 0, data[index++], 0,
      0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2thruster/alpha_VSP1
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.alpha_VSP1_o, 0, data[index++],
      0, 0);
  } else {
    index += 1;
  }

  // ctrl_out/ctrl_sixaxis2thruster/alpha_VSP2
  if (TaskSampleHit[0]) {
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_B.alpha_VSP2_f2, 0, data[index
      ++], 0, 0);
  } else {
    index += 1;
  }
}                                      /* of SetExternalInputs */

long NumInputPorts(void)
{
  return 65;
}

double ni_extout[30];
void SetExternalOutputs(double* data, int* TaskSampleHit)
{
  int index = 0, count = 0;

  // ctrl_out/alpha_VSP2: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Saturation4,0,0,0);
  } else {
    index += 1;
  }

  // ctrl_out/u_BT: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Saturation,0,0,0);
  } else {
    index += 1;
  }

  // ctrl_out/u_VSP1: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Saturation1,0,0,0);
  } else {
    index += 1;
  }

  // ctrl_out/u_VSP2: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Saturation2,0,0,0);
  } else {
    index += 1;
  }

  // ctrl_out/alpha_VSP1: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Saturation3,0,0,0);
  } else {
    index += 1;
  }

  // ctrl_out/omega_VSP1: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Saturation5,0,0,0);
  } else {
    index += 1;
  }

  // ctrl_out/omega_VSP2: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Saturation6,0,0,0);
  } else {
    index += 1;
  }

  // ctrl_out/control input u exceeds bounds: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.fault,0,
      8,0);
  } else {
    index += 1;
  }

  // ctrl_out/indicator/ctrl_DP_basic: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.ctrl_DP_basic,0,8,0);
  } else {
    index += 1;
  }

  // ctrl_out/indicator/ctrl_sixaxis2force: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.ctrl_sixaxis2force,0,8,0);
  } else {
    index += 1;
  }

  // ctrl_out/indicator/ctrl_sixaxis2thruster: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.ctrl_sixaxis2thruster,0,8,0);
  } else {
    index += 1;
  }

  // ctrl_out/indicator/ctrl_student: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.ctrl_student,0,8,0);
  } else {
    index += 1;
  }

  // Output/Control output/tau_N: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum1,2,
      17,0);
  } else {
    index += 1;
  }

  // Output/Control output/tau_X: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum1,0,
      17,0);
  } else {
    index += 1;
  }

  // Output/Control output/tau_Y: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum1,1,
      17,0);
  } else {
    index += 1;
  }

  // Output/Guidance output/x_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.MultiportSwitch,0,20,0);
  } else {
    index += 1;
  }

  // Output/Guidance output/y_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.MultiportSwitch,1,20,0);
  } else {
    index += 1;
  }

  // Output/Guidance output/psi_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum_p,0,
      0,0);
  } else {
    index += 1;
  }

  // Output/Guidance output/r_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Integrator1,2,17,0);
  } else {
    index += 1;
  }

  // Output/Guidance output/u_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Integrator1,0,17,0);
  } else {
    index += 1;
  }

  // Output/Guidance output/v_d: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.Integrator1,1,17,0);
  } else {
    index += 1;
  }

  // Output/Guidance output/r_oculus: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.MatrixMultiply_k,2,17,0);
  } else {
    index += 1;
  }

  // Output/Guidance output/u_oculus: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.MatrixMultiply_k,0,17,0);
  } else {
    index += 1;
  }

  // Output/Guidance output/v_oculus: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_B.MatrixMultiply_k,1,17,0);
  } else {
    index += 1;
  }

  // Output/Navigation output/r_hat: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.nu,2,17,
      0);
  } else {
    index += 1;
  }

  // Output/Navigation output/u_hat: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.nu,0,17,
      0);
  } else {
    index += 1;
  }

  // Output/Navigation output/v_hat: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.nu,1,17,
      0);
  } else {
    index += 1;
  }

  // Output/Plant output/x: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.x,0,0,0);
  } else {
    index += 1;
  }

  // Output/Plant output/y: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.y,0,0,0);
  } else {
    index += 1;
  }

  // Output/Plant output/psi: Virtual Signal # 0
  if (TaskSampleHit[0]) {              // sample and hold
    ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum_a,0,
      0,0);
  } else {
    index += 1;
  }

  if (data)
    memcpy(&data[0], &ni_extout[0], sizeof(ni_extout));
}

long NumOutputPorts(void)
{
  return 30;
}

int NI_InitExternalOutputs()
{
  int index = 0, count = 0;

  // ctrl_out/alpha_VSP2: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.Saturation4,0,0,0);

  // ctrl_out/u_BT: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Saturation,
    0,0,0);

  // ctrl_out/u_VSP1: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.Saturation1,0,0,0);

  // ctrl_out/u_VSP2: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.Saturation2,0,0,0);

  // ctrl_out/alpha_VSP1: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.Saturation3,0,0,0);

  // ctrl_out/omega_VSP1: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.Saturation5,0,0,0);

  // ctrl_out/omega_VSP2: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.Saturation6,0,0,0);

  // ctrl_out/control input u exceeds bounds: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.fault,0,8,
    0);

  // ctrl_out/indicator/ctrl_DP_basic: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.ctrl_DP_basic,0,8,0);

  // ctrl_out/indicator/ctrl_sixaxis2force: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.ctrl_sixaxis2force,0,8,0);

  // ctrl_out/indicator/ctrl_sixaxis2thruster: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.ctrl_sixaxis2thruster,0,8,0);

  // ctrl_out/indicator/ctrl_student: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.ctrl_student,0,8,0);

  // Output/Control output/tau_N: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum1,2,17,
    0);

  // Output/Control output/tau_X: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum1,0,17,
    0);

  // Output/Control output/tau_Y: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum1,1,17,
    0);

  // Output/Guidance output/x_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.MultiportSwitch,0,20,0);

  // Output/Guidance output/y_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.MultiportSwitch,1,20,0);

  // Output/Guidance output/psi_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum_p,0,0,
    0);

  // Output/Guidance output/r_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.Integrator1,2,17,0);

  // Output/Guidance output/u_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.Integrator1,0,17,0);

  // Output/Guidance output/v_d: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.Integrator1,1,17,0);

  // Output/Guidance output/r_oculus: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.MatrixMultiply_k,2,17,0);

  // Output/Guidance output/u_oculus: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.MatrixMultiply_k,0,17,0);

  // Output/Guidance output/v_oculus: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType
    (&CSE1_Oculus_gesture_B.MatrixMultiply_k,1,17,0);

  // Output/Navigation output/r_hat: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.nu,2,17,0);

  // Output/Navigation output/u_hat: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.nu,0,17,0);

  // Output/Navigation output/v_hat: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.nu,1,17,0);

  // Output/Plant output/x: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.x,0,0,0);

  // Output/Plant output/y: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.y,0,0,0);

  // Output/Plant output/psi: Virtual Signal # 0
  ni_extout[index++] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_B.Sum_a,0,0,
    0);
  return NI_OK;
}

// by default, all elements (inclulding	scalars) have 2 dimensions [1,1]
static NI_Parameter NI_ParamList[] DataSection(".NIVS.paramlist") =
{
  { 0, "cse1_oculus_gesture/ctrl_out/Switch_subsystem/Memory/X0", offsetof
    (P_CSE1_Oculus_gesture_T, Memory_X0), 45, 1, 2, 0, 0 },

  { 1, "cse1_oculus_gesture/Input/[-inf inf] to [-pi pi]/Saturation/UpperLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_UpperSat), 45, 1, 2, 2, 0 },

  { 2, "cse1_oculus_gesture/Input/[-inf inf] to [-pi pi]/Saturation/LowerLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_LowerSat), 45, 1, 2, 4, 0 },

  { 3, "cse1_oculus_gesture/Input/[-inf inf] to [-pi pi]/Gain/Gain", offsetof
    (P_CSE1_Oculus_gesture_T, Gain_Gain), 45, 1, 2, 6, 0 },

  { 4, "cse1_oculus_gesture/Input/[-inf inf] to [-pi pi]/Constant/Value",
    offsetof(P_CSE1_Oculus_gesture_T, Constant_Value), 45, 1, 2, 8, 0 },

  { 5, "cse1_oculus_gesture/Input/Subsystem1/Gain3/Gain", offsetof
    (P_CSE1_Oculus_gesture_T, Gain3_Gain), 45, 1, 2, 10, 0 },

  { 6, "cse1_oculus_gesture/Input/Subsystem1/Gain1/Gain", offsetof
    (P_CSE1_Oculus_gesture_T, Gain1_Gain), 45, 1, 2, 12, 0 },

  { 7,
    "cse1_oculus_gesture/Control/DP Controller/[-inf inf] to [-pi pi]1/Saturation/UpperLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_UpperSat_d), 45, 1, 2, 14, 0 },

  { 8,
    "cse1_oculus_gesture/Control/DP Controller/[-inf inf] to [-pi pi]1/Saturation/LowerLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_LowerSat_l), 45, 1, 2, 16, 0 },

  { 9,
    "cse1_oculus_gesture/Control/DP Controller/[-inf inf] to [-pi pi]1/Gain/Gain",
    offsetof(P_CSE1_Oculus_gesture_T, Gain_Gain_n), 45, 1, 2, 18, 0 },

  { 10,
    "cse1_oculus_gesture/Control/DP Controller/[-inf inf] to [-pi pi]1/Constant/Value",
    offsetof(P_CSE1_Oculus_gesture_T, Constant_Value_d), 45, 1, 2, 20, 0 },

  { 11,
    "cse1_oculus_gesture/Guidance/[-inf inf] to [-pi pi]1/Saturation/UpperLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_UpperSat_dc), 45, 1, 2, 22, 0 },

  { 12,
    "cse1_oculus_gesture/Guidance/[-inf inf] to [-pi pi]1/Saturation/LowerLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_LowerSat_e), 45, 1, 2, 24, 0 },

  { 13, "cse1_oculus_gesture/Guidance/[-inf inf] to [-pi pi]1/Gain/Gain",
    offsetof(P_CSE1_Oculus_gesture_T, Gain_Gain_e), 45, 1, 2, 26, 0 },

  { 14, "cse1_oculus_gesture/Guidance/[-inf inf] to [-pi pi]1/Constant/Value",
    offsetof(P_CSE1_Oculus_gesture_T, Constant_Value_j), 45, 1, 2, 28, 0 },

  { 15,
    "cse1_oculus_gesture/Guidance/Vel Reference model1/Integrator1/InitialCondition",
    offsetof(P_CSE1_Oculus_gesture_T, Integrator1_IC), 45, 1, 2, 30, 0 },

  { 16,
    "cse1_oculus_gesture/Guidance/Reference model/Integrator3/InitialCondition",
    offsetof(P_CSE1_Oculus_gesture_T, Integrator3_IC), 45, 1, 2, 32, 0 },

  { 17,
    "cse1_oculus_gesture/Guidance/Inf,inf tto pi,pi/[-inf inf] to [-pi pi]/Saturation/UpperLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_UpperSat_c), 45, 1, 2, 34, 0 },

  { 18,
    "cse1_oculus_gesture/Guidance/Inf,inf tto pi,pi/[-inf inf] to [-pi pi]/Saturation/LowerLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_LowerSat_n), 45, 1, 2, 36, 0 },

  { 19,
    "cse1_oculus_gesture/Guidance/Inf,inf tto pi,pi/[-inf inf] to [-pi pi]/Gain/Gain",
    offsetof(P_CSE1_Oculus_gesture_T, Gain_Gain_l), 45, 1, 2, 38, 0 },

  { 20,
    "cse1_oculus_gesture/Guidance/Inf,inf tto pi,pi/[-inf inf] to [-pi pi]/Constant/Value",
    offsetof(P_CSE1_Oculus_gesture_T, Constant_Value_e), 45, 1, 2, 40, 0 },

  { 21,
    "cse1_oculus_gesture/Control/DP Controller/[-inf inf] to [-pi pi]/Saturation/UpperLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_UpperSat_g), 45, 1, 2, 42, 0 },

  { 22,
    "cse1_oculus_gesture/Control/DP Controller/[-inf inf] to [-pi pi]/Saturation/LowerLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_LowerSat_et), 45, 1, 2, 44, 0 },

  { 23,
    "cse1_oculus_gesture/Control/DP Controller/[-inf inf] to [-pi pi]/Gain/Gain",
    offsetof(P_CSE1_Oculus_gesture_T, Gain_Gain_p), 45, 1, 2, 46, 0 },

  { 24,
    "cse1_oculus_gesture/Control/DP Controller/[-inf inf] to [-pi pi]/Constant/Value",
    offsetof(P_CSE1_Oculus_gesture_T, Constant_Value_c), 45, 1, 2, 48, 0 },

  { 25, "cse1_oculus_gesture/Control/DP Controller/Integrator/InitialCondition",
    offsetof(P_CSE1_Oculus_gesture_T, Integrator_IC), 45, 1, 2, 50, 0 },

  { 26, "cse1_oculus_gesture/Navigation /Derivative filter/Constant1/Value",
    offsetof(P_CSE1_Oculus_gesture_T, Constant1_Value), 45, 1, 2, 52, 0 },

  { 27, "cse1_oculus_gesture/Navigation /Derivative filter/Memory3/X0", offsetof
    (P_CSE1_Oculus_gesture_T, Memory3_X0), 46, 3, 2, 54, 0 },

  { 28, "cse1_oculus_gesture/ctrl_out/Saturation4/UpperLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation4_UpperSat), 45, 1, 2, 56, 0 },

  { 29, "cse1_oculus_gesture/ctrl_out/Saturation4/LowerLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation4_LowerSat), 45, 1, 2, 58, 0 },

  { 30, "cse1_oculus_gesture/ctrl_out/Saturation/UpperLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation_UpperSat_b), 45, 1, 2, 60, 0 },

  { 31, "cse1_oculus_gesture/ctrl_out/Saturation/LowerLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation_LowerSat_nv), 45, 1, 2, 62, 0 },

  { 32, "cse1_oculus_gesture/ctrl_out/Saturation1/UpperLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation1_UpperSat), 45, 1, 2, 64, 0 },

  { 33, "cse1_oculus_gesture/ctrl_out/Saturation1/LowerLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation1_LowerSat), 45, 1, 2, 66, 0 },

  { 34, "cse1_oculus_gesture/ctrl_out/Saturation2/UpperLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation2_UpperSat), 45, 1, 2, 68, 0 },

  { 35, "cse1_oculus_gesture/ctrl_out/Saturation2/LowerLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation2_LowerSat), 45, 1, 2, 70, 0 },

  { 36, "cse1_oculus_gesture/ctrl_out/Saturation3/UpperLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation3_UpperSat), 45, 1, 2, 72, 0 },

  { 37, "cse1_oculus_gesture/ctrl_out/Saturation3/LowerLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation3_LowerSat), 45, 1, 2, 74, 0 },

  { 38, "cse1_oculus_gesture/ctrl_out/Saturation5/UpperLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation5_UpperSat), 45, 1, 2, 76, 0 },

  { 39, "cse1_oculus_gesture/ctrl_out/Saturation5/LowerLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation5_LowerSat), 45, 1, 2, 78, 0 },

  { 40, "cse1_oculus_gesture/ctrl_out/Saturation6/UpperLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation6_UpperSat), 45, 1, 2, 80, 0 },

  { 41, "cse1_oculus_gesture/ctrl_out/Saturation6/LowerLimit", offsetof
    (P_CSE1_Oculus_gesture_T, Saturation6_LowerSat), 45, 1, 2, 82, 0 },

  { 42,
    "cse1_oculus_gesture/Guidance/Reference model/Integrator2/InitialCondition",
    offsetof(P_CSE1_Oculus_gesture_T, Integrator2_IC), 45, 1, 2, 84, 0 },

  { 43,
    "cse1_oculus_gesture/Guidance/Vel Reference model1/Integrator2/InitialCondition",
    offsetof(P_CSE1_Oculus_gesture_T, Integrator2_IC_n), 45, 1, 2, 86, 0 },

  { 44,
    "cse1_oculus_gesture/Guidance/Vel Reference model1/Integrator3/InitialCondition",
    offsetof(P_CSE1_Oculus_gesture_T, Integrator3_IC_i), 45, 1, 2, 88, 0 },

  { 45, "cse1_oculus_gesture/Input/Subsystem1/Gain2/Gain", offsetof
    (P_CSE1_Oculus_gesture_T, Gain2_Gain), 45, 1, 2, 90, 0 },

  { 46, "cse1_oculus_gesture/Input/Gesture based ctrl/Gain/Gain", offsetof
    (P_CSE1_Oculus_gesture_T, Gain_Gain_f), 45, 1, 2, 92, 0 },

  { 47, "cse1_oculus_gesture/Input/Gesture based ctrl/T_b/Gain", offsetof
    (P_CSE1_Oculus_gesture_T, T_b_Gain), 18, 9, 2, 94, 0 },

  { 48,
    "cse1_oculus_gesture/Output/Plant output/[-inf inf] to [-pi pi]/Saturation/UpperLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_UpperSat_o), 45, 1, 2, 96, 0 },

  { 49,
    "cse1_oculus_gesture/Output/Plant output/[-inf inf] to [-pi pi]/Saturation/LowerLimit",
    offsetof(P_CSE1_Oculus_gesture_T, Saturation_LowerSat_l5), 45, 1, 2, 98, 0 },

  { 50,
    "cse1_oculus_gesture/Output/Plant output/[-inf inf] to [-pi pi]/Gain/Gain",
    offsetof(P_CSE1_Oculus_gesture_T, Gain_Gain_pb), 45, 1, 2, 100, 0 },

  { 51,
    "cse1_oculus_gesture/Output/Plant output/[-inf inf] to [-pi pi]/Constant/Value",
    offsetof(P_CSE1_Oculus_gesture_T, Constant_Value_f), 45, 1, 2, 102, 0 },

  { 52, "cse1_oculus_gesture/Navigation /Derivative filter/Delay/DelayLength",
    offsetof(P_CSE1_Oculus_gesture_T, Delay_DelayLength), 47, 1, 2, 104, 0 },
};

static int NI_ParamListSize DataSection(".NIVS.paramlistsize") = 53;
static int NI_ParamDimList[] DataSection(".NIVS.paramdimlist") =
{
  1, 1,                                /* Parameter at index 0 */
  1, 1,                                /* Parameter at index 1 */
  1, 1,                                /* Parameter at index 2 */
  1, 1,                                /* Parameter at index 3 */
  1, 1,                                /* Parameter at index 4 */
  1, 1,                                /* Parameter at index 5 */
  1, 1,                                /* Parameter at index 6 */
  1, 1,                                /* Parameter at index 7 */
  1, 1,                                /* Parameter at index 8 */
  1, 1,                                /* Parameter at index 9 */
  1, 1,                                /* Parameter at index 10 */
  1, 1,                                /* Parameter at index 11 */
  1, 1,                                /* Parameter at index 12 */
  1, 1,                                /* Parameter at index 13 */
  1, 1,                                /* Parameter at index 14 */
  1, 1,                                /* Parameter at index 15 */
  1, 1,                                /* Parameter at index 16 */
  1, 1,                                /* Parameter at index 17 */
  1, 1,                                /* Parameter at index 18 */
  1, 1,                                /* Parameter at index 19 */
  1, 1,                                /* Parameter at index 20 */
  1, 1,                                /* Parameter at index 21 */
  1, 1,                                /* Parameter at index 22 */
  1, 1,                                /* Parameter at index 23 */
  1, 1,                                /* Parameter at index 24 */
  1, 1,                                /* Parameter at index 25 */
  1, 1,                                /* Parameter at index 26 */
  1, 3,                                /* Parameter at index 27 */
  1, 1,                                /* Parameter at index 28 */
  1, 1,                                /* Parameter at index 29 */
  1, 1,                                /* Parameter at index 30 */
  1, 1,                                /* Parameter at index 31 */
  1, 1,                                /* Parameter at index 32 */
  1, 1,                                /* Parameter at index 33 */
  1, 1,                                /* Parameter at index 34 */
  1, 1,                                /* Parameter at index 35 */
  1, 1,                                /* Parameter at index 36 */
  1, 1,                                /* Parameter at index 37 */
  1, 1,                                /* Parameter at index 38 */
  1, 1,                                /* Parameter at index 39 */
  1, 1,                                /* Parameter at index 40 */
  1, 1,                                /* Parameter at index 41 */
  1, 1,                                /* Parameter at index 42 */
  1, 1,                                /* Parameter at index 43 */
  1, 1,                                /* Parameter at index 44 */
  1, 1,                                /* Parameter at index 45 */
  1, 1,                                /* Parameter at index 46 */
  3, 3,                                /* Parameter at index 47 */
  1, 1,                                /* Parameter at index 48 */
  1, 1,                                /* Parameter at index 49 */
  1, 1,                                /* Parameter at index 50 */
  1, 1,                                /* Parameter at index 51 */
  1, 1,                                /* Parameter at index 52 */
};

static NI_Signal NI_SigList[] DataSection(".NIVS.siglist") =
{
  { 0, "cse1_oculus_gesture/ctrl_out/sixaxis/Triangle", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Triangle)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    0, 0 },

  { 1, "cse1_oculus_gesture/ctrl_out/sixaxis/Circle", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Circle)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 2,
    0 },

  { 2, "cse1_oculus_gesture/ctrl_out/sixaxis/Cross", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Cross)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 4,
    0 },

  { 3, "cse1_oculus_gesture/ctrl_out/sixaxis/Square", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Square)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 6,
    0 },

  { 4, "cse1_oculus_gesture/ctrl_out/Switch_subsystem/Memory", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Memory)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 8,
    0 },

  { 5, "cse1_oculus_gesture/Input/Control Gains/K_p_x", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_p_x)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 10,
    0 },

  { 6, "cse1_oculus_gesture/Input/Control Gains/K_p_y", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_p_y)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 12,
    0 },

  { 7, "cse1_oculus_gesture/Input/Control Gains/K_p_psi", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_p_psi)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    14, 0 },

  { 8, "cse1_oculus_gesture/Input/Control Gains/K_i_psi", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_i_psi)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    16, 0 },

  { 9, "cse1_oculus_gesture/Input/Control Gains/K_i_x", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_i_x)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 18,
    0 },

  { 10, "cse1_oculus_gesture/Input/Control Gains/K_i_y", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_i_y)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 20,
    0 },

  { 11, "cse1_oculus_gesture/Input/Control Gains/K_d_psi", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_d_psi)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    22, 0 },

  { 12, "cse1_oculus_gesture/Input/Control Gains/K_d_x", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_d_x)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 24,
    0 },

  { 13, "cse1_oculus_gesture/Input/Control Gains/K_d_y", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_d_y)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 26,
    0 },

  { 14, "cse1_oculus_gesture/Input/psi", 0, "", offsetof(B_CSE1_Oculus_gesture_T,
    psi)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 28, 0 },

  { 15, "cse1_oculus_gesture/Input/[-inf inf] to [-pi pi]/Sum", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Sum)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 30, 0
  },

  { 16, "cse1_oculus_gesture/Input/reset", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, reset)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 32,
    0 },

  { 17, "cse1_oculus_gesture/Input/Observer Gains/Filter 1", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Filter1)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    34, 0 },

  { 18, "cse1_oculus_gesture/Input/Observer Gains/Filter 2", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Filter2)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    36, 0 },

  { 19, "cse1_oculus_gesture/Input/Observer Gains/Filter 3", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Filter3)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    38, 0 },

  { 20, "cse1_oculus_gesture/Input/VSP_on", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, VSP_on)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 40,
    0 },

  { 21, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/zeta_y", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, zeta_y)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 42, 0 },

  { 22, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/w_d_psi", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, w_d_psi)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 44, 0 },

  { 23, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/w_d_x", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, w_d_x)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 46, 0 },

  { 24, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/w_d_y", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, w_d_y)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 48, 0 },

  { 25, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/zeta_psi", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, zeta_psi)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 50, 0 },

  { 26, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/zeta_x", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, zeta_x)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 52, 0 },

  { 27, "cse1_oculus_gesture/Input/Oculus_ref_on_off", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Oculus_ref_on_off)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 54, 0 },

  { 28, "cse1_oculus_gesture/Input/psi_ref", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, psi_ref)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    56, 0 },

  { 29, "cse1_oculus_gesture/Input/Oculus_yaw", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Oculus_yaw)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    58, 0 },

  { 30, "cse1_oculus_gesture/Input/x_ref", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, x_ref)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 60,
    0 },

  { 31, "cse1_oculus_gesture/Input/y_ref", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, y_ref)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 62,
    0 },

  { 32, "cse1_oculus_gesture/Input/x", 0, "", offsetof(B_CSE1_Oculus_gesture_T,
    x)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 64, 0 },

  { 33, "cse1_oculus_gesture/Input/y", 0, "", offsetof(B_CSE1_Oculus_gesture_T,
    y)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 66, 0 },

  { 34, "cse1_oculus_gesture/Input/Gesture_off", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Gesture_off)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 68, 0 },

  { 35, "cse1_oculus_gesture/Input/Subsystem1/Gain3", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Gain3)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 70,
    0 },

  { 36, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/zeta_y", 0,
    "", offsetof(B_CSE1_Oculus_gesture_T, zeta_y_k)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 72, 0 },

  { 37, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/w_d_psi", 0,
    "", offsetof(B_CSE1_Oculus_gesture_T, w_d_psi_d)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 74, 0 },

  { 38, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/w_d_x", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, w_d_x_l)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 76, 0 },

  { 39, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/w_d_y", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, w_d_y_c)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 78, 0 },

  { 40, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/zeta_psi", 0,
    "", offsetof(B_CSE1_Oculus_gesture_T, zeta_psi_i)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 80, 0 },

  { 41, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/zeta_x", 0,
    "", offsetof(B_CSE1_Oculus_gesture_T, zeta_x_m)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 82, 0 },

  { 42, "cse1_oculus_gesture/Input/Gesture based ctrl/K_u", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_u)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 84, 0
  },

  { 43, "cse1_oculus_gesture/Input/Gesture based ctrl/K_v", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_v)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 86, 0
  },

  { 44, "cse1_oculus_gesture/Input/Gesture based ctrl/K_r", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, K_r)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 88, 0
  },

  { 45, "cse1_oculus_gesture/Input/Oculus_roll", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Oculus_roll)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 90, 0 },

  { 46, "cse1_oculus_gesture/Input/Subsystem1/Gain1", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Gain1)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 92,
    0 },

  { 47, "cse1_oculus_gesture/Input/Oculus_pitch", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Oculus_pitch)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 94, 0 },

  { 48, "cse1_oculus_gesture/Guidance/Transposed rotation  matrix in yaw1/Row1",
    0, "", offsetof(B_CSE1_Oculus_gesture_T, Row1)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 96, 0 },

  { 49, "cse1_oculus_gesture/Guidance/Transposed rotation  matrix in yaw1/Row2",
    0, "", offsetof(B_CSE1_Oculus_gesture_T, Row2)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 98, 0 },

  { 50, "cse1_oculus_gesture/Guidance/Transposed rotation  matrix in yaw1/Row3",
    0, "", offsetof(B_CSE1_Oculus_gesture_T, Row3)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 100, 0 },

  { 51, "cse1_oculus_gesture/Guidance/Vel Reference model1/Integrator1", 0,
    "(1,1)", offsetof(B_CSE1_Oculus_gesture_T, Integrator1)+0*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 102, 0 },

  { 52, "cse1_oculus_gesture/Guidance/Vel Reference model1/Integrator1", 0,
    "(1,2)", offsetof(B_CSE1_Oculus_gesture_T, Integrator1)+1*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 104, 0 },

  { 53, "cse1_oculus_gesture/Guidance/Vel Reference model1/Integrator1", 0,
    "(1,3)", offsetof(B_CSE1_Oculus_gesture_T, Integrator1)+2*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 106, 0 },

  { 54, "cse1_oculus_gesture/Guidance/Reference model/Integrator3", 0, "(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, Integrator3)+0*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 108, 0 },

  { 55, "cse1_oculus_gesture/Guidance/Reference model/Integrator3", 0, "(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, Integrator3)+1*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 110, 0 },

  { 56, "cse1_oculus_gesture/Guidance/Reference model/Integrator3", 0, "(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, Integrator3)+2*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 112, 0 },

  { 57, "cse1_oculus_gesture/Guidance/Multiport Switch", 0, "(1,1)", offsetof
    (B_CSE1_Oculus_gesture_T, MultiportSwitch)+0*sizeof(real_T), BLOCKIO_SIG, 20,
    1, 2, 114, 0 },

  { 58, "cse1_oculus_gesture/Guidance/Multiport Switch", 0, "(1,2)", offsetof
    (B_CSE1_Oculus_gesture_T, MultiportSwitch)+1*sizeof(real_T), BLOCKIO_SIG, 20,
    1, 2, 116, 0 },

  { 59, "cse1_oculus_gesture/Guidance/Multiport Switch", 0, "(1,3)", offsetof
    (B_CSE1_Oculus_gesture_T, MultiportSwitch)+2*sizeof(real_T), BLOCKIO_SIG, 20,
    1, 2, 118, 0 },

  { 60, "cse1_oculus_gesture/Guidance/Multiport Switch", 0, "(1,4)", offsetof
    (B_CSE1_Oculus_gesture_T, MultiportSwitch)+3*sizeof(real_T), BLOCKIO_SIG, 20,
    1, 2, 120, 0 },

  { 61, "cse1_oculus_gesture/Guidance/Multiport Switch", 0, "(1,5)", offsetof
    (B_CSE1_Oculus_gesture_T, MultiportSwitch)+4*sizeof(real_T), BLOCKIO_SIG, 20,
    1, 2, 122, 0 },

  { 62, "cse1_oculus_gesture/Guidance/Multiport Switch", 0, "(1,6)", offsetof
    (B_CSE1_Oculus_gesture_T, MultiportSwitch)+5*sizeof(real_T), BLOCKIO_SIG, 20,
    1, 2, 124, 0 },

  { 63,
    "cse1_oculus_gesture/Guidance/Inf,inf tto pi,pi/[-inf inf] to [-pi pi]/Sum",
    0, "", offsetof(B_CSE1_Oculus_gesture_T, Sum_p)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 126, 0 },

  { 64, "cse1_oculus_gesture/Navigation /Derivative filter/Delay", 0, "(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, Delay)+0*sizeof(real_T), BLOCKIO_SIG, 17,
    1, 2, 128, 0 },

  { 65, "cse1_oculus_gesture/Navigation /Derivative filter/Delay", 0, "(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, Delay)+1*sizeof(real_T), BLOCKIO_SIG, 17,
    1, 2, 130, 0 },

  { 66, "cse1_oculus_gesture/Navigation /Derivative filter/Delay", 0, "(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, Delay)+2*sizeof(real_T), BLOCKIO_SIG, 17,
    1, 2, 132, 0 },

  { 67, "cse1_oculus_gesture/Navigation /Derivative filter/Memory3", 0, "(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, Memory3)+0*sizeof(real_T), BLOCKIO_SIG, 17,
    1, 2, 134, 0 },

  { 68, "cse1_oculus_gesture/Navigation /Derivative filter/Memory3", 0, "(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, Memory3)+1*sizeof(real_T), BLOCKIO_SIG, 17,
    1, 2, 136, 0 },

  { 69, "cse1_oculus_gesture/Navigation /Derivative filter/Memory3", 0, "(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, Memory3)+2*sizeof(real_T), BLOCKIO_SIG, 17,
    1, 2, 138, 0 },

  { 70, "cse1_oculus_gesture/Control/DP Controller/Sum1", 0, "(1,1)", offsetof
    (B_CSE1_Oculus_gesture_T, Sum1)+0*sizeof(real_T), BLOCKIO_SIG, 17, 1, 2, 140,
    0 },

  { 71, "cse1_oculus_gesture/Control/DP Controller/Sum1", 0, "(1,2)", offsetof
    (B_CSE1_Oculus_gesture_T, Sum1)+1*sizeof(real_T), BLOCKIO_SIG, 17, 1, 2, 142,
    0 },

  { 72, "cse1_oculus_gesture/Control/DP Controller/Sum1", 0, "(1,3)", offsetof
    (B_CSE1_Oculus_gesture_T, Sum1)+2*sizeof(real_T), BLOCKIO_SIG, 17, 1, 2, 144,
    0 },

  { 73, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2force/u_BT", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, u_BT)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 146,
    0 },

  { 74, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2force/u_VSP2", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, u_VSP2)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 148, 0 },

  { 75, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2force/omega_VSP1", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, omega_VSP1)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 150, 0 },

  { 76, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2force/omega_VSP2", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, omega_VSP2)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 152, 0 },

  { 77, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2force/u_VSP1", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, u_VSP1)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 154, 0 },

  { 78, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2force/alpha_VSP1", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, alpha_VSP1)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 156, 0 },

  { 79, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2force/alpha_VSP2", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, alpha_VSP2)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 158, 0 },

  { 80, "cse1_oculus_gesture/ctrl_out/ctrl_DP_basic/u_BT", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, u_BT_c)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    160, 0 },

  { 81, "cse1_oculus_gesture/ctrl_out/ctrl_DP_basic/u_VSP2", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, u_VSP2_c)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    162, 0 },

  { 82, "cse1_oculus_gesture/ctrl_out/ctrl_DP_basic/omega_VSP1", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, omega_VSP1_a)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 164, 0 },

  { 83, "cse1_oculus_gesture/ctrl_out/ctrl_DP_basic/omega_VSP2", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, omega_VSP2_f)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 166, 0 },

  { 84, "cse1_oculus_gesture/ctrl_out/ctrl_DP_basic/u_VSP1", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, u_VSP1_d)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    168, 0 },

  { 85, "cse1_oculus_gesture/ctrl_out/ctrl_DP_basic/alpha_VSP1", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, alpha_VSP1_i)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 170, 0 },

  { 86, "cse1_oculus_gesture/ctrl_out/ctrl_DP_basic/alpha_VSP2", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, alpha_VSP2_f)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 172, 0 },

  { 87, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2thruster/u_BT", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, u_BT_f)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 174, 0 },

  { 88, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2thruster/u_VSP2", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, u_VSP2_o)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 176, 0 },

  { 89, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2thruster/omega_VSP1", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, omega_VSP1_k)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 178, 0 },

  { 90, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2thruster/omega_VSP2", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, omega_VSP2_b)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 180, 0 },

  { 91, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2thruster/u_VSP1", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, u_VSP1_g)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 182, 0 },

  { 92, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2thruster/alpha_VSP1", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, alpha_VSP1_o)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 184, 0 },

  { 93, "cse1_oculus_gesture/ctrl_out/ctrl_sixaxis2thruster/alpha_VSP2", 0, "",
    offsetof(B_CSE1_Oculus_gesture_T, alpha_VSP2_f2)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 186, 0 },

  { 94, "cse1_oculus_gesture/ctrl_out/Saturation4", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Saturation4)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 188, 0 },

  { 95, "cse1_oculus_gesture/ctrl_out/Saturation", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Saturation)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2,
    190, 0 },

  { 96, "cse1_oculus_gesture/ctrl_out/Saturation1", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Saturation1)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 192, 0 },

  { 97, "cse1_oculus_gesture/ctrl_out/Saturation2", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Saturation2)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 194, 0 },

  { 98, "cse1_oculus_gesture/ctrl_out/Saturation3", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Saturation3)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 196, 0 },

  { 99, "cse1_oculus_gesture/ctrl_out/Saturation5", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Saturation5)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 198, 0 },

  { 100, "cse1_oculus_gesture/ctrl_out/Saturation6", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Saturation6)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 200, 0 },

  { 101, "cse1_oculus_gesture/Input/Multiport Switch", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, MultiportSwitch_o)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 202, 0 },

  { 102, "cse1_oculus_gesture/Guidance/Reference model/Matrix Multiply", 0,
    "(1,1)", offsetof(B_CSE1_Oculus_gesture_T, MatrixMultiply)+0*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 204, 0 },

  { 103, "cse1_oculus_gesture/Guidance/Reference model/Matrix Multiply", 0,
    "(1,2)", offsetof(B_CSE1_Oculus_gesture_T, MatrixMultiply)+1*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 206, 0 },

  { 104, "cse1_oculus_gesture/Guidance/Reference model/Matrix Multiply", 0,
    "(1,3)", offsetof(B_CSE1_Oculus_gesture_T, MatrixMultiply)+2*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 208, 0 },

  { 105, "cse1_oculus_gesture/Guidance/Reference model/Sum5", 0, "(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, Sum5)+0*sizeof(real_T), BLOCKIO_SIG, 17, 1,
    2, 210, 0 },

  { 106, "cse1_oculus_gesture/Guidance/Reference model/Sum5", 0, "(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, Sum5)+1*sizeof(real_T), BLOCKIO_SIG, 17, 1,
    2, 212, 0 },

  { 107, "cse1_oculus_gesture/Guidance/Reference model/Sum5", 0, "(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, Sum5)+2*sizeof(real_T), BLOCKIO_SIG, 17, 1,
    2, 214, 0 },

  { 108, "cse1_oculus_gesture/Guidance/Vel Reference model1/Integrator3", 0,
    "(1,1)", offsetof(B_CSE1_Oculus_gesture_T, Integrator3_o)+0*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 216, 0 },

  { 109, "cse1_oculus_gesture/Guidance/Vel Reference model1/Integrator3", 0,
    "(1,2)", offsetof(B_CSE1_Oculus_gesture_T, Integrator3_o)+1*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 218, 0 },

  { 110, "cse1_oculus_gesture/Guidance/Vel Reference model1/Integrator3", 0,
    "(1,3)", offsetof(B_CSE1_Oculus_gesture_T, Integrator3_o)+2*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 220, 0 },

  { 111, "cse1_oculus_gesture/Input/Subsystem1/Gain2", 0, "", offsetof
    (B_CSE1_Oculus_gesture_T, Gain2)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1, 2, 222,
    0 },

  { 112, "cse1_oculus_gesture/Input/Gesture based ctrl/Matrix Multiply", 0,
    "(1,1)", offsetof(B_CSE1_Oculus_gesture_T, MatrixMultiply_k)+0*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 224, 0 },

  { 113, "cse1_oculus_gesture/Input/Gesture based ctrl/Matrix Multiply", 0,
    "(1,2)", offsetof(B_CSE1_Oculus_gesture_T, MatrixMultiply_k)+1*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 226, 0 },

  { 114, "cse1_oculus_gesture/Input/Gesture based ctrl/Matrix Multiply", 0,
    "(1,3)", offsetof(B_CSE1_Oculus_gesture_T, MatrixMultiply_k)+2*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 228, 0 },

  { 115, "cse1_oculus_gesture/Guidance/Vel Reference model1/Matrix Multiply", 0,
    "(1,1)", offsetof(B_CSE1_Oculus_gesture_T, MatrixMultiply_n)+0*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 230, 0 },

  { 116, "cse1_oculus_gesture/Guidance/Vel Reference model1/Matrix Multiply", 0,
    "(1,2)", offsetof(B_CSE1_Oculus_gesture_T, MatrixMultiply_n)+1*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 232, 0 },

  { 117, "cse1_oculus_gesture/Guidance/Vel Reference model1/Matrix Multiply", 0,
    "(1,3)", offsetof(B_CSE1_Oculus_gesture_T, MatrixMultiply_n)+2*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 234, 0 },

  { 118, "cse1_oculus_gesture/Guidance/Vel Reference model1/Sum5", 0, "(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, Sum5_o)+0*sizeof(real_T), BLOCKIO_SIG, 17,
    1, 2, 236, 0 },

  { 119, "cse1_oculus_gesture/Guidance/Vel Reference model1/Sum5", 0, "(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, Sum5_o)+1*sizeof(real_T), BLOCKIO_SIG, 17,
    1, 2, 238, 0 },

  { 120, "cse1_oculus_gesture/Guidance/Vel Reference model1/Sum5", 0, "(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, Sum5_o)+2*sizeof(real_T), BLOCKIO_SIG, 17,
    1, 2, 240, 0 },

  { 121, "cse1_oculus_gesture/Output/Plant output/[-inf inf] to [-pi pi]/Sum", 0,
    "", offsetof(B_CSE1_Oculus_gesture_T, Sum_a)+0*sizeof(real_T), BLOCKIO_SIG,
    0, 1, 2, 242, 0 },

  { 122, "cse1_oculus_gesture/ctrl_out/Switch_subsystem/Switch_function", 0,
    "switch_signal", offsetof(B_CSE1_Oculus_gesture_T, switch_signal)+0*sizeof
    (real_T), BLOCKIO_SIG, 0, 1, 2, 244, 0 },

  { 123, "cse1_oculus_gesture/Thrust allocation/Thrust allocation", 0, "u_BT",
    offsetof(B_CSE1_Oculus_gesture_T, u_BT_j)+0*sizeof(real_T), BLOCKIO_SIG, 0,
    1, 2, 246, 0 },

  { 124, "cse1_oculus_gesture/Thrust allocation/Thrust allocation", 1, "u_VSP",
    offsetof(B_CSE1_Oculus_gesture_T, u_VSP)+0*sizeof(real_T), BLOCKIO_SIG, 0, 1,
    2, 248, 0 },

  { 125, "cse1_oculus_gesture/Thrust allocation/Thrust allocation", 2,
    "alpha_VSP", offsetof(B_CSE1_Oculus_gesture_T, alpha_VSP)+0*sizeof(real_T),
    BLOCKIO_SIG, 0, 1, 2, 250, 0 },

  { 126, "cse1_oculus_gesture/Navigation /Derivative filter/MATLAB Function3", 0,
    "nu(1,1)", offsetof(B_CSE1_Oculus_gesture_T, nu)+0*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 252, 0 },

  { 127, "cse1_oculus_gesture/Navigation /Derivative filter/MATLAB Function3", 0,
    "nu(1,2)", offsetof(B_CSE1_Oculus_gesture_T, nu)+1*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 254, 0 },

  { 128, "cse1_oculus_gesture/Navigation /Derivative filter/MATLAB Function3", 0,
    "nu(1,3)", offsetof(B_CSE1_Oculus_gesture_T, nu)+2*sizeof(real_T),
    BLOCKIO_SIG, 17, 1, 2, 256, 0 },

  { 129, "cse1_oculus_gesture/Navigation /Derivative filter/MATLAB Function2", 0,
    "eta_dot_filtered(1,1)", offsetof(B_CSE1_Oculus_gesture_T, eta_dot_filtered)
    +0*sizeof(real_T), BLOCKIO_SIG, 17, 1, 2, 258, 0 },

  { 130, "cse1_oculus_gesture/Navigation /Derivative filter/MATLAB Function2", 0,
    "eta_dot_filtered(1,2)", offsetof(B_CSE1_Oculus_gesture_T, eta_dot_filtered)
    +1*sizeof(real_T), BLOCKIO_SIG, 17, 1, 2, 260, 0 },

  { 131, "cse1_oculus_gesture/Navigation /Derivative filter/MATLAB Function2", 0,
    "eta_dot_filtered(1,3)", offsetof(B_CSE1_Oculus_gesture_T, eta_dot_filtered)
    +2*sizeof(real_T), BLOCKIO_SIG, 17, 1, 2, 262, 0 },

  { 132, "cse1_oculus_gesture/Navigation /Derivative filter/MATLAB Function", 0,
    "eta_filtered(1,1)", offsetof(B_CSE1_Oculus_gesture_T, eta_filtered)+0*
    sizeof(real_T), BLOCKIO_SIG, 17, 1, 2, 264, 0 },

  { 133, "cse1_oculus_gesture/Navigation /Derivative filter/MATLAB Function", 0,
    "eta_filtered(1,2)", offsetof(B_CSE1_Oculus_gesture_T, eta_filtered)+1*
    sizeof(real_T), BLOCKIO_SIG, 17, 1, 2, 266, 0 },

  { 134, "cse1_oculus_gesture/Navigation /Derivative filter/MATLAB Function", 0,
    "eta_filtered(1,3)", offsetof(B_CSE1_Oculus_gesture_T, eta_filtered)+2*
    sizeof(real_T), BLOCKIO_SIG, 17, 1, 2, 268, 0 },

  { 135, "cse1_oculus_gesture/ctrl_out/indicator/C", 0, "ctrl_student", offsetof
    (B_CSE1_Oculus_gesture_T, ctrl_student)+0*sizeof(boolean_T), BLOCKIO_SIG, 8,
    1, 2, 270, 0 },

  { 136, "cse1_oculus_gesture/ctrl_out/indicator/C", 1, "ctrl_DP_basic",
    offsetof(B_CSE1_Oculus_gesture_T, ctrl_DP_basic)+0*sizeof(boolean_T),
    BLOCKIO_SIG, 8, 1, 2, 272, 0 },

  { 137, "cse1_oculus_gesture/ctrl_out/indicator/C", 2, "ctrl_sixaxis2force",
    offsetof(B_CSE1_Oculus_gesture_T, ctrl_sixaxis2force)+0*sizeof(boolean_T),
    BLOCKIO_SIG, 8, 1, 2, 274, 0 },

  { 138, "cse1_oculus_gesture/ctrl_out/indicator/C", 3, "ctrl_sixaxis2thruster",
    offsetof(B_CSE1_Oculus_gesture_T, ctrl_sixaxis2thruster)+0*sizeof(boolean_T),
    BLOCKIO_SIG, 8, 1, 2, 276, 0 },

  { 139, "cse1_oculus_gesture/ctrl_out/control limit checking", 0, "fault",
    offsetof(B_CSE1_Oculus_gesture_T, fault)+0*sizeof(boolean_T), BLOCKIO_SIG, 8,
    1, 2, 278, 0 },

  { 140, "cse1_oculus_gesture/Output/diag2vector4", 0, "y(1,1)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector4.y)+0*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 280, 0 },

  { 141, "cse1_oculus_gesture/Output/diag2vector4", 0, "y(1,2)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector4.y)+1*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 282, 0 },

  { 142, "cse1_oculus_gesture/Output/diag2vector4", 0, "y(1,3)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector4.y)+2*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 284, 0 },

  { 143, "cse1_oculus_gesture/Output/diag2vector3", 0, "y(1,1)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector3.y)+0*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 286, 0 },

  { 144, "cse1_oculus_gesture/Output/diag2vector3", 0, "y(1,2)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector3.y)+1*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 288, 0 },

  { 145, "cse1_oculus_gesture/Output/diag2vector3", 0, "y(1,3)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector3.y)+2*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 290, 0 },

  { 146, "cse1_oculus_gesture/Output/diag2vector2", 0, "y(1,1)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector2.y)+0*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 292, 0 },

  { 147, "cse1_oculus_gesture/Output/diag2vector2", 0, "y(1,2)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector2.y)+1*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 294, 0 },

  { 148, "cse1_oculus_gesture/Output/diag2vector2", 0, "y(1,3)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector2.y)+2*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 296, 0 },

  { 149, "cse1_oculus_gesture/Output/diag2vector1", 0, "y(1,1)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector1.y)+0*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 298, 0 },

  { 150, "cse1_oculus_gesture/Output/diag2vector1", 0, "y(1,2)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector1.y)+1*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 300, 0 },

  { 151, "cse1_oculus_gesture/Output/diag2vector1", 0, "y(1,3)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector1.y)+2*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 302, 0 },

  { 152, "cse1_oculus_gesture/Output/diag2vector", 0, "y(1,1)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector.y)+0*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 304, 0 },

  { 153, "cse1_oculus_gesture/Output/diag2vector", 0, "y(1,2)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector.y)+1*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 306, 0 },

  { 154, "cse1_oculus_gesture/Output/diag2vector", 0, "y(1,3)", offsetof
    (B_CSE1_Oculus_gesture_T, sf_diag2vector.y)+2*sizeof(real_T), BLOCKIO_SIG,
    17, 1, 2, 308, 0 },

  { 155, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag1", 0,
    "Zeta(1,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1_j.Zeta)+0*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 310, 0 },

  { 156, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag1", 0,
    "Zeta(2,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1_j.Zeta)+1*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 312, 0 },

  { 157, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag1", 0,
    "Zeta(3,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1_j.Zeta)+2*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 314, 0 },

  { 158, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag1", 0,
    "Zeta(1,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1_j.Zeta)+3*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 316, 0 },

  { 159, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag1", 0,
    "Zeta(2,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1_j.Zeta)+4*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 318, 0 },

  { 160, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag1", 0,
    "Zeta(3,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1_j.Zeta)+5*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 320, 0 },

  { 161, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag1", 0,
    "Zeta(1,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1_j.Zeta)+6*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 322, 0 },

  { 162, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag1", 0,
    "Zeta(2,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1_j.Zeta)+7*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 324, 0 },

  { 163, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag1", 0,
    "Zeta(3,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1_j.Zeta)+8*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 326, 0 },

  { 164, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag", 0,
    "w_d(1,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag_j.w_d)+0*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 328, 0 },

  { 165, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag", 0,
    "w_d(2,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag_j.w_d)+1*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 330, 0 },

  { 166, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag", 0,
    "w_d(3,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag_j.w_d)+2*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 332, 0 },

  { 167, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag", 0,
    "w_d(1,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag_j.w_d)+3*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 334, 0 },

  { 168, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag", 0,
    "w_d(2,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag_j.w_d)+4*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 336, 0 },

  { 169, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag", 0,
    "w_d(3,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag_j.w_d)+5*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 338, 0 },

  { 170, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag", 0,
    "w_d(1,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag_j.w_d)+6*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 340, 0 },

  { 171, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag", 0,
    "w_d(2,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag_j.w_d)+7*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 342, 0 },

  { 172, "cse1_oculus_gesture/Input/Guidance gains/Gesture guidance/diag", 0,
    "w_d(3,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag_j.w_d)+8*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 344, 0 },

  { 173, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag1", 0,
    "Zeta(1,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1.Zeta)+0*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 346, 0 },

  { 174, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag1", 0,
    "Zeta(2,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1.Zeta)+1*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 348, 0 },

  { 175, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag1", 0,
    "Zeta(3,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1.Zeta)+2*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 350, 0 },

  { 176, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag1", 0,
    "Zeta(1,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1.Zeta)+3*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 352, 0 },

  { 177, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag1", 0,
    "Zeta(2,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1.Zeta)+4*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 354, 0 },

  { 178, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag1", 0,
    "Zeta(3,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1.Zeta)+5*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 356, 0 },

  { 179, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag1", 0,
    "Zeta(1,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1.Zeta)+6*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 358, 0 },

  { 180, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag1", 0,
    "Zeta(2,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1.Zeta)+7*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 360, 0 },

  { 181, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag1", 0,
    "Zeta(3,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag1.Zeta)+8*sizeof
    (real_T), BLOCKIO_SIG, 18, 1, 2, 362, 0 },

  { 182, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag", 0,
    "w_d(1,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag.w_d)+0*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 364, 0 },

  { 183, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag", 0,
    "w_d(2,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag.w_d)+1*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 366, 0 },

  { 184, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag", 0,
    "w_d(3,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag.w_d)+2*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 368, 0 },

  { 185, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag", 0,
    "w_d(1,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag.w_d)+3*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 370, 0 },

  { 186, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag", 0,
    "w_d(2,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag.w_d)+4*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 372, 0 },

  { 187, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag", 0,
    "w_d(3,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag.w_d)+5*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 374, 0 },

  { 188, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag", 0,
    "w_d(1,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag.w_d)+6*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 376, 0 },

  { 189, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag", 0,
    "w_d(2,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag.w_d)+7*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 378, 0 },

  { 190, "cse1_oculus_gesture/Input/Guidance gains/DP guidance/diag", 0,
    "w_d(3,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_diag.w_d)+8*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 380, 0 },

  { 191, "cse1_oculus_gesture/Input/Gesture based ctrl/MATLAB Function4", 0,
    "K_p(1,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction4.K_p)+0*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 382, 0 },

  { 192, "cse1_oculus_gesture/Input/Gesture based ctrl/MATLAB Function4", 0,
    "K_p(2,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction4.K_p)+1*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 384, 0 },

  { 193, "cse1_oculus_gesture/Input/Gesture based ctrl/MATLAB Function4", 0,
    "K_p(3,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction4.K_p)+2*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 386, 0 },

  { 194, "cse1_oculus_gesture/Input/Gesture based ctrl/MATLAB Function4", 0,
    "K_p(1,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction4.K_p)+3*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 388, 0 },

  { 195, "cse1_oculus_gesture/Input/Gesture based ctrl/MATLAB Function4", 0,
    "K_p(2,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction4.K_p)+4*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 390, 0 },

  { 196, "cse1_oculus_gesture/Input/Gesture based ctrl/MATLAB Function4", 0,
    "K_p(3,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction4.K_p)+5*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 392, 0 },

  { 197, "cse1_oculus_gesture/Input/Gesture based ctrl/MATLAB Function4", 0,
    "K_p(1,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction4.K_p)+6*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 394, 0 },

  { 198, "cse1_oculus_gesture/Input/Gesture based ctrl/MATLAB Function4", 0,
    "K_p(2,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction4.K_p)+7*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 396, 0 },

  { 199, "cse1_oculus_gesture/Input/Gesture based ctrl/MATLAB Function4", 0,
    "K_p(3,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction4.K_p)+8*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 398, 0 },

  { 200, "cse1_oculus_gesture/Input/Control Gains/MATLAB Function", 0,
    "K_p(1,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction.K_p)+0*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 400, 0 },

  { 201, "cse1_oculus_gesture/Input/Control Gains/MATLAB Function", 0,
    "K_p(2,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction.K_p)+1*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 402, 0 },

  { 202, "cse1_oculus_gesture/Input/Control Gains/MATLAB Function", 0,
    "K_p(3,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction.K_p)+2*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 404, 0 },

  { 203, "cse1_oculus_gesture/Input/Control Gains/MATLAB Function", 0,
    "K_p(1,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction.K_p)+3*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 406, 0 },

  { 204, "cse1_oculus_gesture/Input/Control Gains/MATLAB Function", 0,
    "K_p(2,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction.K_p)+4*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 408, 0 },

  { 205, "cse1_oculus_gesture/Input/Control Gains/MATLAB Function", 0,
    "K_p(3,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction.K_p)+5*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 410, 0 },

  { 206, "cse1_oculus_gesture/Input/Control Gains/MATLAB Function", 0,
    "K_p(1,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction.K_p)+6*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 412, 0 },

  { 207, "cse1_oculus_gesture/Input/Control Gains/MATLAB Function", 0,
    "K_p(2,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction.K_p)+7*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 414, 0 },

  { 208, "cse1_oculus_gesture/Input/Control Gains/MATLAB Function", 0,
    "K_p(3,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_MATLABFunction.K_p)+8*
    sizeof(real_T), BLOCKIO_SIG, 18, 1, 2, 416, 0 },

  { 209, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^3", 0, "y(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3_f.y)+0*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 418, 0 },

  { 210, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^3", 0, "y(2,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3_f.y)+1*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 420, 0 },

  { 211, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^3", 0, "y(3,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3_f.y)+2*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 422, 0 },

  { 212, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^3", 0, "y(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3_f.y)+3*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 424, 0 },

  { 213, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^3", 0, "y(2,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3_f.y)+4*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 426, 0 },

  { 214, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^3", 0, "y(3,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3_f.y)+5*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 428, 0 },

  { 215, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^3", 0, "y(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3_f.y)+6*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 430, 0 },

  { 216, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^3", 0, "y(2,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3_f.y)+7*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 432, 0 },

  { 217, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^3", 0, "y(3,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3_f.y)+8*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 434, 0 },

  { 218, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^-2", 0, "y(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2_d.y)+0*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 436, 0 },

  { 219, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^-2", 0, "y(2,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2_d.y)+1*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 438, 0 },

  { 220, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^-2", 0, "y(3,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2_d.y)+2*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 440, 0 },

  { 221, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^-2", 0, "y(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2_d.y)+3*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 442, 0 },

  { 222, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^-2", 0, "y(2,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2_d.y)+4*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 444, 0 },

  { 223, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^-2", 0, "y(3,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2_d.y)+5*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 446, 0 },

  { 224, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^-2", 0, "y(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2_d.y)+6*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 448, 0 },

  { 225, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^-2", 0, "y(2,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2_d.y)+7*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 450, 0 },

  { 226, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d^-2", 0, "y(3,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2_d.y)+8*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 452, 0 },

  { 227, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d1", 0,
    "y(1,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1_f.y)+0*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 454, 0 },

  { 228, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d1", 0,
    "y(2,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1_f.y)+1*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 456, 0 },

  { 229, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d1", 0,
    "y(3,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1_f.y)+2*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 458, 0 },

  { 230, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d1", 0,
    "y(1,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1_f.y)+3*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 460, 0 },

  { 231, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d1", 0,
    "y(2,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1_f.y)+4*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 462, 0 },

  { 232, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d1", 0,
    "y(3,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1_f.y)+5*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 464, 0 },

  { 233, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d1", 0,
    "y(1,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1_f.y)+6*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 466, 0 },

  { 234, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d1", 0,
    "y(2,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1_f.y)+7*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 468, 0 },

  { 235, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d1", 0,
    "y(3,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1_f.y)+8*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 470, 0 },

  { 236, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d", 0,
    "y(1,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d_f.y)+0*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 472, 0 },

  { 237, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d", 0,
    "y(2,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d_f.y)+1*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 474, 0 },

  { 238, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d", 0,
    "y(3,1)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d_f.y)+2*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 476, 0 },

  { 239, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d", 0,
    "y(1,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d_f.y)+3*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 478, 0 },

  { 240, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d", 0,
    "y(2,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d_f.y)+4*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 480, 0 },

  { 241, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d", 0,
    "y(3,2)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d_f.y)+5*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 482, 0 },

  { 242, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d", 0,
    "y(1,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d_f.y)+6*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 484, 0 },

  { 243, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d", 0,
    "y(2,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d_f.y)+7*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 486, 0 },

  { 244, "cse1_oculus_gesture/Guidance/Vel Reference model1/w_d*w_d", 0,
    "y(3,3)", offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d_f.y)+8*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 488, 0 },

  { 245, "cse1_oculus_gesture/Guidance/Reference model/w_d^3", 0, "y(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3.y)+0*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 490, 0 },

  { 246, "cse1_oculus_gesture/Guidance/Reference model/w_d^3", 0, "y(2,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3.y)+1*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 492, 0 },

  { 247, "cse1_oculus_gesture/Guidance/Reference model/w_d^3", 0, "y(3,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3.y)+2*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 494, 0 },

  { 248, "cse1_oculus_gesture/Guidance/Reference model/w_d^3", 0, "y(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3.y)+3*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 496, 0 },

  { 249, "cse1_oculus_gesture/Guidance/Reference model/w_d^3", 0, "y(2,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3.y)+4*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 498, 0 },

  { 250, "cse1_oculus_gesture/Guidance/Reference model/w_d^3", 0, "y(3,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3.y)+5*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 500, 0 },

  { 251, "cse1_oculus_gesture/Guidance/Reference model/w_d^3", 0, "y(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3.y)+6*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 502, 0 },

  { 252, "cse1_oculus_gesture/Guidance/Reference model/w_d^3", 0, "y(2,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3.y)+7*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 504, 0 },

  { 253, "cse1_oculus_gesture/Guidance/Reference model/w_d^3", 0, "y(3,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d3.y)+8*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 506, 0 },

  { 254, "cse1_oculus_gesture/Guidance/Reference model/w_d^-2", 0, "y(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2.y)+0*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 508, 0 },

  { 255, "cse1_oculus_gesture/Guidance/Reference model/w_d^-2", 0, "y(2,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2.y)+1*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 510, 0 },

  { 256, "cse1_oculus_gesture/Guidance/Reference model/w_d^-2", 0, "y(3,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2.y)+2*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 512, 0 },

  { 257, "cse1_oculus_gesture/Guidance/Reference model/w_d^-2", 0, "y(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2.y)+3*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 514, 0 },

  { 258, "cse1_oculus_gesture/Guidance/Reference model/w_d^-2", 0, "y(2,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2.y)+4*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 516, 0 },

  { 259, "cse1_oculus_gesture/Guidance/Reference model/w_d^-2", 0, "y(3,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2.y)+5*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 518, 0 },

  { 260, "cse1_oculus_gesture/Guidance/Reference model/w_d^-2", 0, "y(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2.y)+6*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 520, 0 },

  { 261, "cse1_oculus_gesture/Guidance/Reference model/w_d^-2", 0, "y(2,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2.y)+7*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 522, 0 },

  { 262, "cse1_oculus_gesture/Guidance/Reference model/w_d^-2", 0, "y(3,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_d2.y)+8*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 524, 0 },

  { 263, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d1", 0, "y(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1.y)+0*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 526, 0 },

  { 264, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d1", 0, "y(2,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1.y)+1*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 528, 0 },

  { 265, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d1", 0, "y(3,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1.y)+2*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 530, 0 },

  { 266, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d1", 0, "y(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1.y)+3*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 532, 0 },

  { 267, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d1", 0, "y(2,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1.y)+4*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 534, 0 },

  { 268, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d1", 0, "y(3,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1.y)+5*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 536, 0 },

  { 269, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d1", 0, "y(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1.y)+6*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 538, 0 },

  { 270, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d1", 0, "y(2,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1.y)+7*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 540, 0 },

  { 271, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d1", 0, "y(3,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d1.y)+8*sizeof(real_T),
    BLOCKIO_SIG, 18, 1, 2, 542, 0 },

  { 272, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d", 0, "y(1,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d.y)+0*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 544, 0 },

  { 273, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d", 0, "y(2,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d.y)+1*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 546, 0 },

  { 274, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d", 0, "y(3,1)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d.y)+2*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 548, 0 },

  { 275, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d", 0, "y(1,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d.y)+3*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 550, 0 },

  { 276, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d", 0, "y(2,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d.y)+4*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 552, 0 },

  { 277, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d", 0, "y(3,2)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d.y)+5*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 554, 0 },

  { 278, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d", 0, "y(1,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d.y)+6*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 556, 0 },

  { 279, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d", 0, "y(2,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d.y)+7*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 558, 0 },

  { 280, "cse1_oculus_gesture/Guidance/Reference model/w_d*w_d", 0, "y(3,3)",
    offsetof(B_CSE1_Oculus_gesture_T, sf_w_dw_d.y)+8*sizeof(real_T), BLOCKIO_SIG,
    18, 1, 2, 560, 0 },

  { -1, "", -1, "", 0, 0, 0 }
};

static int NI_SigListSize DataSection(".NIVS.siglistsize") = 281;
static int NI_VirtualBlockSources[1][1];
static int NI_VirtualBlockOffsets[1][1];
static int NI_VirtualBlockLengths[1][1];
static int NI_SigDimList[] DataSection(".NIVS.sigdimlist") =
{
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, };

static long NI_ExtListSize DataSection(".NIVS.extlistsize") = 95;
static NI_ExternalIO NI_ExtList[] DataSection(".NIVS.extlist") =
{
  { 0, "ctrl_out/sixaxis/Triangle", 0, EXT_IN, 1, 1, 1 },

  { 1, "ctrl_out/sixaxis/Circle", 0, EXT_IN, 1, 1, 1 },

  { 2, "ctrl_out/sixaxis/Cross", 0, EXT_IN, 1, 1, 1 },

  { 3, "ctrl_out/sixaxis/Square", 0, EXT_IN, 1, 1, 1 },

  { 4, "Input/Control Gains/K_p_x", 0, EXT_IN, 1, 1, 1 },

  { 5, "Input/Control Gains/K_p_y", 0, EXT_IN, 1, 1, 1 },

  { 6, "Input/Control Gains/K_p_psi", 0, EXT_IN, 1, 1, 1 },

  { 7, "Input/Control Gains/K_i_psi", 0, EXT_IN, 1, 1, 1 },

  { 8, "Input/Control Gains/K_i_x", 0, EXT_IN, 1, 1, 1 },

  { 9, "Input/Control Gains/K_i_y", 0, EXT_IN, 1, 1, 1 },

  { 10, "Input/Control Gains/K_d_psi", 0, EXT_IN, 1, 1, 1 },

  { 11, "Input/Control Gains/K_d_x", 0, EXT_IN, 1, 1, 1 },

  { 12, "Input/Control Gains/K_d_y", 0, EXT_IN, 1, 1, 1 },

  { 13, "Input/psi", 0, EXT_IN, 1, 1, 1 },

  { 14, "Input/reset", 0, EXT_IN, 1, 1, 1 },

  { 15, "Input/Observer Gains/Filter 1", 0, EXT_IN, 1, 1, 1 },

  { 16, "Input/Observer Gains/Filter 2", 1, EXT_IN, 1, 1, 1 },

  { 17, "Input/Observer Gains/Filter 3", 0, EXT_IN, 1, 1, 1 },

  { 18, "Input/VSP_on", 0, EXT_IN, 1, 1, 1 },

  { 19, "Input/Guidance gains/DP guidance/zeta_y", 0, EXT_IN, 1, 1, 1 },

  { 20, "Input/Guidance gains/DP guidance/w_d_psi", 0, EXT_IN, 1, 1, 1 },

  { 21, "Input/Guidance gains/DP guidance/w_d_x", 0, EXT_IN, 1, 1, 1 },

  { 22, "Input/Guidance gains/DP guidance/w_d_y", 0, EXT_IN, 1, 1, 1 },

  { 23, "Input/Guidance gains/DP guidance/zeta_psi", 0, EXT_IN, 1, 1, 1 },

  { 24, "Input/Guidance gains/DP guidance/zeta_x", 0, EXT_IN, 1, 1, 1 },

  { 25, "Input/Oculus_ref_on_off", 0, EXT_IN, 1, 1, 1 },

  { 26, "Input/psi_ref", 0, EXT_IN, 1, 1, 1 },

  { 27, "Input/Oculus_yaw", 0, EXT_IN, 1, 1, 1 },

  { 28, "Input/x_ref", 0, EXT_IN, 1, 1, 1 },

  { 29, "Input/y_ref", 0, EXT_IN, 1, 1, 1 },

  { 30, "Input/x", 0, EXT_IN, 1, 1, 1 },

  { 31, "Input/y", 0, EXT_IN, 1, 1, 1 },

  { 32, "Input/Gesture_off", 0, EXT_IN, 1, 1, 1 },

  { 33, "Input/Guidance gains/Gesture guidance/zeta_y", 0, EXT_IN, 1, 1, 1 },

  { 34, "Input/Guidance gains/Gesture guidance/w_d_psi", 0, EXT_IN, 1, 1, 1 },

  { 35, "Input/Guidance gains/Gesture guidance/w_d_x", 0, EXT_IN, 1, 1, 1 },

  { 36, "Input/Guidance gains/Gesture guidance/w_d_y", 0, EXT_IN, 1, 1, 1 },

  { 37, "Input/Guidance gains/Gesture guidance/zeta_psi", 0, EXT_IN, 1, 1, 1 },

  { 38, "Input/Guidance gains/Gesture guidance/zeta_x", 0, EXT_IN, 1, 1, 1 },

  { 39, "Input/Gesture based ctrl/K_u", 0, EXT_IN, 1, 1, 1 },

  { 40, "Input/Gesture based ctrl/K_v", 0, EXT_IN, 1, 1, 1 },

  { 41, "Input/Gesture based ctrl/K_r", 0, EXT_IN, 1, 1, 1 },

  { 42, "Input/Oculus_roll", 0, EXT_IN, 1, 1, 1 },

  { 43, "Input/Oculus_pitch", 0, EXT_IN, 1, 1, 1 },

  { 44, "ctrl_out/ctrl_sixaxis2force/u_BT", 0, EXT_IN, 1, 1, 1 },

  { 45, "ctrl_out/ctrl_sixaxis2force/u_VSP2", 0, EXT_IN, 1, 1, 1 },

  { 46, "ctrl_out/ctrl_sixaxis2force/omega_VSP1", 0, EXT_IN, 1, 1, 1 },

  { 47, "ctrl_out/ctrl_sixaxis2force/omega_VSP2", 0, EXT_IN, 1, 1, 1 },

  { 48, "ctrl_out/ctrl_sixaxis2force/u_VSP1", 0, EXT_IN, 1, 1, 1 },

  { 49, "ctrl_out/ctrl_sixaxis2force/alpha_VSP1", 0, EXT_IN, 1, 1, 1 },

  { 50, "ctrl_out/ctrl_sixaxis2force/alpha_VSP2", 0, EXT_IN, 1, 1, 1 },

  { 51, "ctrl_out/ctrl_DP_basic/u_BT", 0, EXT_IN, 1, 1, 1 },

  { 52, "ctrl_out/ctrl_DP_basic/u_VSP2", 0, EXT_IN, 1, 1, 1 },

  { 53, "ctrl_out/ctrl_DP_basic/omega_VSP1", 0, EXT_IN, 1, 1, 1 },

  { 54, "ctrl_out/ctrl_DP_basic/omega_VSP2", 0, EXT_IN, 1, 1, 1 },

  { 55, "ctrl_out/ctrl_DP_basic/u_VSP1", 0, EXT_IN, 1, 1, 1 },

  { 56, "ctrl_out/ctrl_DP_basic/alpha_VSP1", 0, EXT_IN, 1, 1, 1 },

  { 57, "ctrl_out/ctrl_DP_basic/alpha_VSP2", 0, EXT_IN, 1, 1, 1 },

  { 58, "ctrl_out/ctrl_sixaxis2thruster/u_BT", 0, EXT_IN, 1, 1, 1 },

  { 59, "ctrl_out/ctrl_sixaxis2thruster/u_VSP2", 0, EXT_IN, 1, 1, 1 },

  { 60, "ctrl_out/ctrl_sixaxis2thruster/omega_VSP1", 0, EXT_IN, 1, 1, 1 },

  { 61, "ctrl_out/ctrl_sixaxis2thruster/omega_VSP2", 0, EXT_IN, 1, 1, 1 },

  { 62, "ctrl_out/ctrl_sixaxis2thruster/u_VSP1", 0, EXT_IN, 1, 1, 1 },

  { 63, "ctrl_out/ctrl_sixaxis2thruster/alpha_VSP1", 0, EXT_IN, 1, 1, 1 },

  { 64, "ctrl_out/ctrl_sixaxis2thruster/alpha_VSP2", 0, EXT_IN, 1, 1, 1 },

  { 0, "ctrl_out/alpha_VSP2", 0, EXT_OUT, 1, 1, 1 },

  { 1, "ctrl_out/u_BT", 0, EXT_OUT, 1, 1, 1 },

  { 2, "ctrl_out/u_VSP1", 0, EXT_OUT, 1, 1, 1 },

  { 3, "ctrl_out/u_VSP2", 0, EXT_OUT, 1, 1, 1 },

  { 4, "ctrl_out/alpha_VSP1", 0, EXT_OUT, 1, 1, 1 },

  { 5, "ctrl_out/omega_VSP1", 0, EXT_OUT, 1, 1, 1 },

  { 6, "ctrl_out/omega_VSP2", 0, EXT_OUT, 1, 1, 1 },

  { 7, "ctrl_out/control input u exceeds bounds", 0, EXT_OUT, 1, 1, 1 },

  { 8, "ctrl_out/indicator/ctrl_DP_basic", 0, EXT_OUT, 1, 1, 1 },

  { 9, "ctrl_out/indicator/ctrl_sixaxis2force", 0, EXT_OUT, 1, 1, 1 },

  { 10, "ctrl_out/indicator/ctrl_sixaxis2thruster", 0, EXT_OUT, 1, 1, 1 },

  { 11, "ctrl_out/indicator/ctrl_student", 0, EXT_OUT, 1, 1, 1 },

  { 12, "Output/Control output/tau_N", 0, EXT_OUT, 1, 1, 1 },

  { 13, "Output/Control output/tau_X", 0, EXT_OUT, 1, 1, 1 },

  { 14, "Output/Control output/tau_Y", 0, EXT_OUT, 1, 1, 1 },

  { 15, "Output/Guidance output/x_d", 0, EXT_OUT, 1, 1, 1 },

  { 16, "Output/Guidance output/y_d", 0, EXT_OUT, 1, 1, 1 },

  { 17, "Output/Guidance output/psi_d", 0, EXT_OUT, 1, 1, 1 },

  { 18, "Output/Guidance output/r_d", 0, EXT_OUT, 1, 1, 1 },

  { 19, "Output/Guidance output/u_d", 0, EXT_OUT, 1, 1, 1 },

  { 20, "Output/Guidance output/v_d", 0, EXT_OUT, 1, 1, 1 },

  { 21, "Output/Guidance output/r_oculus", 0, EXT_OUT, 1, 1, 1 },

  { 22, "Output/Guidance output/u_oculus", 0, EXT_OUT, 1, 1, 1 },

  { 23, "Output/Guidance output/v_oculus", 0, EXT_OUT, 1, 1, 1 },

  { 24, "Output/Navigation output/r_hat", 0, EXT_OUT, 1, 1, 1 },

  { 25, "Output/Navigation output/u_hat", 0, EXT_OUT, 1, 1, 1 },

  { 26, "Output/Navigation output/v_hat", 0, EXT_OUT, 1, 1, 1 },

  { 27, "Output/Plant output/x", 0, EXT_OUT, 1, 1, 1 },

  { 28, "Output/Plant output/y", 0, EXT_OUT, 1, 1, 1 },

  { 29, "Output/Plant output/psi", 0, EXT_OUT, 1, 1, 1 },

  { -1, "", 0, 0, 0, 0, 0 }
};

/* This Task List is generated to allow access to the task specs without
 * initializing the model.
 * 0th entry is for scheduler (base rate)
 * rest for multirate model's tasks.
 */
NI_Task NI_TaskList[] DataSection(".NIVS.tasklist") =
{
  { 0, 0.01, 0 }
};

int NI_NumTasks DataSection(".NIVS.numtasks") = 1;
static char* NI_CompiledModelName DataSection(".NIVS.compiledmodelname") =
  "cse1_oculus_gesture";
static char* NI_CompiledModelVersion = "1.30";
static char* NI_CompiledModelDateTime = "Thu Apr 23 10:29:55 2015";
static char* NI_builder DataSection(".NIVS.builder") =
  "NI VeriStand 2014.0.0.82 (2014) RTW Build";
static char* NI_BuilderVersion DataSection(".NIVS.builderversion") =
  "2014.0.0.82";

/* Model Information Query fucntions for MATLAB
 */
/* dll information
 * Returns 1 for RTW DLL
 *		   2 for AutoCode DLL
 */
DLL_EXPORT long NIRT_GetBuildInfo(char* detail, long* len)
{
  // There are no console properties to set for VxWorks, because the console is simply serial output data.
  // Just do printf for VxWorks and ignore all console properties.
#if ! defined (VXWORKS) && ! defined (kNIOSLinux)

  HANDLE hStdout = GetStdHandle(STD_OUTPUT_HANDLE);
  SetConsoleTextAttribute(hStdout, FOREGROUND_INTENSITY | FOREGROUND_BLUE |
    FOREGROUND_GREEN | FOREGROUND_RED);

#endif

  printf("\n*******************************************************************************\n");
  printf("%s\nModel Name: %s\nModel Version: %s\nCompiled On: %s",
         NI_builder, NI_CompiledModelName, NI_CompiledModelVersion,
         NI_CompiledModelDateTime);
  printf("\n*******************************************************************************\n");

#if ! defined (VXWORKS) && ! defined (kNIOSLinux)

  SetConsoleTextAttribute(hStdout, FOREGROUND_BLUE | FOREGROUND_GREEN |
    FOREGROUND_RED);

#endif

  if (*len>=(long)strlen(NI_builder))
    *len = strlen(NI_builder)+1;
  strncpy(detail,NI_builder,*len);
  return 1;
}

/*
 * Distinction between Index and ID:
 * Index is a long datatype (used to set parameter/probe signals).
 * ID on the other hand is a string (tag "2-3-2-12" for MatrixX/ Full path "f14/Gain/Gain" for Matlab).
 * If Bus support is added then signal path from the block name is added to the end of the port number (Model/subsystem1:1/X/A)
 * where X/A is the path from the block
 * NOTE: ID may not be the same as Paramname or signal name.
 */

/* signal information
   NOTE: signal ID == the blockname and port that feeds it extended with /sinalname.

   The port number in Simulation Environment is 1 indexed.. but on RT is 0 indexed.
 */
DLL_EXPORT long NIRT_GetSignalSpec(long* sidx, char* ID, long* ID_len, char
  * blkname, long *bnlen,
  long *portnum, char* signame, long *snlen, long *dattype, long* dims, long
  * numdim)
{
  long sigidx = *sidx;
  int i = 0;
  char *IDblk = 0;
  int IDport = 0;
  if (sigidx<0) {
    // check if ID has been specified.
    if (ID && *ID_len>0) {
      // parse ID into blkname and port
      i = strrchr(ID, ':') - ID;

      // malformed ID
      if (i<=0)
        return NI_SigListSize;

      //ID[i] = 0;
      IDblk = ID;
      IDport = atoi(ID+i+1);

      // lookup the table for matching ID
      // Bus support
      for (i=0;i<NI_SigListSize;i++) {
        char *tempID = (char *)calloc(strlen(NI_SigList[i].blockname)+strlen
          (NI_SigList[i].signalname)+ 11, sizeof(char));

        //sprintf(tempID,"%s%s%s",NI_SigList[i].blockname,"/",NI_SigList[i].signalname);
        if (strlen(NI_SigList[i].signalname)>0)
          sprintf(tempID,"%s:%d%s%s",NI_SigList[i].blockname,NI_SigList[i].
                  portno+1,"/",NI_SigList[i].signalname);
        else
          sprintf(tempID,"%s:%d",NI_SigList[i].blockname,NI_SigList[i].portno+1);
        if (!strcmp(IDblk,tempID) && IDport==(NI_SigList[i].portno+1))
          break;
        free(tempID);
      }

      if (i<NI_SigListSize)
        sigidx = *sidx = i;
      else
        return NI_SigListSize;
    } else                             // no index or ID specified.
      return NI_SigListSize;
  }

  if (sigidx>=0 && sigidx<NI_SigListSize) {
    if (ID) {
      // no need for return string to be null terminated!
      // 11 to accomodate ':','/', port number and null character
      char *tempID = (char *)calloc(strlen(NI_SigList[sigidx].blockname)+strlen
        (NI_SigList[sigidx].signalname)+ 11, sizeof(char));
      if (strlen(NI_SigList[sigidx].signalname)>0)
        sprintf(tempID,"%s:%d%s%s",NI_SigList[sigidx].blockname,
                NI_SigList[sigidx].portno+1,"/",NI_SigList[sigidx].signalname);
      else
        sprintf(tempID,"%s:%d",NI_SigList[sigidx].blockname,NI_SigList[sigidx].
                portno+1);
      if ((long)strlen(tempID)<*ID_len)
        *ID_len = strlen(tempID);
      strncpy(ID, tempID, *ID_len);
      free(tempID);
    }

    if (blkname) {
      // no need for return string to be null terminated!
      if ((long)strlen(NI_SigList[sigidx].blockname)<*bnlen)
        *bnlen = strlen(NI_SigList[sigidx].blockname);
      strncpy(blkname, NI_SigList[sigidx].blockname, *bnlen);
    }

    if (signame) {
      // no need for return string to be null terminated!
      if ((long)strlen(NI_SigList[sigidx].signalname)<*snlen)
        *snlen = strlen(NI_SigList[sigidx].signalname);
      strncpy(signame, NI_SigList[sigidx].signalname, *snlen);
    }

    if (portnum)
      *portnum = NI_SigList[sigidx].portno;
    if (dattype)
      *dattype = NI_SigList[sigidx].datatype;
    if (dims && *numdim>=NI_SigList[sigidx].numofdims) {
      *numdim = NI_SigList[sigidx].numofdims;
      for (i=0;i < *numdim; i++)
        dims[i] = NI_SigDimList[NI_SigList[sigidx].dimListOffset +i];
    } else
      *numdim = 0;                     // set numdim to 0 to indicate that no enough memory to return the info.
    return 0;
  }

  return NI_SigListSize;
}

/*
 * Get parameter indices
 */
DLL_EXPORT long NIRT_GetParameterIndices(long* indices, long* len)
{
  long i;
  for (i=0;i<NI_ParamListSize && i<*len;i++)
    indices[i] = NI_ParamList[i].idx;
  *len = i;
  return NI_OK;
}

/*
 * parameter information
 *
 * if *pidx < 0, Lookup parameter by ID if ID != NULL.
 * if ID == NULL or no matching ID found, return number of parameters.
 *
 * plen  -> size of path
 * pnlen -> size of paramname
 * numdim -> size of dims array
 */
DLL_EXPORT long NIRT_GetParameterSpec(long* pidx, char* ID, long* ID_len, char
  * paramname, long *pnlen,
  long *dattype, long* dims, long* numdim)
{
  int i= 0;
  int paramidx = *pidx;
  if (paramidx<0) {
    // check if ID has been specified.
    if (ID && *ID_len>0) {
      // lookup the table for matching ID
      for (i=0;i<NI_ParamListSize;i++) {
        if (!strcmp(ID,NI_ParamList[i].paramname))
          break;
      }

      if (i<NI_ParamListSize)
        paramidx = *pidx = i;
      else
        return NI_ParamListSize;
    } else                             // no index or ID specified.
      return NI_ParamListSize;
  }

  if (paramidx>=0 && paramidx<NI_ParamListSize) {
    if (ID) {
      if ((long)strlen(NI_ParamList[paramidx].paramname)<*ID_len)
        *ID_len = strlen(NI_ParamList[paramidx].paramname);
      strncpy(ID, NI_ParamList[paramidx].paramname, *ID_len);
    }

    if (paramname) {
      // no need for return string to be null terminated!
      if ((long)strlen(NI_ParamList[paramidx].paramname)<*pnlen)
        *pnlen = strlen(NI_ParamList[paramidx].paramname);
      strncpy(paramname, NI_ParamList[paramidx].paramname, *pnlen);
    }

    if (dattype)
      *dattype = NI_ParamList[paramidx].datatype;
    if (!numdim)
      return 0;
    if (*numdim>=NI_ParamList[paramidx].numofdims) {
      *numdim = NI_ParamList[paramidx].numofdims;
      for (i=0;i < *numdim; i++)
        dims[i] = NI_ParamDimList[NI_ParamList[paramidx].dimListOffset +i];
    } else
      *numdim = 0;                     // set numdim to 0 to indicate that no enough memory to return the info.
    return 0;
  }

  return NI_ParamListSize;
}

/*
 * DEPRECATED.
 */
DLL_EXPORT long NIRT_GetParameterExpression(long paramidx, char* expression,
  long *exp_len)
{
  return 0;
}

/*
 * DEPRECATED.
 */
DLL_EXPORT long NIRT_GetVariableName(long varidx, char* variable_name, long
  *var_len)
{
  return 0;
}

/*
 * NIRT_GetExtIOSpec
 *
 * Inputs:
 *		index: index of the task
 * Outputs:
 *		idx:  idx of the IO.
 *		name: Name of the IO block
 *		tid: task id
 *		type: EXT_IN or EXT_OUT
 *		dimX: size of 0th dimension
 *		dimY: size of 1th dimension
 * Return value: 0 if no error. (if index == -1, return number of tasks in the model)
 */
DLL_EXPORT long NIRT_GetExtIOSpec(long index, long *idx, char* name, long* tid,
  long *type, long *dims, long* numdims)
{
  if (index==-1)
    return NI_ExtListSize;
  if (idx)
    *idx = NI_ExtList[index].idx;
  if (name) {
    int sz = strlen(name);
    strncpy(name, NI_ExtList[index].name, sz-1);
    name[sz-1]= 0;
  }

  if (tid)
    *tid = NI_ExtList[index].TID;
  if (type)
    *type = NI_ExtList[index].type;
  if (numdims && dims) {
    if (*numdims>=2) {
      *numdims= 2;
      dims[0] = NI_ExtList[index].dimX;
      dims[1] = NI_ExtList[index].dimY;
    } else
      *numdims= 0;
  }

  return 0;
}

/* Helper function to probe one	signal. baseaddr must NOT be VIRTUAL_SIG */
static long NI_ProbeOneSignal(long idx, double *value, long len, long *count,
  long vOffset, long vLength)
{
  char *ptr = (char*)((NI_SigList[idx].baseaddr == BLOCKIO_SIG) ?
                      S->ModelData.blockIO : S->ModelData.inputs) + (int)
    NI_SigList[idx].addr;
  long subindex = (vLength == -1) ? 0 : vOffset;
  long sublength = (vLength == -1) ? NI_SigList[idx].width : (vLength + vOffset);
  while ((subindex < sublength) && (*count < len))
    value[(*count)++] = NIRT_GetValueByDataType(ptr, subindex++, NI_SigList[idx]
      .datatype, NI_SigList[idx].IsComplex);
  return *count;
}

/*
 * NIRT_ProbeSignals
 *
 * Inputs:
 *		sigindices: indeces of signals
 *		numsigs: number of signals
 *		len: total length of all signals
 * Outputs:
 *		value: probed signal data
 *		len: length of data (may vary from input)
 * Return value: equal to len
 */
DLL_EXPORT long NIRT_ProbeSignals(long* sigindices, long numsigs,
  double* value, long* len)
{
  int i, j, idx;
  long count = 0;
  if (!SITexportglobals.inCriticalSection)
    SetSITErrorMessage("SignalProbe should only be called between ScheduleTasks and PostOutputs",
                       1);
  if ((*len > 1) && (numsigs > 0)) {
    value[count++] = sigindices[0];
    value[count++] = 0;
  }

  for (i = 1; (i < numsigs) && (count < *len); i++) {
    idx = sigindices[i];
    if (idx < 0)
      break;
    if (idx < NI_SigListSize) {
      if (NI_SigList[idx].baseaddr == VIRTUAL_SIG) {
        for (j = 0; j < 2; j++) {
          long vidx = NI_VirtualBlockSources[NI_SigList[idx].addr][j];
          long voff = NI_VirtualBlockOffsets[NI_SigList[idx].addr][j];
          long vlen = NI_VirtualBlockLengths[NI_SigList[idx].addr][j];
          if (vidx == -1)
            break;
          NI_ProbeOneSignal(vidx, value, *len, &count, voff, vlen);
        }
      } else
        NI_ProbeOneSignal(idx, value, *len, &count, 0, -1);
    }
  }

  *len = count;
  return count;
}

/* Copy the	statically initialized params into our copy of the param struct
   The undef allows us to access the real CSE1_Oculus_gesture_P
   In the rest of the code CSE1_Oculus_gesture_P is redefine to be the read-side
   of rtParameter.
 */
#undef CSE1_Oculus_gesture_P

int NI_InitializeParamStruct()
{
  memcpy(&rtParameter[0], &CSE1_Oculus_gesture_P, sizeof(P_CSE1_Oculus_gesture_T));
  return NI_OK;
}

/*  After the model has initialized and updated the parameters in
   rtParameter[0] (aka CSE1_Oculus_gesture_P) we make a copy to rtParameter[1] so
   that it is double buffered. We also do a memcpy to each task's copy.
 */
int NI_InitParamDoubleBuf()
{
  int idx = 1;

#ifdef MULTITASKING

  for (; idx <= NUMST - TID01EQ; idx++)
#endif

    memcpy(&rtParameter[idx], &rtParameter[0], sizeof(P_CSE1_Oculus_gesture_T));
  return NI_OK;
}

static int NI_SetParamTxStatus = NI_OK;

// This function is called by the BGL to set parameters.  When a commit is requested (index < 0),
// the code enters a critical section shared with the TCL. This ensures that the flip occurs only
// when safe, and acts as a messaging scheme for us to copy back the parameters.
DLL_EXPORT long NIRT_SetParameter(long index, long subindex, double value)
{
  char* ptr = NULL;
  if (index>=NI_ParamListSize) {
    SetSITErrorMessage("Parameter index is out of bounds.",1);
    return NI_SetParamTxStatus= NI_ERROR;
  }

  if (index < 0) {
    if (ReadSideDirtyFlag == 1) {
      memcpy(&rtParameter[1-READSIDE], &rtParameter[READSIDE], sizeof
             (P_CSE1_Oculus_gesture_T));
      ReadSideDirtyFlag = 0;
      if (WriteSideDirtyFlag == 0)
        return NI_OK;
      SetSITErrorMessage("Parameters have been set inline and from the background loop at the same time. Parameters written from the background loop since the last commit have been lost.",
                         1);
      WriteSideDirtyFlag = 0;
      return NI_ERROR;
    }

    if (NI_SetParamTxStatus==NI_ERROR) {
      // fail the transaction.
      // copy old	list of parameters to the failed TX buffer
      if (WriteSideDirtyFlag == 1)
        memcpy(&rtParameter[READSIDE], &rtParameter[1-READSIDE], sizeof
               (P_CSE1_Oculus_gesture_T));

      // reset the status.
      NI_SetParamTxStatus = NI_OK;
      WriteSideDirtyFlag = 0;
      return NI_ERROR;
    }

    /*Do nothing if no new parameters were written after last commit*/
    if (WriteSideDirtyFlag == 0)
      return NI_OK;

    // commit changes
    S->ModelData.defaultParam = (double *)&rtParameter[1-READSIDE];
    WaitForSingleObject(SITexportglobals.flipCriticalSection, INFINITE);
    READSIDE = 1 - READSIDE;
    SITexportglobals.copyTaskBitfield = 0xFFFFFFFF;
    ReleaseSemaphore(SITexportglobals.flipCriticalSection, 1, NULL);

    // Copy back the newly set parameters to the writeside.
    memcpy(&rtParameter[1-READSIDE], &rtParameter[READSIDE], sizeof
           (P_CSE1_Oculus_gesture_T));
    WriteSideDirtyFlag = 0;
    return NI_OK;
  }

  // verify that subindex is within bounds.
  if (subindex>=NI_ParamList[index].width) {
    SetSITErrorMessage("Parameter subindex is out of bounds.",1);
    return NI_SetParamTxStatus= NI_ERROR;
  }

  if (ReadSideDirtyFlag == 1) {
    memcpy(&rtParameter[1-READSIDE], &rtParameter[READSIDE], sizeof
           (P_CSE1_Oculus_gesture_T));
    ReadSideDirtyFlag = 0;
  }

  ptr = (char *)(&rtParameter[1-READSIDE]);
  ptr += (int)NI_ParamList[index].addr;
  WriteSideDirtyFlag = 1;
  return NIRT_SetValueByDataType(ptr,subindex,value,NI_ParamList[index].datatype,
    NI_ParamList[index].IsComplex);
}

DLL_EXPORT long NIRT_SetVectorParameter( unsigned long index, const double
  * paramvalues, unsigned long paramlength)
{
  unsigned int i = 0;
  long retval= NI_OK, temp_retval;
  char* ptr = NULL;
  if (index>=NI_ParamListSize) {
    SetSITErrorMessage("Parameter index is out of bounds.",1);
    return NI_SetParamTxStatus= NI_ERROR;
  }

  // verify that subindex is within bounds.
  if (paramlength!=NI_ParamList[index].width) {
    SetSITErrorMessage("Parameter length is incorrect.",1);
    return NI_SetParamTxStatus= NI_ERROR;
  }

  if (ReadSideDirtyFlag == 1) {
    memcpy(&rtParameter[1-READSIDE], &rtParameter[READSIDE], sizeof
           (P_CSE1_Oculus_gesture_T));
    ReadSideDirtyFlag = 0;
  }

  ptr = (char *)(&rtParameter[1-READSIDE]);
  ptr += (int)NI_ParamList[index].addr;
  while (i<paramlength) {
    if (temp_retval = NIRT_SetValueByDataType(ptr, i, paramvalues[i],
         NI_ParamList[index].datatype, NI_ParamList[index].IsComplex))//assignment intended in if condition
      retval= temp_retval;
    i++;
  }

  WriteSideDirtyFlag = 1;
  return retval;
}

DLL_EXPORT long NIRT_SetScalarParameterInline( unsigned long index, unsigned
  long subindex, double paramvalue)
{
  char* ptr = NULL;
  if (index>=NI_ParamListSize) {
    SetSITErrorMessage("Parameter index is out of bounds.",1);
    return NI_SetParamTxStatus= NI_ERROR;
  }

  // verify that subindex is within bounds.
  if (subindex>=NI_ParamList[index].width) {
    SetSITErrorMessage("Parameter subindex is out of bounds.",1);
    return NI_SetParamTxStatus= NI_ERROR;
  }

  ptr = (char *)(&rtParameter[READSIDE]);
  ptr += (int)NI_ParamList[index].addr;
  ReadSideDirtyFlag = 1;
  return NIRT_SetValueByDataType(ptr,subindex,paramvalue,NI_ParamList[index].
    datatype,NI_ParamList[index].IsComplex);
}

DLL_EXPORT long NIRT_GetParameter(long index, long subindex, double *value)
{
  char* ptr = NULL;
  if (index>=NI_ParamListSize || index < 0)
    return NI_ERROR;

  // verify that subindex is within bounds.
  if (subindex>=NI_ParamList[index].width)
    return NI_ERROR;
  ptr = (char *)(&rtParameter[READSIDE]);
  ptr += (int)NI_ParamList[index].addr;
  *value = NIRT_GetValueByDataType(ptr,subindex,NI_ParamList[index].datatype,
    NI_ParamList[index].IsComplex);
  return NI_OK;
}

DLL_EXPORT long NIRT_GetVectorParameter(unsigned long index, double* paramvalues,
  unsigned long paramlength)
{
  char* ptr = NULL;
  unsigned int i = 0;
  if (index>=NI_ParamListSize || index < 0)
    return NI_ERROR;

  // verify that subindex is within bounds.
  if (paramlength!=NI_ParamList[index].width)
    return NI_ERROR;
  ptr = (char *)(&rtParameter[READSIDE]);
  ptr += (int)NI_ParamList[index].addr;
  while (i<paramlength) {
    paramvalues[i] = NIRT_GetValueByDataType(ptr, i, NI_ParamList[index].
      datatype, NI_ParamList[index].IsComplex);
    i++;
  }

  return NI_OK;
}

DLL_EXPORT long NIRT_GetSimState(long* numContStates, char* contStatesNames,
  double* contStates, long* numDiscStates, char* discStatesNames, double
  * discStates, long* numClockTicks, char* clockTicksNames, long* clockTicks)
{
  long count, idx;
  if (numContStates && numDiscStates && numClockTicks) {
    if (*numContStates < 0 || *numDiscStates < 0 || *numClockTicks < 0) {
      *numContStates = 24;
      *numDiscStates = 2125;
      *numClockTicks = NUMST - TID01EQ;
      return NI_OK;
    }
  }

  if (contStates && contStatesNames) {
    idx = 0;
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator_CSTATE[0], 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator_CSTATE[0], 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator_CSTATE[0], 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator1_CSTATE[0], 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator1_CSTATE[0], 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator1_CSTATE[0], 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[0], 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE_j");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[0], 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE_j");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[0], 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator1_CSTATE_j");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator3_CSTATE[0], 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator3_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator3_CSTATE[0], 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator3_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator3_CSTATE[0], 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator3_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator_CSTATE_i[0], 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE_i");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator_CSTATE_i[0], 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE_i");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator_CSTATE_i[0], 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator_CSTATE_i");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator2_CSTATE[0], 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator2_CSTATE[0], 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator2_CSTATE[0], 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[0], 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE_b");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[0], 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE_b");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[0], 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator2_CSTATE_b");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[0], 0, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator3_CSTATE_f");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[0], 1, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator3_CSTATE_f");
    contStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[0], 2, 0, 0);
    strcpy(contStatesNames + (idx++ * 100), "Integrator3_CSTATE_f");
  }

  if (discStates && discStatesNames) {
    idx = 0;
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Delay_DSTATE, 0, 17, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Delay_DSTATE");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Delay_DSTATE, 1, 17, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Delay_DSTATE");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Delay_DSTATE, 2, 17, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Delay_DSTATE");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Triangle_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Triangle_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Circle_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Circle_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Cross_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Cross_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Square_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Square_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Memory_PreviousInput, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Memory_PreviousInput");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.K_p_x_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.K_p_x_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.K_p_y_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.K_p_y_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.K_p_psi_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.K_p_psi_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.K_i_psi_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.K_i_psi_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.K_i_x_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.K_i_x_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.K_i_y_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.K_i_y_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.K_d_psi_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.K_d_psi_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.K_d_x_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.K_d_x_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.K_d_y_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.K_d_y_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.psi_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.psi_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.reset_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.reset_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Filter1_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Filter1_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Filter2_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Filter2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Filter3_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Filter3_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.VSP_on_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.VSP_on_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.zeta_y_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.zeta_y_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.w_d_psi_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.w_d_psi_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.w_d_x_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.w_d_x_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.w_d_y_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.w_d_y_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.zeta_psi_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.zeta_psi_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.zeta_x_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.zeta_x_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Oculus_ref_on_off_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Oculus_ref_on_off_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.psi_ref_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.psi_ref_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Oculus_yaw_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Oculus_yaw_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.x_ref_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.x_ref_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.y_ref_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.y_ref_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.x_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.x_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.y_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.y_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Gesture_off_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Gesture_off_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.zeta_y_DWORK1_a, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.zeta_y_DWORK1_a");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.w_d_psi_DWORK1_h, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.w_d_psi_DWORK1_h");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.w_d_x_DWORK1_p, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.w_d_x_DWORK1_p");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.w_d_y_DWORK1_g, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.w_d_y_DWORK1_g");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.zeta_psi_DWORK1_b, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.zeta_psi_DWORK1_b");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.zeta_x_DWORK1_p, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.zeta_x_DWORK1_p");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.K_u_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.K_u_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.K_v_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.K_v_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.K_r_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.K_r_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Oculus_roll_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Oculus_roll_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Oculus_pitch_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Oculus_pitch_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Memory3_PreviousInput, 0, 17, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Memory3_PreviousInput");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Memory3_PreviousInput, 1, 17, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Memory3_PreviousInput");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Memory3_PreviousInput, 2, 17, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Memory3_PreviousInput");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_BT_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_BT_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_BT_DWORK1_j, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_BT_DWORK1_j");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1_b, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1_b");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1_b, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1_b");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1_k, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1_k");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1_e, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1_e");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1_b, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1_b");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1_i, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1_i");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_BT_DWORK1_l, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_BT_DWORK1_l");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1_m, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1_m");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1_h, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1_h");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1_o, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1_o");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1_h, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1_h");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1_p, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1_p");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1_n, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1_n");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1_l, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1_l");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_BT_DWORK1_f, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_BT_DWORK1_f");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1_hn, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1_hn");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1_o, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1_o");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1_f, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1_f");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1_l, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1_l");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1_d, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1_d");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.controlinputuexceedsbounds_DWOR, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.controlinputuexceedsbounds_DWOR");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.ctrl_DP_basic_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.ctrl_DP_basic_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.ctrl_sixaxis2force_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.ctrl_sixaxis2force_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.ctrl_sixaxis2thruster_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.ctrl_sixaxis2thruster_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.ctrl_student_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.ctrl_student_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.tau_N_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.tau_N_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.tau_X_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.tau_X_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.tau_Y_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.tau_Y_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.x_d_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.x_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.y_d_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.y_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.psi_d_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.psi_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.r_d_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.r_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.u_d_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.u_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.v_d_DWORK1,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.v_d_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.r_oculus_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.r_oculus_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_oculus_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_oculus_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.v_oculus_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.v_oculus_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.r_hat_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.r_hat_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.u_hat_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.u_hat_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.v_hat_DWORK1, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.v_hat_DWORK1");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.x_DWORK1_m,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.x_DWORK1_m");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.y_DWORK1_c,
      0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.y_DWORK1_c");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.psi_DWORK1_o, 0, 0, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.psi_DWORK1_o");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.ToFile_PWORK, 0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.ToFile_PWORK");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.tau_PWORK,
      0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.tau_PWORK");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.eta3_PWORK,
      0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.eta3_PWORK");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.eta1_PWORK,
      0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.eta1_PWORK");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta3_PWORK_p, 0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta3_PWORK_p");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.eta5_PWORK,
      0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.eta5_PWORK");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.eta4_PWORK,
      0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.eta4_PWORK");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.eta2_PWORK,
      0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.eta2_PWORK");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.nu1_PWORK,
      0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.nu1_PWORK");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.nu_dot1_PWORK, 0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.nu_dot1_PWORK");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.nu_hat_PWORK, 0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.nu_hat_PWORK");
    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.eta_PWORK,
      0, 11, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.eta_PWORK");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.NIVeriStandSignalProbe_DWORK2, 0, 6, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.NIVeriStandSignalProbe_DWORK2");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Integrator_IWORK.IcNeedsLoading, 0, 10, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Integrator_IWORK.IcNeedsLoading");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.Integrator1_IWORK.IcNeedsLoading, 0, 10, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.Integrator1_IWORK.IcNeedsLoading");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.ToFile_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.ToFile_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.ToFile_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.ToFile_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.tau_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.tau_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.tau_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.tau_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta3_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta3_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta3_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta3_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta1_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta1_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta1_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta1_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta3_IWORK_a.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta3_IWORK_a.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta3_IWORK_a.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta3_IWORK_a.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta5_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta5_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta5_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta5_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta4_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta4_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta4_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta4_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta2_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta2_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta2_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta2_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.nu1_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.nu1_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.nu1_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.nu1_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.nu_hat_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.nu_hat_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.nu_hat_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.nu_hat_IWORK.Decimation");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta_IWORK.Count, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta_IWORK.Count");
    discStates[idx] = NIRT_GetValueByDataType
      (&CSE1_Oculus_gesture_DW.eta_IWORK.Decimation, 0, 24, 0);
    strcpy(discStatesNames + (idx++ * 100),
           "&CSE1_Oculus_gesture_DW.eta_IWORK.Decimation");
    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Triangle_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Triangle_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Circle_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Circle_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Cross_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Cross_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Square_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Square_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_p_x_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_p_x_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_p_y_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_p_y_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_p_psi_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_p_psi_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_i_psi_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_i_psi_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_i_x_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_i_x_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_i_y_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_i_y_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_d_psi_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_d_psi_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_d_x_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_d_x_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_d_y_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_d_y_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.psi_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.psi_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.reset_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.reset_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Filter1_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Filter1_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Filter2_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Filter2_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Filter3_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Filter3_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.VSP_on_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.VSP_on_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.zeta_y_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.zeta_y_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.w_d_psi_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.w_d_psi_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.w_d_x_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.w_d_x_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.w_d_y_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.w_d_y_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.zeta_psi_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.zeta_psi_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.zeta_x_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.zeta_x_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Oculus_ref_on_off_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Oculus_ref_on_off_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.psi_ref_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.psi_ref_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Oculus_yaw_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Oculus_yaw_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.x_ref_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.x_ref_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.y_ref_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.y_ref_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.x_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.x_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.y_DWORK2,
        count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.y_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Gesture_off_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Gesture_off_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.zeta_y_DWORK2_c, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.zeta_y_DWORK2_c");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.w_d_psi_DWORK2_h, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.w_d_psi_DWORK2_h");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.w_d_x_DWORK2_b, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.w_d_x_DWORK2_b");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.w_d_y_DWORK2_b, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.w_d_y_DWORK2_b");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.zeta_psi_DWORK2_e, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.zeta_psi_DWORK2_e");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.zeta_x_DWORK2_g, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.zeta_x_DWORK2_g");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_u_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_u_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_v_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_v_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.K_r_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.K_r_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Oculus_roll_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Oculus_roll_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.Oculus_pitch_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.Oculus_pitch_DWORK2");
    }

    discStates[idx] = NIRT_GetValueByDataType(&CSE1_Oculus_gesture_DW.icLoad, 0,
      3, 0);
    strcpy(discStatesNames + (idx++ * 100), "&CSE1_Oculus_gesture_DW.icLoad");
    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_BT_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_BT_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_BT_DWORK2_k, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_BT_DWORK2_k");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2_c, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2_c");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2_c, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2_c");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2_p, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2_p");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2_k, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2_k");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2_a, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2_a");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2_n, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2_n");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_BT_DWORK2_b, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_BT_DWORK2_b");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2_o, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2_o");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2_a, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2_a");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2_k, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2_k");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2_f, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2_f");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2_b, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2_b");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2_c, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2_c");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2_n5, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2_n5");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_BT_DWORK2_l, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_BT_DWORK2_l");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2_h, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2_h");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2_cb, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2_cb");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2_f, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2_f");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2_f, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2_f");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2_d, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2_d");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.controlinputuexceedsbounds_DW_f, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.controlinputuexceedsbounds_DW_f");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.ctrl_DP_basic_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.ctrl_DP_basic_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.ctrl_sixaxis2force_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.ctrl_sixaxis2force_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.ctrl_sixaxis2thruster_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.ctrl_sixaxis2thruster_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.ctrl_student_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.ctrl_student_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.tau_N_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.tau_N_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.tau_X_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.tau_X_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.tau_Y_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.tau_Y_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.x_d_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.x_d_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.y_d_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.y_d_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.psi_d_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.psi_d_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.r_d_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.r_d_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_d_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_d_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.v_d_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.v_d_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.r_oculus_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.r_oculus_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_oculus_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_oculus_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.v_oculus_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.v_oculus_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.r_hat_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.r_hat_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.u_hat_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.u_hat_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.v_hat_DWORK2, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.v_hat_DWORK2");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.x_DWORK2_f, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.x_DWORK2_f");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.y_DWORK2_i, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.y_DWORK2_i");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.psi_DWORK2_o, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.psi_DWORK2_o");
    }

    for (count = 0; count < 20; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.NIVeriStandSignalProbe_DWORK1, count, 21, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.NIVeriStandSignalProbe_DWORK1");
    }

    for (count = 0; count < 63; count++) {
      discStates[idx] = NIRT_GetValueByDataType
        (&CSE1_Oculus_gesture_DW.NIVeriStandSignalProbe_DWORK3, count, 23, 0);
      strcpy(discStatesNames + (idx++ * 100),
             "&CSE1_Oculus_gesture_DW.NIVeriStandSignalProbe_DWORK3");
    }
  }

  if (clockTicks && clockTicksNames) {
    clockTicks[0] = S->Timing.clockTick0;
    strcpy(clockTicksNames, "clockTick0");
  }

  return NI_OK;
}

DLL_EXPORT long NIRT_SetSimState(double* contStates, double* discStates, long
  * clockTicks)
{
  long count, idx;
  if (contStates) {
    idx = 0;
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator_CSTATE[0], 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator_CSTATE[0], 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator_CSTATE[0], 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator1_CSTATE[0], 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator1_CSTATE[0], 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator1_CSTATE[0], 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[0], 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[0], 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator1_CSTATE_j[0], 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator3_CSTATE[0], 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator3_CSTATE[0], 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator3_CSTATE[0], 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator_CSTATE_i[0], 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator_CSTATE_i[0], 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator_CSTATE_i[0], 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator2_CSTATE[0], 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator2_CSTATE[0], 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator2_CSTATE[0], 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[0], 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[0], 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator2_CSTATE_b[0], 2,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[0], 0,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[0], 1,
      contStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_X.Integrator3_CSTATE_f[0], 2,
      contStates[idx++], 0, 0);
  }

  if (discStates) {
    idx = 0;
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Delay_DSTATE, 0,
      discStates[idx++], 17, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Delay_DSTATE, 1,
      discStates[idx++], 17, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Delay_DSTATE, 2,
      discStates[idx++], 17, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Triangle_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Circle_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Cross_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Square_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Memory_PreviousInput, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_p_x_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_p_y_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_p_psi_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_i_psi_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_i_x_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_i_y_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_d_psi_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_d_x_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_d_y_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.psi_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.reset_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Filter1_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Filter2_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Filter3_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.VSP_on_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_y_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_psi_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_x_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_y_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_psi_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_x_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Oculus_ref_on_off_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.psi_ref_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Oculus_yaw_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.x_ref_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.y_ref_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.x_DWORK1, 0, discStates[idx
      ++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.y_DWORK1, 0, discStates[idx
      ++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Gesture_off_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_y_DWORK1_a, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_psi_DWORK1_h, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_x_DWORK1_p, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_y_DWORK1_g, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_psi_DWORK1_b, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_x_DWORK1_p, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_u_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_v_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_r_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Oculus_roll_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Oculus_pitch_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Memory3_PreviousInput, 0,
      discStates[idx++], 17, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Memory3_PreviousInput, 1,
      discStates[idx++], 17, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Memory3_PreviousInput, 2,
      discStates[idx++], 17, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_BT_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_BT_DWORK1_j, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1_b, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1_b, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1_k, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1_e, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1_b, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1_i, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_BT_DWORK1_l, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1_m, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1_h, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1_o, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1_h, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1_p, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1_n, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK1_l, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_BT_DWORK1_f, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP1_DWORK1_hn, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP2_DWORK1_o, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK1_f, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK1_l, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK1_d, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType
      (&CSE1_Oculus_gesture_DW.controlinputuexceedsbounds_DWOR, 0,
       discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ctrl_DP_basic_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ctrl_sixaxis2force_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ctrl_sixaxis2thruster_DWORK1,
      0, discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ctrl_student_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.tau_N_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.tau_X_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.tau_Y_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.x_d_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.y_d_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.psi_d_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.r_d_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_d_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.v_d_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.r_oculus_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_oculus_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.v_oculus_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.r_hat_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_hat_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.v_hat_DWORK1, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.x_DWORK1_m, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.y_DWORK1_c, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.psi_DWORK1_o, 0,
      discStates[idx++], 0, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ToFile_PWORK, 0,
      discStates[idx++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.tau_PWORK, 0, discStates[idx
      ++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta3_PWORK, 0,
      discStates[idx++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta1_PWORK, 0,
      discStates[idx++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta3_PWORK_p, 0,
      discStates[idx++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta5_PWORK, 0,
      discStates[idx++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta4_PWORK, 0,
      discStates[idx++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta2_PWORK, 0,
      discStates[idx++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.nu1_PWORK, 0, discStates[idx
      ++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.nu_dot1_PWORK, 0,
      discStates[idx++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.nu_hat_PWORK, 0,
      discStates[idx++], 11, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta_PWORK, 0, discStates[idx
      ++], 11, 0);
    NIRT_SetValueByDataType
      (&CSE1_Oculus_gesture_DW.NIVeriStandSignalProbe_DWORK2, 0, discStates[idx
       ++], 6, 0);
    NIRT_SetValueByDataType
      (&CSE1_Oculus_gesture_DW.Integrator_IWORK.IcNeedsLoading, 0,
       discStates[idx++], 10, 0);
    NIRT_SetValueByDataType
      (&CSE1_Oculus_gesture_DW.Integrator1_IWORK.IcNeedsLoading, 0,
       discStates[idx++], 10, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ToFile_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ToFile_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.tau_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.tau_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta3_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta3_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta1_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta1_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta3_IWORK_a.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta3_IWORK_a.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta5_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta5_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta4_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta4_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta2_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta2_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.nu1_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.nu1_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.nu_dot1_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.nu_hat_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.nu_hat_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta_IWORK.Count, 0,
      discStates[idx++], 24, 0);
    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.eta_IWORK.Decimation, 0,
      discStates[idx++], 24, 0);
    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Triangle_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Circle_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Cross_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Square_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_p_x_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_p_y_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_p_psi_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_i_psi_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_i_x_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_i_y_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_d_psi_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_d_x_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_d_y_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.psi_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.reset_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Filter1_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Filter2_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Filter3_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.VSP_on_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_y_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_psi_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_x_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_y_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_psi_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_x_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Oculus_ref_on_off_DWORK2,
        count, discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.psi_ref_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Oculus_yaw_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.x_ref_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.y_ref_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.x_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.y_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Gesture_off_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_y_DWORK2_c, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_psi_DWORK2_h, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_x_DWORK2_b, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.w_d_y_DWORK2_b, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_psi_DWORK2_e, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.zeta_x_DWORK2_g, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_u_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_v_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.K_r_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Oculus_roll_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.Oculus_pitch_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.icLoad, 0, discStates[idx++],
      3, 0);
    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_BT_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_BT_DWORK2_k, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2_c, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2_c, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2_p, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2_k, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2_a, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2_n, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_BT_DWORK2_b, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2_o, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2_a, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2_k, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2_f, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2_b, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2_c, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP2_DWORK2_n5,
        count, discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_BT_DWORK2_l, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP1_DWORK2_h, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_VSP2_DWORK2_cb, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.alpha_VSP1_DWORK2_f, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP1_DWORK2_f, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.omega_VSP2_DWORK2_d, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType
        (&CSE1_Oculus_gesture_DW.controlinputuexceedsbounds_DW_f, count,
         discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ctrl_DP_basic_DWORK2,
        count, discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ctrl_sixaxis2force_DWORK2,
        count, discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType
        (&CSE1_Oculus_gesture_DW.ctrl_sixaxis2thruster_DWORK2, count,
         discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.ctrl_student_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.tau_N_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.tau_X_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.tau_Y_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.x_d_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.y_d_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.psi_d_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.r_d_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_d_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.v_d_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.r_oculus_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_oculus_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.v_oculus_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.r_hat_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.u_hat_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.v_hat_DWORK2, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.x_DWORK2_f, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.y_DWORK2_i, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType(&CSE1_Oculus_gesture_DW.psi_DWORK2_o, count,
        discStates[idx++], 21, 0);
    }

    for (count = 0; count < 20; count++) {
      NIRT_SetValueByDataType
        (&CSE1_Oculus_gesture_DW.NIVeriStandSignalProbe_DWORK1, count,
         discStates[idx++], 21, 0);
    }

    for (count = 0; count < 63; count++) {
      NIRT_SetValueByDataType
        (&CSE1_Oculus_gesture_DW.NIVeriStandSignalProbe_DWORK3, count,
         discStates[idx++], 23, 0);
    }
  }

  if (clockTicks) {
    S->Timing.clockTick0 = clockTicks[0];
    S->Timing.clockTick1 = clockTicks[0];
  }

  return NI_OK;
}

#endif                                 // of NI_ROOTMODEL_CSE1_Oculus_gesture
